'use strict';

var index = require('./index-D5bL1DOi.js');
var parts = require('./parts-9jMf1erK.js');

exports.BadgeVariant = void 0;
(function (BadgeVariant) {
    BadgeVariant["PRIMARY"] = "primary";
    BadgeVariant["SECONDARY"] = "secondary";
    BadgeVariant["SUCCESS"] = "success";
    BadgeVariant["DANGER"] = "danger";
    BadgeVariant["WARNING"] = "warning";
    BadgeVariant["INFO"] = "info";
    BadgeVariant["LIGHT"] = "light";
    BadgeVariant["DARK"] = "dark";
})(exports.BadgeVariant || (exports.BadgeVariant = {}));
const Badge = (props) => {
    const { variant, text, title } = props;
    const cssClasses = {
        default: 'badge',
        primary: 'badge bg-primary',
        secondary: 'badge bg-secondary',
        success: 'badge bg-success',
        danger: 'badge bg-danger',
        warning: 'badge bg-warning',
        info: 'badge bg-info',
        light: 'badge bg-light',
        dark: 'badge bg-dark',
    };
    const badgeVariant = {
        default: parts.badge,
        primary: parts.badgePrimary,
        secondary: parts.badgeSecondary,
        success: parts.badgeSuccess,
        danger: parts.badgeDanger,
        warning: parts.badgeWarning,
        info: parts.badgeInfo,
        light: parts.badgeLight,
        dark: parts.badgeDark,
    };
    return (index.h("span", { class: cssClasses[variant] || cssClasses.default, part: badgeVariant[variant] || badgeVariant.default, title: title }, text));
};

exports.Badge = Badge;
