'use strict';

var index = require('./index-D5bL1DOi.js');
require('./config-state-Dz9bnWHg.js');
require('./dinero-J-SRFKIR.js');
require('./ComponentError-CEv9ltwy.js');
var Refund = require('./Refund-08OcZkXX.js');
require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./Dispute-CruQTF6_.js');
var businessFormOptions = require('./business-form-options-CMII7nIK.js');
require('./event-types-DNOUef41.js');
var utils = require('./utils-DAyWinG2.js');
var utils$1 = require('./utils-DqlrBltg.js');
var parts = require('./parts-9jMf1erK.js');
var skeleton = require('./skeleton-CbZBGO47.js');
require('./event-types-YOY5TKUN.js');
var formControlErrorText = require('./form-control-error-text-CVPYL0lE.js');
require('./index-BCtVWU61.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./helpers-B5OCqlIM.js');
require('./state-options-CIT9xdTz.js');

const BankAccountDocumentFormInputs = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
    }
    render() {
        return (index.h("div", { key: '23f5fa6b191b3feea7677a85a421002642a86f50', class: "row gy-3" }, index.h("div", { key: 'da9d9698f15aeb4bb05baef8fb63c630fcff8a82', class: "col-12" }, index.h("form-control-file", { key: 'b84a8ec1753210f74989c04b5520f0e94c5a083d', name: "voided_check", label: "Voided Check", documentType: Refund.EntityDocumentType.voidedCheck, inputHandler: this.inputHandler, onFileSelected: this.storeFiles, errorText: this.errors["voided_check"], multiple: true })), index.h("div", { key: '06d442df900406f122970bde6b2b293f2c9080ee', class: "col-12" }, index.h("form-control-file", { key: 'b3dc1d48900c5932c4d59f8b31a323193f0e86b4', name: "bank_statement", label: "Bank Statement", documentType: Refund.EntityDocumentType.bankStatement, inputHandler: this.inputHandler, onFileSelected: this.storeFiles, errorText: this.errors["bank_statement"], multiple: true }))));
    }
};

const BankAccountFormInputs = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
    }
    render() {
        return (index.h("div", { key: 'da4dc9523bca84cdd02f7e5d47e513c426ed90fd', class: "row gy-3" }, index.h("div", { key: 'b625a293dec704cbbb132469fdbc8c5d99a660e1', class: "col-12" }, index.h("form-control-text", { key: 'b41460ddc605f73faf71233ccbbef7e34e690e5a', name: "bank_name", label: "Bank Name", defaultValue: this.defaultValue.bank_name, errorText: this.errors.bank_name, inputHandler: this.inputHandler, disabled: this.formDisabled })), index.h("div", { key: 'e5560bcdba399baa2e54441436ef5c67936e9fef', class: "col-12" }, index.h("form-control-text", { key: '18cd16931899f724fd92cb89f1b8d4cd41c5354c', name: "nickname", label: "Nickname", defaultValue: this.defaultValue.nickname, errorText: this.errors.nickname, inputHandler: this.inputHandler, disabled: this.formDisabled })), index.h("div", { key: '3bb589db98e5d65022576b602bda41f36e3a90d5', class: "col-12" }, index.h("form-control-text", { key: 'c870513b8895add114d5ec588561fa6f33a63514', name: "account_owner_name", label: "Account Owner Name", defaultValue: this.defaultValue.account_owner_name, errorText: this.errors.account_owner_name, inputHandler: this.inputHandler, disabled: this.formDisabled })), index.h("div", { key: '1783e7b4af2b012338fe2e1b4f1faa9b5e086bcd', class: "col-12" }, index.h("form-control-select", { key: '6a9af0f6edeae133dce04b7f829abb802db4ac83', name: "account_type", label: "Account Type", options: businessFormOptions.bankAccountTypeOptions, defaultValue: this.defaultValue.account_type, errorText: this.errors.account_type, inputHandler: this.inputHandler, disabled: this.formDisabled })), index.h("div", { key: '3c3ffced96f67320b4c580be6f28dd8ef5d2c109', class: "col-12" }, index.h("form-control-text", { key: 'e85df115a9de08ad9abb3237f7bf6c6d23c84150', name: "account_number", label: "Account Number", defaultValue: this.defaultValue.account_number, maxLength: 17, errorText: this.errors.account_number, inputHandler: this.inputHandler, keyDownHandler: utils.numberOnlyHandler, disabled: this.formDisabled, helpText: "Please copy the account number as shown on your statement/check. Do not include spaces or dashes." })), index.h("div", { key: '5a25cb25160aff24d1f62df2115dbd248709141e', class: "col-12" }, index.h("form-control-text", { key: 'dfdf7dce470efb8eea65aa6daf562d190963bace', name: "routing_number", label: "Routing Number", defaultValue: this.defaultValue.routing_number, maxLength: 9, errorText: this.errors.routing_number, inputHandler: this.inputHandler, keyDownHandler: utils.numberOnlyHandler, disabled: this.formDisabled, helpText: "A valid routing number is nine digits. Please include any leading or trailing zeroes." }))));
    }
};

const BusinessDocumentsOnFile = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.documents = [];
        this.isLoading = false;
    }
    render() {
        if (this.isLoading) {
            return index.h(skeleton.Skeleton, { height: "50px" });
        }
        if (!this.documents.length) {
            return null;
        }
        return (index.h(index.Host, null, index.h("div", { class: "card", part: parts.card }, index.h("div", { class: "card-body" }, index.h("h5", { class: "card-title", part: parts.heading2 }, "Documents Already on File"), index.h("div", { class: "table-responsive" }, index.h("table", { class: "table table-sm table-borderless", part: parts.table }, index.h("thead", null, index.h("tr", null, index.h("th", { style: { width: "25%" }, part: parts.tableHeadCell, scope: "col" }, "File Name"), index.h("th", { style: { width: "25%" }, part: parts.tableHeadCell, scope: "col" }, "File Type"), index.h("th", { style: { width: "25%" }, part: parts.tableHeadCell, scope: "col" }, "Document Type"), index.h("th", { style: { width: "25%" }, part: parts.tableHeadCell, scope: "col" }, "Date Uploaded"))), index.h("tbody", null, this.documents.sort((a, b) => a.document_type.localeCompare(b.document_type))
            .map((document, index$1) => {
            return (index.h("tr", { class: index$1 === 0 ? "border-bottom border-top" : "border-bottom" }, index.h("td", { part: parts.tableCell }, document.file_name), index.h("td", { part: parts.tableCell }, document.file_type), index.h("td", { part: parts.tableCell }, utils$1.snakeCaseToHumanReadable(document.document_type)), index.h("td", { part: parts.tableCell }, `${utils$1.formatDate(document.created_at)} - ${utils$1.formatTimeSeconds(document.created_at)}`)));
        })))))), index.h("hr", null)));
    }
};

const FileInput = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.formControlInput = index.createEvent(this, "formControlInput");
        this.formControlBlur = index.createEvent(this, "formControlBlur");
        this.fileSelected = index.createEvent(this, "fileSelected");
        this.isFocused = false;
        this.handleFormControlInput = (event) => {
            const target = event.target;
            const name = target.getAttribute('name');
            this.inputHandler(name, target.value);
            this.formControlInput.emit({ name, value: target.value });
        };
        this.changeHandler = () => {
            const inputFileList = this.fileInput.files;
            if (inputFileList) {
                this.fileSelected.emit({
                    fileList: inputFileList,
                    document_type: this.documentType
                });
            }
        };
    }
    componentDidLoad() {
        this.fileInput = this.el.querySelector('input');
    }
    get part() {
        let part = parts.input;
        if (this.errorText) {
            part = parts.inputInvalid;
        }
        if (this.disabled) {
            part = parts.inputDisabled;
        }
        if (this.isFocused) {
            part = parts.inputFocused;
        }
        return part;
    }
    render() {
        return (index.h(index.Host, { key: 'bbf3a7e4cd4dcd5cc0ccefe4ad405dccbe7e3e78' }, index.h("div", { key: '4cb2c56d8015d1bb78ab08c5499d00ddeb8dd738', class: "form-group d-flex flex-column" }, index.h("div", { key: 'f72a96162d320c2ec86b0668a0d174065cca15e1', class: "d-flex align-items-start gap-2" }, index.h("label", { key: 'b99571312c582e453b867888db7499ad5dad69c1', part: parts.label, class: "form-label", htmlFor: this.name }, this.label), index.h("form-control-tooltip", { key: '014c69076270156f8301ba329bbc779046282e69', helpText: this.helpText })), index.h("input", { key: '08a71546d4f2c2fc3df64d4f87ac1ffe2dcef6d4', ref: (el) => this.fileInput = el, type: "file", name: this.name, part: this.part, class: this.errorText ? "form-control is-invalid" : "form-control", multiple: this.multiple, disabled: this.disabled, onChange: this.changeHandler, onInput: this.handleFormControlInput, onFocus: () => this.isFocused = true, onBlur: () => {
                this.isFocused = false;
                this.formControlBlur.emit();
            } }), index.h(formControlErrorText.FormControlErrorText, { key: '67496c44c3db670d269394b2667c13776d9ae166', errorText: this.errorText, name: this.name }))));
    }
    get el() { return index.getElement(this); }
};

exports.bank_account_document_form_inputs = BankAccountDocumentFormInputs;
exports.bank_account_form_inputs = BankAccountFormInputs;
exports.business_documents_on_file = BusinessDocumentsOnFile;
exports.form_control_file = FileInput;
