'use strict';

var index = require('./index-D5bL1DOi.js');
var skeleton = require('./skeleton-CbZBGO47.js');
var configState = require('./config-state-Dz9bnWHg.js');
require('./parts-9jMf1erK.js');
require('./index-BCtVWU61.js');

const BankAccountFormSkeleton = (props) => {
    const { isReady } = props;
    if (isReady) {
        return null;
    }
    return (index.h("div", { class: "container-fluid p-0" },
        index.h("div", { class: "row mb-3" },
            index.h("div", { class: "col-12 align-content-end" },
                index.h(skeleton.Skeleton, { height: "18px", width: "120px" }),
                index.h(skeleton.Skeleton, { height: "36px" }))),
        index.h("div", { class: "row" },
            index.h("div", { class: "col-12 align-content-end" },
                index.h(skeleton.Skeleton, { height: "18px", width: "110px" }),
                index.h(skeleton.Skeleton, { height: "36px" })))));
};

const BankAccountForm = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.isReady = false;
    }
    async componentWillLoad() {
        await configState.waitForConfig();
        this.iframeOrigin = configState.configState.iframeOrigin;
    }
    componentDidRender() {
        const elements = [
            this.accountNumberIframeElement,
            this.routingNumberIframeElement,
        ];
        Promise.all(elements.map((element) => {
            return new Promise((resolve) => {
                element.addEventListener('iframeLoaded', () => { resolve(); });
            });
        })).then(() => {
            this.isReady = true;
        });
    }
    async validate() {
        const accountNumberIsValid = await this.accountNumberIframeElement.validate();
        const routingNumberIsValid = await this.routingNumberIframeElement.validate();
        return accountNumberIsValid && routingNumberIsValid;
    }
    async tokenize(clientId, paymentMethodMetadata, account) {
        return this.accountNumberIframeElement.tokenize(clientId, paymentMethodMetadata, account);
    }
    render() {
        return (index.h(index.Host, { key: 'f7fccd7526b31937a7adb5c1eef5d7db21116b8b' }, index.h(BankAccountFormSkeleton, { key: '316e16b7bc09d15334c863323b338d61bf074ad4', isReady: this.isReady }), index.h("div", { key: '6676e15da0bc4f4dccbbbe035af3de9abd449ebf', class: "container-fluid p-0", style: {
                opacity: this.isReady ? '1' : '0',
                height: this.isReady ? 'auto' : '0',
            } }, index.h("div", { key: 'd689e889153f3efd693ff2acfe8a0bf2da84b786', class: "row mb-3" }, index.h("iframe-input", { key: 'd5405444fbd9776882cbaf649cdc4f709c60f7be', inputId: "accountNumber", ref: (el) => (this.accountNumberIframeElement = el), label: "Account Number", iframeOrigin: `${this.iframeOrigin}/v2/accountNumber` })), index.h("div", { key: '788b71169701d7a004ce668cd2126b85cd65a372', class: "row" }, index.h("iframe-input", { key: '13d88a9e446e4fa7d88424359737202baa1ff79b', inputId: "routingNumber", ref: (el) => (this.routingNumberIframeElement = el), label: "Routing Number", iframeOrigin: `${this.iframeOrigin}/v2/routingNumber` })))));
    }
};

exports.bank_account_form = BankAccountForm;
