'use strict';

var index = require('./index-D5bL1DOi.js');
var utils = require('./utils-wkdkLmDI.js');
var styledHost = require('./styled-host-DXNHOiqW.js');
require('./event-types-YOY5TKUN.js');
var skeleton = require('./skeleton-CbZBGO47.js');
require('./parts-9jMf1erK.js');

const BusinessDetailsLoading = () => {
    const Block = () => (index.h("div", { class: "mt-5" },
        index.h(skeleton.Skeleton, { width: "40%", height: "1.5rem" }),
        index.h("hr", null),
        index.h("div", { class: "row g-3" },
            index.h("div", { class: "col-12 col-md-6" },
                index.h(skeleton.Skeleton, null),
                index.h(skeleton.Skeleton, null),
                index.h(skeleton.Skeleton, null)),
            index.h("div", { class: "col-12 col-md-6" },
                index.h(skeleton.Skeleton, null),
                index.h(skeleton.Skeleton, null),
                index.h(skeleton.Skeleton, null)))));
    return (index.h(index.Fragment, null,
        index.h(Block, null),
        index.h(Block, null),
        index.h(Block, null),
        index.h(Block, null)));
};

var RENDER_STATES;
(function (RENDER_STATES) {
    RENDER_STATES["LOADING"] = "loading";
    RENDER_STATES["READY"] = "ready";
    RENDER_STATES["ERROR"] = "error";
})(RENDER_STATES || (RENDER_STATES = {}));
const BusinessDetailsCore = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.errorEvent = index.createEvent(this, "error-event");
        this.renderState = RENDER_STATES.LOADING;
    }
    async componentWillLoad() {
        if (this.getBusiness) {
            this.fetchData();
        }
    }
    fetchData() {
        this.renderState = RENDER_STATES.LOADING;
        this.getBusiness({
            onSuccess: ({ business }) => {
                this.business = business;
                this.renderState = RENDER_STATES.READY;
            },
            onError: ({ error, code, severity }) => {
                this.errorMessage = error;
                this.renderState = RENDER_STATES.ERROR;
                this.errorEvent.emit({
                    errorCode: code,
                    message: error,
                    severity,
                });
            }
        });
    }
    render() {
        if (this.renderState === RENDER_STATES.LOADING) {
            return (index.h(styledHost.StyledHost, null, index.h(BusinessDetailsLoading, null)));
        }
        if (this.renderState === RENDER_STATES.ERROR) {
            return index.h(styledHost.StyledHost, null, utils.ErrorState(this.errorMessage));
        }
        return (index.h(styledHost.StyledHost, null, index.h("justifi-details", { "error-message": this.errorMessage }, index.h("div", { slot: 'detail-sections' }, index.h("core-info-details", { business: this.business }), index.h("legal-address-details", { legalAddress: this.business.legal_address }), index.h("representative-details", { representative: this.business.representative }), index.h("owner-details", { owners: this.business.owners }), index.h("additional-questions-details", { additionalQuestions: this.business.additional_questions })))));
    }
};

exports.business_details_core = BusinessDetailsCore;
