'use strict';

var index = require('./index-D5bL1DOi.js');
var parts = require('./parts-9jMf1erK.js');

const ButtonSpinner = () => (index.h("div", { class: "spinner-border spinner-border-sm", role: "status", part: "button-spinner" },
    index.h("span", { class: "visually-hidden" }, "Loading...")));

const Button = (props, children) => {
    const variantToButton = {
        primary: parts.buttonPrimary,
        secondary: parts.buttonSecondary,
    };
    const getCSSParts = () => {
        return `${variantToButton[props.variant]} ${(props.isLoading) ? parts.buttonLoading : ''}`;
    };
    return (index.h("button", Object.assign({ class: `btn btn-${props.variant}`, onClick: props.clickHandler, part: getCSSParts() }, props), props.isLoading ? ButtonSpinner() : children));
};

exports.Button = Button;
