'use strict';

var index = require('./index-D5bL1DOi.js');
var skeleton = require('./skeleton-CbZBGO47.js');
var configState = require('./config-state-Dz9bnWHg.js');
require('./parts-9jMf1erK.js');
require('./index-BCtVWU61.js');

const CardFormSkeleton = (props) => {
    const { isReady } = props;
    if (isReady) {
        return null;
    }
    return (index.h("div", { class: "container-fluid p-0" },
        index.h("div", { class: "mb-3" },
            index.h(skeleton.Skeleton, { height: "18px", width: "100px" }),
            index.h(skeleton.Skeleton, { height: "36px" })),
        index.h("div", { class: "row" },
            index.h("div", { class: "col-4 align-content-end" },
                index.h(skeleton.Skeleton, { height: "18px", width: "80px" }),
                index.h(skeleton.Skeleton, { height: "36px" })),
            index.h("div", { class: "col-4 align-content-end" },
                index.h(skeleton.Skeleton, { height: "36px" })),
            index.h("div", { class: "col-4 align-content-end" },
                index.h(skeleton.Skeleton, { height: "18px", width: "30px" }),
                index.h(skeleton.Skeleton, { height: "36px" })))));
};

const CardForm = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.isReady = false;
    }
    async componentWillLoad() {
        await configState.waitForConfig();
        this.iframeOrigin = configState.configState.iframeOrigin;
    }
    componentDidRender() {
        const elements = [
            this.cardNumberIframeElement,
            this.expirationMonthIframeElement,
            this.expirationYearIframeElement,
            this.cvvIframeElement,
        ];
        Promise.all(elements.map((element) => {
            return new Promise((resolve) => {
                element.addEventListener('iframeLoaded', () => { resolve(); });
            });
        })).then(() => {
            this.isReady = true;
        });
    }
    async validate() {
        const cardNumberIsValid = await this.cardNumberIframeElement.validate();
        const expirationMonthIsValid = await this.expirationMonthIframeElement.validate();
        const expirationYearIsValid = await this.expirationYearIframeElement.validate();
        const cvvIsValid = await this.cvvIframeElement.validate();
        return cardNumberIsValid && expirationMonthIsValid && expirationYearIsValid && cvvIsValid;
    }
    async tokenize(clientId, paymentMethodMetadata, account) {
        return this.cardNumberIframeElement.tokenize(clientId, paymentMethodMetadata, account);
    }
    render() {
        return (index.h(index.Host, { key: 'd5e5c74e5e3be0bb5a9603a89724d23cc6216d6c' }, index.h(CardFormSkeleton, { key: 'a1e90d74ca6e72678255590a94937932a9520046', isReady: this.isReady }), index.h("div", { key: 'bb303552ed581492de8ebb0d83cea751ddd90a09', class: "container-fluid p-0", style: {
                opacity: this.isReady ? '1' : '0',
                height: this.isReady ? 'auto' : '0',
            } }, index.h("div", { key: '9641c97124a504729b1eba3e8704d8fd3fda7fde', class: "mb-3" }, index.h("iframe-input", { key: 'a5a73c00c2ac0cd12ef98b155a40108248529fb7', inputId: "cardNumber", ref: (el) => (this.cardNumberIframeElement = el), label: "Card Number", iframeOrigin: `${this.iframeOrigin}/v2/cardNumber` })), index.h("div", { key: 'dad1b83f028745aa8b85a8e552f702d5daa3ac6f', class: "d-flex align-items-start" }, index.h("div", { key: '5de05029d93a81d5ad8c799135863e8cdd1e8619', class: "flex-fill me-3" }, index.h("iframe-input", { key: '4ec81652e51187bbaa25600299f8cb89f0c41c5c', inputId: "expirationMonth", ref: (el) => (this.expirationMonthIframeElement = el), label: "Exp. Month", iframeOrigin: `${this.iframeOrigin}/v2/expirationMonth` })), index.h("div", { key: '0280f01efdbbfa3542036fa4ee7baec130e42688', class: "flex-fill me-3" }, index.h("iframe-input", { key: 'b13dba61a6bd18529e70987029592b5b7307e74b', inputId: "expirationYear", ref: (el) => (this.expirationYearIframeElement = el), label: "Exp. Year", iframeOrigin: `${this.iframeOrigin}/v2/expirationYear` })), index.h("div", { key: 'edf1e383a148a2d535c4733a2b5af2d8e31e2f43', class: "flex-fill" }, index.h("iframe-input", { key: 'd63e832db1a089f36909db23cacb110f6571535c', inputId: "CVV", ref: (el) => (this.cvvIframeElement = el), label: "CVV", iframeOrigin: `${this.iframeOrigin}/v2/CVV` }))))));
    }
};

exports.card_form = CardForm;
