'use strict';

var index = require('./index-D5bL1DOi.js');
var parts = require('./parts-9jMf1erK.js');
var formControlHelpText = require('./form-control-help-text-B3jRgfoa.js');
var formControlErrorText = require('./form-control-error-text-CVPYL0lE.js');
require('./event-types-YOY5TKUN.js');

const CheckboxInput = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.formControlInput = index.createEvent(this, "formControlInput");
        this.formControlBlur = index.createEvent(this, "formControlBlur");
        this.isFocused = false;
        this.handleFormControlInput = (event) => {
            event.preventDefault();
            const target = event.target;
            const name = target.getAttribute('name');
            this.inputHandler(name, target.checked);
            this.formControlInput.emit({ name, value: target.value });
        };
        this.updateInput = (newValue) => {
            this.checkboxElement.checked = newValue;
        };
    }
    get part() {
        if (this.errorText) {
            return parts.inputCheckboxInvalid;
        }
        if (this.isFocused && this.checked) {
            return parts.inputCheckboxCheckedFocused;
        }
        if (this.isFocused) {
            return parts.inputCheckboxFocused;
        }
        if (this.checked) {
            return parts.inputCheckboxChecked;
        }
        return parts.inputCheckbox;
    }
    render() {
        return (index.h(index.Host, { key: 'f574898ffe8a3d666d4b95721cf4f3f3866f8632' }, index.h("div", { key: '185ac07832d140b467162e2bdacb90ea0640d460', class: 'form-group d-flex flex-column' }, index.h("div", { key: 'c610e4c989b6c8529253ef73e39d4e58f0efd1e3', class: "form-check" }, index.h("input", { key: '7abfbfed27e3ad2c0a46a5f30b0681d54673c1fb', ref: el => (this.checkboxElement = el), type: "checkbox", id: this.name, name: this.name, onFocus: () => this.isFocused = true, onBlur: () => {
                this.isFocused = false;
                this.formControlBlur.emit();
            }, onInput: this.handleFormControlInput, part: this.part, class: this.errorText ? 'form-check-input is-invalid' : 'form-check-input', disabled: this.disabled, checked: this.checked }), index.h("label", { key: '9c505e1d0926690eb32d2d9621d6c144cfe27f6a', class: "form-check-label", htmlFor: this.name, part: parts.label }, this.label)), index.h(formControlHelpText.FormControlHelpText, { key: 'fc7933d29f06ef533fe45025184d5c8cdd24cdd1', helpText: this.helpText, name: this.name }), index.h(formControlErrorText.FormControlErrorText, { key: '29879fd2d7c04a26eb999bb2f9991bc38515994b', errorText: this.errorText, name: this.name }))));
    }
};

exports.form_control_checkbox = CheckboxInput;
