'use strict';

var index = require('./index-D5bL1DOi.js');
var parts = require('./parts-9jMf1erK.js');
var formControlHelpText = require('./form-control-help-text-B3jRgfoa.js');
var formControlErrorText = require('./form-control-error-text-CVPYL0lE.js');
require('./event-types-YOY5TKUN.js');

const NumberInput = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.formControlInput = index.createEvent(this, "formControlInput");
        this.formControlBlur = index.createEvent(this, "formControlBlur");
        this.isFocused = false;
        this.handleFormControlInput = (event) => {
            const target = event.target;
            const name = target.getAttribute('name');
            this.inputHandler(name, target.value);
            this.formControlInput.emit({ name, value: target.value });
        };
        this.updateInput = (newValue) => {
            const inputElement = this.el.querySelector('input');
            if (inputElement) {
                inputElement.value = newValue || '';
            }
        };
    }
    handleDefaultValueChange(newValue) {
        this.updateInput(newValue);
    }
    componentDidLoad() {
        this.updateInput(this.defaultValue);
    }
    get part() {
        if (this.isFocused && this.errorText) {
            return parts.inputInvalidAndFocused;
        }
        if (this.isFocused) {
            return parts.inputFocused;
        }
        if (this.errorText) {
            return parts.inputInvalid;
        }
        return parts.input;
    }
    render() {
        return (index.h(index.Host, { key: '0c518001e14574c5c7bce66643ec03571eb80e86' }, index.h("div", { key: 'd09fbf1cd01990d2d73fe8ca3b0ee59ba48b4631', class: 'form-group d-flex flex-column' }, index.h("label", { key: '51476220a170a30e6fb8eabb06c0dc16b5231a59', part: parts.label, class: "form-label", htmlFor: this.name }, this.label), index.h("input", { key: '3d31c0cbb62e9f9957994b3a4d2fc26330aa4ee8', id: this.name, name: this.name, onFocus: () => this.isFocused = true, onBlur: () => {
                this.isFocused = false;
                this.formControlBlur.emit();
            }, onInput: this.handleFormControlInput, part: this.part, class: this.errorText ? 'form-control is-invalid' : 'form-control', type: "number", disabled: this.disabled }), index.h(formControlHelpText.FormControlHelpText, { key: '48241a9ebf6118a0b231d05b7aa14ade91e105b7', helpText: this.helpText, name: this.name }), index.h(formControlErrorText.FormControlErrorText, { key: '53b60709bd2c431e93fe411c498df28dca5dbc30', errorText: this.errorText, name: this.name }))));
    }
    get el() { return index.getElement(this); }
    static get watchers() { return {
        "defaultValue": ["handleDefaultValueChange"]
    }; }
};

exports.form_control_number = NumberInput;
