'use strict';

const PHONE_MASKS = {
    US: '(000) 000-0000',
};
const TAX_ID_MASKS = { US: '00-0000000' };
const SSN_MASK = '000-00-0000';
const CURRENCY_MASK = {
    WHOLE: {
        mask: Number,
        thousandsSeparator: ',',
        normalizeZeros: true,
    },
    DECIMAL: {
        mask: Number,
        scale: 2,
        thousandsSeparator: ',',
        padFractionalZeros: true,
        normalizeZeros: true,
        radix: '.',
    }
};

exports.CURRENCY_MASK = CURRENCY_MASK;
exports.PHONE_MASKS = PHONE_MASKS;
exports.SSN_MASK = SSN_MASK;
exports.TAX_ID_MASKS = TAX_ID_MASKS;
