'use strict';

var ComponentError = require('./ComponentError-CEv9ltwy.js');
var utils = require('./utils-IGCnjtqc.js');

const makeGetPayoutCSV = ({ authToken, service }) => async ({ payoutId, onError }) => {
    try {
        const { data } = await service.fetchCSV(payoutId, authToken);
        const a = document.createElement('a');
        a.href = data.csv_url;
        a.click();
    }
    catch (error) {
        const errorMessage = utils.getErrorMessage(error);
        const code = utils.getErrorCode(error === null || error === void 0 ? void 0 : error.code);
        onError({
            error: errorMessage,
            code,
            severity: ComponentError.ComponentErrorSeverity.ERROR,
        });
    }
};

exports.makeGetPayoutCSV = makeGetPayoutCSV;
