'use strict';

var Api = require('./Api-eP0XeJLd.js');
var ComponentError = require('./ComponentError-CEv9ltwy.js');
var Refund = require('./Refund-08OcZkXX.js');
require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./Dispute-CruQTF6_.js');
require('./config-state-Dz9bnWHg.js');
require('./dinero-J-SRFKIR.js');
var utils = require('./utils-IGCnjtqc.js');

const api = Api.Api();
class SubAccountService {
    async fetchSubAccounts(accountId, authToken, params) {
        const endpoint = 'sub_accounts';
        const headers = { Account: accountId };
        return api.get({ authToken, endpoint, params, headers });
    }
}

const makeGetSubAccounts = ({ accountId, authToken, service }) => async ({ params, onSuccess, onError }) => {
    var _a, _b;
    try {
        const response = await service.fetchSubAccounts(accountId, authToken, params);
        if (!response.error) {
            const pagingInfo = Object.assign({}, response.page_info);
            const subAccounts = ((_a = response.data) === null || _a === void 0 ? void 0 : _a.map((dataItem) => new Refund.SubAccount(dataItem))) || [];
            onSuccess({ subAccounts, pagingInfo });
        }
        else {
            const responseError = utils.getErrorMessage(response.error);
            const code = utils.getErrorCode((_b = response.error) === null || _b === void 0 ? void 0 : _b.code);
            return onError({
                error: responseError,
                code,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
        }
    }
    catch (error) {
        const code = utils.getErrorCode(error === null || error === void 0 ? void 0 : error.code);
        return onError({
            error: error.message || error,
            code,
            severity: ComponentError.ComponentErrorSeverity.ERROR,
        });
    }
};

exports.SubAccountService = SubAccountService;
exports.makeGetSubAccounts = makeGetSubAccounts;
