'use strict';

var index = require('./index-D5bL1DOi.js');
var parts = require('./parts-9jMf1erK.js');
var styledHost = require('./styled-host-DXNHOiqW.js');

const JustifiRadioListItem = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.radioClick = index.createEvent(this, "radio-click");
        this.checked = false;
        this.hidden = false;
        this.handleClick = () => {
            this.radioClick.emit(this.value);
        };
    }
    render() {
        return (index.h(styledHost.StyledHost, { key: '492a73e2bab02c04aa8733ce0b9ab801e5ff8875' }, index.h("div", { key: 'c095a98ba11739b85ece4c7bb0e0c30e7e08ec7b', class: `radio-list-item p-3 ${this.class || ''}`, part: parts.radioListItem, onClick: this.handleClick, hidden: this.hidden }, index.h("form-control-radio", { key: 'e76be985c8c7a69799869e58b9c9b749e7bd363f', name: this.name, value: this.value, checked: this.checked, label: this.label }))));
    }
};

const BillingForm = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
    }
    get isPostalOnlyMode() {
        return this.paymentMethodType === 'card' && this.hideCardBillingForm;
    }
    get hideAllBillingFields() {
        return this.paymentMethodType === 'bankAccount' && this.hideBankAccountBillingForm;
    }
    async getValues() {
        return this.formRef.getValues();
    }
    async fill(fields) {
        return this.formRef.fill(fields);
    }
    async validate() {
        const { isValid, errors } = await this.formRef.validate();
        return { isValid, errors };
    }
    render() {
        const showHeader = !this.isPostalOnlyMode && !this.hideAllBillingFields;
        return (index.h("div", { key: 'b1d80f02eee8bdc4fe4b9bfd7e9fb86d89af53b3', part: parts.billingForm, class: "mt-4", hidden: this.hideAllBillingFields }, showHeader && index.h("justifi-header", { key: 'f3d7d02561a3de2c777b869a8b874fe0e03d1924', text: "Billing address", level: "h3", class: "fs-6 fw-bold lh-lg mb-4" }), this.legend && index.h("legend", { key: '9218d5b52eed27d86970e745cbbd9d02c6df513b' }, this.legend), this.isPostalOnlyMode ? (index.h("justifi-postal-code-form", { ref: (el) => this.formRef = el })) : (index.h("justifi-billing-information-form", { ref: (el) => this.formRef = el }))));
    }
};

exports.justifi_billing_form = BillingForm;
exports.justifi_radio_list_item = JustifiRadioListItem;
