'use strict';

var index = require('./index-D5bL1DOi.js');
var utils = require('./utils-wkdkLmDI.js');
var business_service = require('./business.service-CZrK48lv.js');
var getBusiness = require('./get-business-BiEc-jdH.js');
var ComponentError = require('./ComponentError-CEv9ltwy.js');
var checkPkgVersion = require('./check-pkg-version-DBocF2eE.js');
require('./parts-9jMf1erK.js');
require('./Api-eP0XeJLd.js');
require('./config-state-Dz9bnWHg.js');
require('./index-BCtVWU61.js');
require('./utils-DqlrBltg.js');
require('./dinero-J-SRFKIR.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./Refund-08OcZkXX.js');
require('./Dispute-CruQTF6_.js');
require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./helpers-B5OCqlIM.js');
require('./state-options-CIT9xdTz.js');
require('./utils-IGCnjtqc.js');
require('./package-BM2FCIB8.js');

const BusinessDetails = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.errorEvent = index.createEvent(this, "error-event");
        this.errorMessage = null;
        this.handleErrorEvent = event => {
            this.errorMessage = event.detail.message;
            this.errorEvent.emit(event.detail);
        };
    }
    componentWillLoad() {
        checkPkgVersion.checkPkgVersion();
        this.analytics = new checkPkgVersion.JustifiAnalytics(this);
        this.initializeGetBusiness();
    }
    disconnectedCallback() {
        var _a;
        (_a = this.analytics) === null || _a === void 0 ? void 0 : _a.cleanup();
    }
    ;
    initializeGetBusiness() {
        if (!this.businessId || !this.authToken) {
            this.errorMessage = 'Invalid business id or auth token';
            this.errorEvent.emit({
                errorCode: ComponentError.ComponentErrorCodes.MISSING_PROPS,
                message: this.errorMessage,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
            return;
        }
        this.getBusiness = getBusiness.makeGetBusiness({
            id: this.businessId,
            authToken: this.authToken,
            service: new business_service.BusinessService(),
        });
    }
    render() {
        if (this.errorMessage) {
            return utils.ErrorState(this.errorMessage);
        }
        return (index.h("business-details-core", { getBusiness: this.getBusiness, "onError-event": this.handleErrorEvent }));
    }
};

exports.justifi_business_details = BusinessDetails;
