'use strict';

var index = require('./index-D5bL1DOi.js');
var index_esm = require('./index.esm-CVuJLXJZ.js');
var businessAdditionalQuestionsSchema = require('./business-additional-questions-schema-e3GCIHk5.js');
var businessIdentitySchema = require('./business-identity-schema-Diqj_WVQ.js');
require('./config-state-Dz9bnWHg.js');
require('./dinero-J-SRFKIR.js');
var ComponentError = require('./ComponentError-CEv9ltwy.js');
require('./Refund-08OcZkXX.js');
require('./Pagination-Dediz133.js');
var Business = require('./Business-DCRzZf0w.js');
require('./Dispute-CruQTF6_.js');
var checkPkgVersion = require('./check-pkg-version-DBocF2eE.js');
var button = require('./button-0HYMPryx.js');
var styledHost = require('./styled-host-DXNHOiqW.js');
var header1 = require('./header-1-M-mc3bsa.js');
require('./event-types-YOY5TKUN.js');
var skeleton = require('./skeleton-CbZBGO47.js');
var eventTypes = require('./event-types-DNOUef41.js');
var paymentProvisioningActions = require('./payment-provisioning-actions-SNMCdsyF.js');
var business_service = require('./business.service-CZrK48lv.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./schema-validations-BSeMee-o.js');
require('./state-options-CIT9xdTz.js');
require('./business-form-options-CMII7nIK.js');
require('./index-BCtVWU61.js');
require('./utils-DqlrBltg.js');
require('./helpers-B5OCqlIM.js');
require('./package-BM2FCIB8.js');
require('./Api-eP0XeJLd.js');
require('./parts-9jMf1erK.js');
require('./utils-IGCnjtqc.js');

const businessFormSchema = index_esm.create$3(Object.assign(Object.assign({}, businessAdditionalQuestionsSchema.businessCoreInfoSchema().fields), { legal_address: businessIdentitySchema.addressSchema(), additional_questions: businessAdditionalQuestionsSchema.additionalQuestionsSchema(), representative: businessIdentitySchema.identitySchema('representative') }));

const FormBlock = () => (index.h("div", { class: "row gap-3" },
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "25%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "100%" })),
    index.h("div", { class: "col-12 d-flex gap-3" },
        index.h(skeleton.Skeleton, { width: "50%" }),
        index.h(skeleton.Skeleton, { width: "50%" })),
    index.h("div", { class: "col-12 d-flex gap-3" },
        index.h(skeleton.Skeleton, { width: "65%" }),
        index.h(skeleton.Skeleton, { width: "35%" }))));
const BusinessFormLoading = () => {
    return (index.h("div", { class: "row gap-5" },
        index.h("div", { class: "col-12" },
            index.h(skeleton.Skeleton, { width: "40%", height: "40px" })),
        index.h(FormBlock, null),
        index.h(FormBlock, null),
        index.h(FormBlock, null)));
};

const BusinessForm = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.submitEvent = index.createEvent(this, "submit-event");
        this.clickEvent = index.createEvent(this, "click-event");
        this.errorEvent = index.createEvent(this, "error-event");
        this.isLoading = false;
        this.isSaving = false;
        this.hideErrors = false;
        this.formTitle = 'Business Information';
        this.removeTitle = false;
        this.instantiateBusiness = (data) => {
            const business = new Business.Business(data);
            this.formController.setInitialValues(Object.assign({}, business));
        };
        this.sendData = async () => {
            this.isSaving = true;
            const values = this.formController.values.getValue();
            const initialValues = this.formController.getInitialValues();
            const payload = new Business.Business(Object.assign(Object.assign({}, initialValues), values)).payload;
            this.patchBusiness({
                payload,
                onSuccess: (response) => {
                    this.handleReponse(response);
                },
                onError: ({ error, code, severity }) => {
                    this.errorMessage = error.message;
                    this.errorEvent.emit({ errorCode: code, message: error.message, severity });
                },
                final: () => {
                    this.isSaving = false;
                }
            });
        };
        this.validateAndSubmit = (event) => {
            event.preventDefault();
            this.formController.validateAndSubmit(this.sendData);
        };
    }
    componentWillLoad() {
        checkPkgVersion.checkPkgVersion();
        this.analytics = new checkPkgVersion.JustifiAnalytics(this);
        this.formController = new index_esm.FormController(businessFormSchema);
        this.initializeApi();
    }
    disconnectedCallback() {
        var _a;
        (_a = this.analytics) === null || _a === void 0 ? void 0 : _a.cleanup();
    }
    ;
    get title() {
        return this.removeTitle ? '' : this.formTitle;
    }
    get disabledState() {
        return this.isSaving;
    }
    get businessEndpoint() {
        return `entities/business/${this.businessId}`;
    }
    initializeApi() {
        if (this.authToken && this.businessId) {
            this.getBusiness = paymentProvisioningActions.makeGetBusiness({
                authToken: this.authToken,
                businessId: this.businessId,
                service: new business_service.BusinessService()
            });
            this.patchBusiness = paymentProvisioningActions.makePatchBusiness({
                authToken: this.authToken,
                businessId: this.businessId,
                service: new business_service.BusinessService()
            });
            this.getBusiness({
                onSuccess: (response) => {
                    this.instantiateBusiness(response.data);
                },
                onError: ({ error, code, severity }) => {
                    this.errorMessage = error.message;
                    this.errorEvent.emit({ errorCode: code, message: error.message, severity });
                },
                final: () => {
                    this.isLoading = false;
                }
            });
        }
        else {
            this.errorEvent.emit({
                message: 'auth-token and business-id are required',
                errorCode: ComponentError.ComponentErrorCodes.MISSING_PROPS,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
        }
    }
    handleReponse(response) {
        if (response.error) {
            this.errorMessage = Business.BusinessFormServerErrors.patchData;
        }
        this.submitEvent.emit({ response });
        this.instantiateBusiness(response.data);
    }
    render() {
        if (this.isLoading) {
            return index.h(styledHost.StyledHost, null, index.h(BusinessFormLoading, null));
        }
        return (index.h(styledHost.StyledHost, null, index.h("form", { onSubmit: this.validateAndSubmit }, index.h("div", { class: "row gap-3" }, index.h(header1.Header1, { text: this.title }), index.h("form-alert", { text: this.errorMessage, hideAlert: this.hideErrors }), index.h("div", { class: "col-12 mb-4" }, index.h("justifi-business-core-info", { formController: this.formController })), index.h("div", { class: "col-12 mb-4" }, index.h("justifi-legal-address-form", { formController: this.formController })), index.h("div", { class: "col-12 mb-4" }, index.h("justifi-additional-questions", { formController: this.formController })), index.h("div", { class: "col-12 mb-4" }, index.h("justifi-business-representative", { formController: this.formController })), index.h("div", { class: "col-12 d-flex flex-row-reverse" }, index.h(button.Button, { type: "submit", disabled: this.disabledState, variant: 'primary', onClick: () => this.clickEvent.emit({ name: eventTypes.BusinessFormClickActions.submit }), isLoading: this.isSaving }, "Submit"))))));
    }
};

exports.justifi_business_form = BusinessForm;
