'use strict';

var index = require('./index-D5bL1DOi.js');
var parts = require('./parts-9jMf1erK.js');
var utils = require('./utils-DqlrBltg.js');
var checkout_store = require('./checkout.store--pVCO0L1.js');
var styledHost = require('./styled-host-DXNHOiqW.js');
require('./event-types-YOY5TKUN.js');
var checkPkgVersion = require('./check-pkg-version-DBocF2eE.js');
require('./config-state-Dz9bnWHg.js');
require('./dinero-J-SRFKIR.js');
var ComponentError = require('./ComponentError-CEv9ltwy.js');
require('./Refund-08OcZkXX.js');
require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./Dispute-CruQTF6_.js');
var utils$1 = require('./utils-IGCnjtqc.js');
var checkout_service = require('./checkout.service-CllLA9W6.js');
var insuranceState = require('./insurance-state-kH0kuTD8.js');
var paymentMethodOptionUtils = require('./payment-method-option-utils-QODgEWhU.js');
require('./index-BCtVWU61.js');
require('./package-BM2FCIB8.js');
require('./Api-eP0XeJLd.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./helpers-B5OCqlIM.js');
require('./state-options-CIT9xdTz.js');

const Summary = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
    }
    render() {
        return (index.h(styledHost.StyledHost, { key: '1bafeffc42f1e98f50551ca971f52e8294782168' }, index.h("section", { key: 'bf1a89bf030ae5a953abe092d0a5c543ed7f543f' }, index.h("div", { key: 'ce0b98733c2e158c1caef43b751513a0565ecfc6' }, index.h("div", { key: '8d0525c31ac3a93a5ce1aa2afde5c9bd7da26dc0', part: parts.text }, checkout_store.checkoutStore === null || checkout_store.checkoutStore === void 0 ? void 0 : checkout_store.checkoutStore.paymentDescription), index.h("div", { key: '7885858ddcd2819522fa08fbbc2d3dce2f0132f6' }, index.h("span", { key: '57ce1d9a9dd1269c4d958c78210565e9cb68d22a', part: parts.text }, "Total"), "\u00A0", index.h("span", { key: '0b6673bd2c841cb0e50db93c148bfe15f96b577a', part: parts.text }, utils.formatCurrency(+(checkout_store.checkoutStore === null || checkout_store.checkoutStore === void 0 ? void 0 : checkout_store.checkoutStore.totalAmount))))))));
    }
};

const makeGetCheckout = ({ authToken, checkoutId, service }) => async ({ onSuccess, onError }) => {
    var _a;
    try {
        const response = await service.fetchCheckout(authToken, checkoutId);
        if (!response.error) {
            const checkout = response.data;
            onSuccess({ checkout });
        }
        else {
            const responseError = utils$1.getErrorMessage(response.error);
            const code = utils$1.getErrorCode((_a = response.error) === null || _a === void 0 ? void 0 : _a.code);
            return onError({
                error: responseError,
                code,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
        }
    }
    catch (error) {
        const code = utils$1.getErrorCode(error === null || error === void 0 ? void 0 : error.code);
        return onError({
            error: error.message || error,
            code,
            severity: ComponentError.ComponentErrorSeverity.ERROR,
        });
    }
};
const makeCheckoutComplete = ({ authToken, checkoutId, service }) => async ({ payment, onSuccess, onError }) => {
    var _a;
    try {
        const response = await service.complete(authToken, checkoutId, payment);
        if (!response.error) {
            onSuccess(response);
        }
        else {
            const responseError = utils$1.getErrorMessage(response.error);
            const code = utils$1.getErrorCode((_a = response.error) === null || _a === void 0 ? void 0 : _a.code);
            return onError({
                error: responseError,
                code,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
        }
    }
    catch (error) {
        const code = utils$1.getErrorCode(error === null || error === void 0 ? void 0 : error.code);
        return onError({
            error: error.message || error,
            code,
            severity: ComponentError.ComponentErrorSeverity.ERROR,
        });
    }
};

const CheckoutWrapper = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.errorEvent = index.createEvent(this, "error-event");
        this.submitEvent = index.createEvent(this, "submit-event");
        this.paymentMethodChangedEvent = index.createEvent(this, "payment-method-changed");
        this.savePaymentMethod = false;
    }
    connectedCallback() {
        this.observer = new MutationObserver(() => {
            this.queryFormRefs();
        });
        this.observer.observe(this.hostEl, {
            childList: true,
            subtree: true
        });
        checkout_store.checkoutStore.checkoutId = this.checkoutId;
        const config = {
            authToken: this.authToken,
            checkoutId: this.checkoutId,
            service: new checkout_service.CheckoutService()
        };
        this.getCheckout = makeGetCheckout(config);
        this.completeCheckout = makeCheckoutComplete(config);
        checkout_store.onChange('selectedPaymentMethod', (newValue) => {
            this.paymentMethodChangedEvent.emit(newValue);
        });
    }
    componentWillLoad() {
        this.analytics = new checkPkgVersion.JustifiAnalytics(this);
        checkPkgVersion.checkPkgVersion();
        checkout_store.checkoutStore.authToken = this.authToken;
        this.fetchCheckout();
        // Refresh the checkout data when insurance is added or removed
        insuranceState.insuranceValuesOn('set', (key) => {
            const value = insuranceState.insuranceValues[key];
            if (value !== undefined) {
                this.fetchCheckout();
            }
        });
    }
    componentDidLoad() {
        this.queryFormRefs();
    }
    disconnectedCallback() {
        var _a;
        (_a = this.observer) === null || _a === void 0 ? void 0 : _a.disconnect();
    }
    fetchCheckout() {
        if (this.getCheckout) {
            this.getCheckout({
                onSuccess: ({ checkout }) => {
                    this.updateStore(checkout);
                },
                onError: (error) => {
                    this.errorEvent.emit({
                        message: error.message,
                        errorCode: ComponentError.ComponentErrorCodes.FETCH_ERROR,
                        severity: ComponentError.ComponentErrorSeverity.ERROR,
                    });
                }
            });
        }
    }
    updateStore(checkout) {
        var _a, _b, _c, _d;
        checkout_store.checkoutStore.accountId = checkout.account_id;
        checkout_store.checkoutStore.paymentMethods = checkout.payment_methods;
        checkout_store.checkoutStore.paymentMethodGroupId = checkout.payment_method_group_id;
        checkout_store.checkoutStore.paymentDescription = checkout.payment_description;
        checkout_store.checkoutStore.totalAmount = checkout.total_amount;
        checkout_store.checkoutStore.paymentAmount = checkout.payment_amount;
        checkout_store.checkoutStore.bnplEnabled = checkout.payment_settings.bnpl_payments;
        checkout_store.checkoutStore.bnplProviderClientId = (_a = checkout === null || checkout === void 0 ? void 0 : checkout.bnpl) === null || _a === void 0 ? void 0 : _a.provider_client_id;
        checkout_store.checkoutStore.bnplProviderMode = (_b = checkout === null || checkout === void 0 ? void 0 : checkout.bnpl) === null || _b === void 0 ? void 0 : _b.provider_mode;
        checkout_store.checkoutStore.bnplProviderApiVersion = (_c = checkout === null || checkout === void 0 ? void 0 : checkout.bnpl) === null || _c === void 0 ? void 0 : _c.provider_api_version;
        checkout_store.checkoutStore.bnplProviderCheckoutUrl = (_d = checkout === null || checkout === void 0 ? void 0 : checkout.bnpl) === null || _d === void 0 ? void 0 : _d.provider_checkout_url;
    }
    queryFormRefs() {
        this.paymentMethodFormRef = this.hostEl.querySelector('justifi-card-form, justifi-bank-account-form');
        this.tokenizeComponentRef = this.hostEl.querySelector('justifi-tokenize-payment-method');
        this.billingInformationFormRef = this.hostEl.querySelector('justifi-billing-information-form, justifi-postal-code-form');
        this.insuranceFormRef = this.hostEl.querySelector('justifi-season-interruption-insurance');
        this.sezzlePaymentMethodRef = this.hostEl.querySelector('justifi-sezzle-payment-method');
    }
    async tokenizePaymentMethod(tokenizeArgs) {
        var _a, _b;
        const billingInfoValues = (_b = await ((_a = this.billingInformationFormRef) === null || _a === void 0 ? void 0 : _a.getValues())) !== null && _b !== void 0 ? _b : {};
        const combinedBillingInfo = Object.assign(Object.assign({}, tokenizeArgs), billingInfoValues);
        const paymentMethodMetadata = Object.assign({ accountId: checkout_store.checkoutStore.accountId, payment_method_group_id: undefined }, combinedBillingInfo);
        if (this.savePaymentMethod) {
            paymentMethodMetadata.payment_method_group_id = checkout_store.checkoutStore.paymentMethodGroupId;
        }
        if (this.tokenizeComponentRef) {
            const tokenizeResult = await this.tokenizeComponentRef.tokenizePaymentMethod();
            if (tokenizeResult.error) {
                return tokenizeResult;
            }
        }
        return this.paymentMethodFormRef.tokenize({
            clientId: this.authToken,
            paymentMethodMetadata,
            account: checkout_store.checkoutStore.accountId,
        });
    }
    async getPaymentMethod(submitCheckoutArgs) {
        if (!this.paymentMethodFormRef) {
            return checkout_store.checkoutStore.selectedPaymentMethod;
        }
        const { error, id: token } = await this.tokenizePaymentMethod(submitCheckoutArgs);
        if (error) {
            this.errorEvent.emit({
                errorCode: error.code,
                message: error.message,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
            return undefined;
        }
        return token;
    }
    async validate() {
        var _a, _b;
        const promises = [
            (_a = this.paymentMethodFormRef) === null || _a === void 0 ? void 0 : _a.validate(),
            (_b = this.billingInformationFormRef) === null || _b === void 0 ? void 0 : _b.validate()
        ];
        if (this.insuranceFormRef) {
            promises.push(this.insuranceFormRef.validate());
        }
        const validationResults = await Promise.all(promises);
        return validationResults.every(result => (result === null || result === void 0 ? void 0 : result.isValid) !== false);
    }
    async submitCheckout(submitCheckoutArgs) {
        var _a;
        const isValid = await this.validate();
        if (!isValid) {
            this.errorEvent.emit({
                message: 'Please fill in all required fields.',
                errorCode: ComponentError.ComponentErrorCodes.VALIDATION_ERROR,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
            return;
        }
        let payment;
        if (checkout_store.checkoutStore.selectedPaymentMethod === 'sezzle') {
            const insuranceValidation = this.insuranceFormRef ? await this.insuranceFormRef.validate() : { isValid: true };
            const sezzleResult = await this.sezzlePaymentMethodRef.resolvePaymentMethod(insuranceValidation);
            if (sezzleResult.error) {
                this.errorEvent.emit({
                    message: sezzleResult.error.message,
                    errorCode: ComponentError.ComponentErrorCodes.TOKENIZE_ERROR,
                    severity: ComponentError.ComponentErrorSeverity.ERROR,
                });
                return;
            }
            else if (((_a = sezzleResult.bnpl) === null || _a === void 0 ? void 0 : _a.status) === 'success') {
                payment = {
                    payment_mode: 'bnpl',
                    payment_token: undefined,
                };
            }
        }
        else {
            const paymentMethod = await this.getPaymentMethod(submitCheckoutArgs);
            if (!paymentMethod) {
                this.errorEvent.emit({
                    message: 'Payment method tokenization failed.',
                    errorCode: ComponentError.ComponentErrorCodes.TOKENIZE_ERROR,
                    severity: ComponentError.ComponentErrorSeverity.ERROR,
                });
                return;
            }
            payment = {
                payment_mode: 'ecom',
                payment_token: paymentMethod,
            };
        }
        this.completeCheckout({
            payment,
            onSuccess: ({ checkout }) => {
                this.submitEvent.emit({
                    checkout,
                    message: 'Checkout completed successfully',
                });
            },
            onError: (error) => {
                this.errorEvent.emit({
                    message: error.message,
                    errorCode: ComponentError.ComponentErrorCodes.COMPLETE_CHECKOUT_ERROR,
                    severity: ComponentError.ComponentErrorSeverity.ERROR,
                });
            },
        });
    }
    async setSelectedPaymentMethod(paymentMethodId) {
        checkout_store.checkoutStore.selectedPaymentMethod = paymentMethodId;
    }
    render() {
        return (index.h(index.Host, { key: '6949f68031572493fae333731c78cc07ccd7fafd' }));
    }
    get hostEl() { return index.getElement(this); }
};

const SavedPaymentMethods = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.onPaymentMethodOptionClick = (paymentMethodId) => (e) => {
            e.preventDefault();
            checkout_store.checkoutStore.selectedPaymentMethod = paymentMethodId;
        };
        this.isAllowedPaymentMethod = (paymentMethod) => {
            if (paymentMethod.type === 'card' && checkout_store.checkoutStore.disableCreditCard) {
                return false;
            }
            if (paymentMethod.type === 'bank_account' && checkout_store.checkoutStore.disableBankAccount) {
                return false;
            }
            return true;
        };
    }
    componentWillLoad() {
        if (!checkout_store.checkoutStore.paymentMethods.length) {
            console.warn('No saved payment methods available.');
        }
        if (checkout_store.checkoutStore.disablePaymentMethodGroup) {
            console.warn('Payment method group is disabled.');
        }
    }
    render() {
        if (checkout_store.checkoutStore.disablePaymentMethodGroup) {
            return null;
        }
        return (index.h(styledHost.StyledHost, null, index.h("div", { class: "saved-payment-methods" }, checkout_store.checkoutStore.paymentMethods.length ? checkout_store.checkoutStore.paymentMethods
            .filter(this.isAllowedPaymentMethod)
            .map((paymentMethod) => (index.h("div", { class: "radio-list-item p-3", part: parts.radioListItem, onClick: this.onPaymentMethodOptionClick(paymentMethod === null || paymentMethod === void 0 ? void 0 : paymentMethod.id) }, index.h("form-control-radio", { name: "paymentMethodType", value: paymentMethod === null || paymentMethod === void 0 ? void 0 : paymentMethod.id, checked: checkout_store.checkoutStore.selectedPaymentMethod === (paymentMethod === null || paymentMethod === void 0 ? void 0 : paymentMethod.id), label: `${paymentMethodOptionUtils.CardBrandLabels[paymentMethod === null || paymentMethod === void 0 ? void 0 : paymentMethod.brand] || ''} *${paymentMethod === null || paymentMethod === void 0 ? void 0 : paymentMethod.acct_last_four}` })))) : null)));
    }
};

const sezzleLogo = (index.h("img", { class: "sezzle-smart-button-logo-img", src: "https://media.sezzle.com/branding/2.0/Sezzle_Logo_FullColor.svg", alt: "Sezzle", style: {
        display: 'inline',
        width: '80px',
        marginLeft: '5px',
        marginTop: '-5px',
    } }));
const SezzlePaymentMethod = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.paymentMethodOptionSelected = index.createEvent(this, "paymentMethodOptionSelected");
        this.paymentMethodOptionId = 'sezzle';
        this.onPaymentMethodOptionClick = (e) => {
            e.preventDefault();
            checkout_store.checkoutStore.selectedPaymentMethod = this.paymentMethodOptionId;
            this.paymentMethodOptionSelected.emit(this.paymentMethodOptionId);
        };
        this.initializeSezzleCheckout = () => {
            let resolveSezzlePromise;
            this.sezzlePromise = new Promise((resolve) => { resolveSezzlePromise = resolve; });
            const amount = Number(checkout_store.checkoutStore.paymentAmount);
            const Checkout = window.Checkout;
            const checkout = new Checkout({
                mode: 'popup',
                publicKey: checkout_store.checkoutStore.bnplProviderClientId,
                apiMode: checkout_store.checkoutStore.bnplProviderMode,
                apiVersion: checkout_store.checkoutStore.bnplProviderApiVersion,
            });
            checkout.sezzleButtonElement = this.sezzleButtonRef;
            checkout.init({
                onClick: function (event) {
                    event.preventDefault();
                    checkout.startCheckout({
                        checkout_url: checkout_store.checkoutStore.bnplProviderCheckoutUrl,
                    });
                },
                onComplete: (event) => resolveSezzlePromise({ bnpl: event.data }),
                onCancel: (event) => resolveSezzlePromise({ bnpl: event.data }),
                onFailure: (event) => resolveSezzlePromise({ bnpl: event.data }),
            });
            this.sezzleCheckout = checkout;
            this.installmentPlan = this.sezzleCheckout.getInstallmentPlan(amount);
        };
    }
    componentDidRender() {
        if (!this.scriptRef)
            return;
        this.scriptRef.onload = () => {
            this.sezzleButtonRef = document.createElement('button');
            this.initializeSezzleCheckout();
        };
    }
    async resolvePaymentMethod(insuranceValidation) {
        if (!insuranceValidation.isValid) {
            return { validationError: true };
        }
        this.sezzleButtonRef.click();
        return this.sezzlePromise;
    }
    render() {
        var _a, _b;
        if (!checkout_store.checkoutStore.bnplEnabled || checkout_store.checkoutStore.disableBnpl) {
            console.warn('justifi-sezzle-payment-method: BNPL is not enabled for this account.');
            return null;
        }
        return (index.h(styledHost.StyledHost, { class: "payment-method" }, index.h("script", { src: "https://checkout-sdk.sezzle.com/checkout.min.js", async: true, ref: (el) => (this.scriptRef = el) }), index.h("div", { class: "radio-list-item p-3", part: parts.radioListItem, onClick: this.onPaymentMethodOptionClick }, index.h("form-control-radio", { name: "paymentMethodType", value: this.paymentMethodOptionId, checked: checkout_store.checkoutStore.selectedPaymentMethod === this.paymentMethodOptionId, label: index.h("div", null, index.h("div", null, "Buy now, pay later with ", sezzleLogo), this.installmentPlan && (index.h("small", null, index.h("span", null, (_a = this.installmentPlan) === null || _a === void 0 ? void 0 : _a.installments.length), "\u00A0", index.h("span", null, this.installmentPlan.schedule, " payments of"), "\u00A0", index.h("span", { class: "fw-bold" }, utils.formatCurrency((_b = this.installmentPlan) === null || _b === void 0 ? void 0 : _b.installments[0].amountInCents))))) }))));
    }
};

const PaymentMethodOption = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
    }
    render() {
        return (index.h(styledHost.StyledHost, { key: 'a8c7ba94cf471c0b12f65c6fa9be1d1b6fc28910', class: "payment-method" }, index.h("div", { key: 'fae8daae8c7b3d00a5ba7a713522766bfe41dfae', class: "radio-list-item p-3", part: parts.radioListItem, onClick: this.clickHandler, hidden: this.radioButtonHidden }, index.h("form-control-radio", { key: '51b8f509374e771c9e0cd7ff463c8a3d3b9d9a35', name: "paymentMethodType", value: this.paymentMethodOptionId, checked: this.isSelected, label: this.label }))));
    }
};

exports.justifi_checkout_summary = Summary;
exports.justifi_modular_checkout = CheckoutWrapper;
exports.justifi_saved_payment_methods = SavedPaymentMethods;
exports.justifi_sezzle_payment_method = SezzlePaymentMethod;
exports.payment_method_option = PaymentMethodOption;
