'use strict';

var index = require('./index-D5bL1DOi.js');
require('./config-state-Dz9bnWHg.js');
require('./dinero-J-SRFKIR.js');
require('./ComponentError-CEv9ltwy.js');
var Refund = require('./Refund-08OcZkXX.js');
require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./Dispute-CruQTF6_.js');
var checkoutsListParamsState = require('./checkouts-list-params-state-DZUKBmLC.js');
var parts = require('./parts-9jMf1erK.js');
var styledHost = require('./styled-host-DXNHOiqW.js');
require('./event-types-YOY5TKUN.js');
require('./index-BCtVWU61.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./utils-DqlrBltg.js');
require('./helpers-B5OCqlIM.js');
require('./state-options-CIT9xdTz.js');

const CheckoutsListFilters = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.setParamsOnChange = (name, value) => {
            checkoutsListParamsState.filterParams[name] = value;
        };
    }
    componentWillLoad() {
        const propsToSet = {
            status: this.checkoutStatus,
            payment_mode: this.paymentMode,
        };
        Object.entries(propsToSet).forEach(([key, value]) => {
            if (value) {
                checkoutsListParamsState.propsParams[key] = value;
            }
        });
    }
    get checkoutStatusOptions() {
        return [
            { label: 'All', value: '' },
            { label: 'Created', value: Refund.ICheckoutStatus.created },
            { label: 'Completed', value: Refund.ICheckoutStatus.completed },
            { label: 'Attempted', value: Refund.ICheckoutStatus.attempted },
            { label: 'Expired', value: Refund.ICheckoutStatus.expired },
        ];
    }
    get checkoutPaymentModeOptions() {
        return [
            { label: 'All', value: '' },
            { label: 'E-commerce', value: Refund.ICheckoutPaymentModeParam.ecom },
            { label: 'BNPL', value: Refund.ICheckoutPaymentModeParam.bnpl },
        ];
    }
    render() {
        const filterMenuParams = Object.assign({}, checkoutsListParamsState.filterParams);
        return (index.h(styledHost.StyledHost, { key: '05a4d429a1acd7bbaf202872523284e2b2cd3677' }, index.h("table-filters-menu", { key: 'abf61654a75212537af580f3bfd2646042eaba8a', params: filterMenuParams, clearParams: checkoutsListParamsState.clearParams, part: parts.checkoutsListFilterMenu }, index.h("div", { key: 'f8e5cfe4b0a23723d0df939a1d1873adffcb1da9', class: "grid-cols-2 gap-3 p-1" }, index.h("div", { key: 'd9e23e96a7269b3609e690a1e64e8c20bd125cb7', class: "p-2" }, index.h("form-control-select", { key: 'e1899dbc615be07486bc54f8baa395bee776d8ce', name: "status", label: "Status", options: this.checkoutStatusOptions, inputHandler: this.setParamsOnChange, defaultValue: this.checkoutStatus || checkoutsListParamsState.filterParams.status, disabled: !!this.checkoutStatus, part: parts.statusCheckoutsListFilterParam })), index.h("div", { key: 'bedbc26d9d9f6906013ef4b80542d9031822b19c', class: "p-2" }, index.h("form-control-select", { key: '3bfef7fabeb85a29304e11093005bb1f58b23f41', name: "payment_mode", label: "Payment Mode", options: this.checkoutPaymentModeOptions, inputHandler: this.setParamsOnChange, defaultValue: this.paymentMode || checkoutsListParamsState.filterParams.payment_mode, disabled: !!this.paymentMode, part: parts.paymentModeCheckoutsListFilterParam }))))));
    }
};

exports.justifi_checkouts_list_filters = CheckoutsListFilters;
