'use strict';

var index = require('./index-D5bL1DOi.js');
var eventTypes = require('./event-types-BWQT2lwu.js');
var Dispute = require('./Dispute-CruQTF6_.js');

const DisputeManagementCore = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.errorEvent = index.createEvent(this, "error-event");
        this.isLoading = true;
        this.showDisputeResponseForm = false;
    }
    disputeResponseHandler(event) {
        if (event.detail.name === eventTypes.DisputeManagementClickActions.respondToDispute) {
            this.showDisputeResponseForm = true;
        }
        if (event.detail.name === eventTypes.DisputeManagementClickActions.cancelDispute) {
            this.showDisputeResponseForm = false;
        }
    }
    disputeSubmittedHandler() {
        this.fetchData();
    }
    componentWillLoad() {
        if (this.getDispute) {
            this.fetchData();
        }
    }
    updateOnPropChange() {
        this.fetchData();
    }
    fetchData() {
        this.isLoading = true;
        this.getDispute({
            onSuccess: ({ dispute }) => {
                this.dispute = new Dispute.Dispute(dispute);
                this.isLoading = false;
                if (this.dispute.status !== Dispute.DisputeStatus.needsResponse) {
                    this.showDisputeResponseForm = false;
                }
            },
            onError: ({ error, code, severity }) => {
                this.errorEvent.emit({
                    errorCode: code,
                    message: error,
                    severity,
                });
                this.isLoading = false;
            },
        });
    }
    render() {
        return (index.h("div", { key: 'b5a802e8c418b3b7f3235f43260186084a6ee079' }, this.showDisputeResponseForm ? (index.h("justifi-dispute-response", { disputeId: this.disputeId, disputeResponse: this.dispute.dispute_response, authToken: this.authToken })) : (index.h("justifi-dispute-notification", { dispute: this.dispute, authToken: this.authToken, isLoading: this.isLoading }))));
    }
    static get watchers() { return {
        "getDispute": ["updateOnPropChange"]
    }; }
};

exports.justifi_dispute_management_core = DisputeManagementCore;
