'use strict';

var index = require('./index-D5bL1DOi.js');
var Api = require('./Api-eP0XeJLd.js');
var ComponentError = require('./ComponentError-CEv9ltwy.js');
require('./Refund-08OcZkXX.js');
require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./Dispute-CruQTF6_.js');
var utils = require('./utils-IGCnjtqc.js');
var utils$1 = require('./utils-wkdkLmDI.js');
var checkPkgVersion = require('./check-pkg-version-DBocF2eE.js');
require('./config-state-Dz9bnWHg.js');
require('./index-BCtVWU61.js');
require('./utils-DqlrBltg.js');
require('./dinero-J-SRFKIR.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./helpers-B5OCqlIM.js');
require('./state-options-CIT9xdTz.js');
require('./parts-9jMf1erK.js');
require('./package-BM2FCIB8.js');

const api = Api.Api();
class ReportsService {
    async fetchGrossVolumeChartData(accountId, authToken) {
        const endpoint = `account/${accountId}/reports/gross_volume`;
        return api.get({ endpoint, authToken });
    }
}

const makeGetGrossPaymentChartData = ({ id, authToken, service }) => async ({ onSuccess, onError }) => {
    var _a;
    try {
        const response = await service.fetchGrossVolumeChartData(id, authToken);
        if (!response.error) {
            onSuccess(response.data);
        }
        else {
            const errorMessage = utils.getErrorMessage(response.error);
            const code = utils.getErrorCode((_a = response.error) === null || _a === void 0 ? void 0 : _a.code);
            onError({
                error: errorMessage,
                code,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
        }
    }
    catch (error) {
        const code = utils.getErrorCode(error === null || error === void 0 ? void 0 : error.code);
        const errorMessage = utils.getErrorMessage(error);
        onError({
            error: errorMessage,
            code,
            severity: ComponentError.ComponentErrorSeverity.ERROR,
        });
    }
};

const GrossPaymentChart = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.errorEvent = index.createEvent(this, "error-event");
        this.errorMessage = null;
        this.handleErrorEvent = (event) => {
            this.errorMessage = event.detail.message;
            this.errorEvent.emit(event.detail);
        };
    }
    componentWillLoad() {
        checkPkgVersion.checkPkgVersion();
        this.analytics = new checkPkgVersion.JustifiAnalytics(this);
        this.initializeGetGrossPayment();
    }
    disconnectedCallback() {
        var _a;
        (_a = this.analytics) === null || _a === void 0 ? void 0 : _a.cleanup();
    }
    ;
    propChanged() {
        this.initializeGetGrossPayment();
    }
    initializeGetGrossPayment() {
        if (this.accountId && this.authToken) {
            this.getGrossPayment = makeGetGrossPaymentChartData({
                id: this.accountId,
                authToken: this.authToken,
                service: new ReportsService(),
            });
        }
        else {
            this.errorMessage = 'Account ID and Auth Token are required';
            this.errorEvent.emit({
                errorCode: ComponentError.ComponentErrorCodes.MISSING_PROPS,
                message: this.errorMessage,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
        }
    }
    render() {
        if (this.errorMessage) {
            return utils$1.ErrorState(this.errorMessage);
        }
        return (index.h("gross-payment-chart-core", { getGrossPayment: this.getGrossPayment, "onError-event": this.handleErrorEvent }));
    }
    static get watchers() { return {
        "accountId": ["propChanged"],
        "authToken": ["propChanged"]
    }; }
};

exports.justifi_gross_payment_chart = GrossPaymentChart;
