'use strict';

var index = require('./index-D5bL1DOi.js');
var payment_service = require('./payment.service-C6kdaQYS.js');
var getPaymentDetails = require('./get-payment-details-C3qBZVdv.js');
var utils = require('./utils-wkdkLmDI.js');
var ComponentError = require('./ComponentError-CEv9ltwy.js');
var checkPkgVersion = require('./check-pkg-version-DBocF2eE.js');
require('./Api-eP0XeJLd.js');
require('./config-state-Dz9bnWHg.js');
require('./index-BCtVWU61.js');
require('./utils-DqlrBltg.js');
require('./dinero-J-SRFKIR.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./Refund-08OcZkXX.js');
require('./Dispute-CruQTF6_.js');
require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./helpers-B5OCqlIM.js');
require('./state-options-CIT9xdTz.js');
require('./utils-IGCnjtqc.js');
require('./parts-9jMf1erK.js');
require('./package-BM2FCIB8.js');

const PaymentDetails = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.errorEvent = index.createEvent(this, "error-event");
        this.errorMessage = null;
        this.paymentService = new payment_service.PaymentService();
        this.handleErrorEvent = event => {
            this.errorMessage = event.detail.message;
            this.errorEvent.emit(event.detail);
        };
    }
    componentWillLoad() {
        checkPkgVersion.checkPkgVersion();
        this.analytics = new checkPkgVersion.JustifiAnalytics(this);
        this.initializeGetPaymentDetails();
    }
    disconnectedCallback() {
        var _a;
        (_a = this.analytics) === null || _a === void 0 ? void 0 : _a.cleanup();
    }
    ;
    propChanged() {
        this.initializeGetPaymentDetails();
    }
    initializeGetPaymentDetails() {
        if (this.paymentId && this.authToken) {
            this.getPaymentDetails = getPaymentDetails.makeGetPaymentDetails({
                id: this.paymentId,
                authToken: this.authToken,
                service: new payment_service.PaymentService()
            });
        }
        else {
            this.errorMessage = 'Payment ID and Auth Token are required';
            this.errorEvent.emit({
                message: this.errorMessage,
                errorCode: ComponentError.ComponentErrorCodes.MISSING_PROPS,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
        }
    }
    render() {
        if (this.errorMessage) {
            return utils.ErrorState(this.errorMessage);
        }
        return (index.h("payment-details-core", { getPaymentDetails: this.getPaymentDetails, "onError-event": this.handleErrorEvent }));
    }
    static get watchers() { return {
        "paymentId": ["propChanged"],
        "authToken": ["propChanged"]
    }; }
};

exports.justifi_payment_details = PaymentDetails;
