'use strict';

var index = require('./index-D5bL1DOi.js');
var checkPkgVersion = require('./check-pkg-version-DBocF2eE.js');
var ComponentError = require('./ComponentError-CEv9ltwy.js');
var paymentProvisioningActions = require('./payment-provisioning-actions-SNMCdsyF.js');
var business_service = require('./business.service-CZrK48lv.js');
var Api = require('./Api-eP0XeJLd.js');
require('./Refund-08OcZkXX.js');
require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./Dispute-CruQTF6_.js');
require('./package-BM2FCIB8.js');
require('./utils-IGCnjtqc.js');
require('./config-state-Dz9bnWHg.js');
require('./index-BCtVWU61.js');
require('./utils-DqlrBltg.js');
require('./dinero-J-SRFKIR.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./helpers-B5OCqlIM.js');
require('./state-options-CIT9xdTz.js');

const api = Api.Api();
class ProvisionService {
    async postProvisioning(authToken, businessId, product) {
        const endpoint = `entities/provisioning`;
        const body = {
            business_id: businessId,
            product_category: product,
        };
        return api.post({ endpoint, body, authToken });
    }
}

const PaymentProvisioning = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.errorEvent = index.createEvent(this, "error-event");
        this.allowOptionalFields = false;
        this.formTitle = 'Business Information';
    }
    propChanged() {
        this.initializeApi();
    }
    componentWillLoad() {
        checkPkgVersion.checkPkgVersion();
        this.analytics = new checkPkgVersion.JustifiAnalytics(this);
        this.initializeApi();
    }
    disconnectedCallback() {
        var _a;
        (_a = this.analytics) === null || _a === void 0 ? void 0 : _a.cleanup();
    }
    ;
    initializeApi() {
        if (this.authToken && this.businessId) {
            this.getBusiness = paymentProvisioningActions.makeGetBusiness({
                authToken: this.authToken,
                businessId: this.businessId,
                service: new business_service.BusinessService()
            });
            this.postProvisioning = paymentProvisioningActions.makePostProvisioning({
                authToken: this.authToken,
                businessId: this.businessId,
                product: 'payment',
                service: new ProvisionService()
            });
        }
        else {
            this.errorEvent.emit({
                message: 'auth-token and business-id are required',
                errorCode: ComponentError.ComponentErrorCodes.MISSING_PROPS,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
        }
    }
    render() {
        return (index.h("justifi-payment-provisioning-core", { key: '6d77016584f204fdc4be5fd554b4eb1639e856ab', businessId: this.businessId, authToken: this.authToken, allowOptionalFields: this.allowOptionalFields, formTitle: this.formTitle, getBusiness: this.getBusiness, postProvisioning: this.postProvisioning }));
    }
    static get watchers() { return {
        "authToken": ["propChanged"],
        "businessId": ["propChanged"]
    }; }
};

exports.justifi_payment_provisioning = PaymentProvisioning;
