'use strict';

var index = require('./index-D5bL1DOi.js');
var payout_service = require('./payout.service-CLnAr59x.js');
require('./config-state-Dz9bnWHg.js');
require('./dinero-J-SRFKIR.js');
var ComponentError = require('./ComponentError-CEv9ltwy.js');
var Refund = require('./Refund-08OcZkXX.js');
require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./Dispute-CruQTF6_.js');
var utils = require('./utils-IGCnjtqc.js');
var utils$1 = require('./utils-wkdkLmDI.js');
var checkPkgVersion = require('./check-pkg-version-DBocF2eE.js');
var getPayoutCsv = require('./get-payout-csv-CdNRRH0t.js');
require('./Api-eP0XeJLd.js');
require('./utils-DqlrBltg.js');
require('./index-BCtVWU61.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./helpers-B5OCqlIM.js');
require('./state-options-CIT9xdTz.js');
require('./parts-9jMf1erK.js');
require('./package-BM2FCIB8.js');

const makeGetPayoutDetails = ({ id, authToken, service }) => async ({ onSuccess, onError }) => {
    var _a;
    try {
        const response = await service.fetchPayout(id, authToken);
        if (!response.error) {
            const payout = new Refund.Payout(response.data);
            onSuccess(payout);
        }
        else {
            const errorMessage = utils.getErrorMessage(response.error);
            const code = utils.getErrorCode((_a = response.error) === null || _a === void 0 ? void 0 : _a.code);
            onError({
                error: errorMessage,
                code,
                severity: ComponentError.ComponentErrorSeverity.ERROR,
            });
        }
    }
    catch (error) {
        const errorMessage = utils.getErrorMessage(error);
        const code = utils.getErrorCode(error === null || error === void 0 ? void 0 : error.code);
        onError({
            error: errorMessage,
            code,
            severity: ComponentError.ComponentErrorSeverity.ERROR,
        });
    }
};

const PayoutDetails = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.errorEvent = index.createEvent(this, "error-event");
        this.errorMessage = null;
        this.handleErrorEvent = (event) => {
            this.errorMessage = event.detail.message;
            this.errorEvent.emit(event.detail);
        };
    }
    componentWillLoad() {
        checkPkgVersion.checkPkgVersion();
        this.analytics = new checkPkgVersion.JustifiAnalytics(this);
        this.initializeServices();
    }
    disconnectedCallback() {
        var _a;
        (_a = this.analytics) === null || _a === void 0 ? void 0 : _a.cleanup();
    }
    ;
    propChanged() {
        this.initializeServices();
    }
    initializeServices() {
        if (this.payoutId && this.authToken) {
            this.getPayout = makeGetPayoutDetails({
                id: this.payoutId,
                authToken: this.authToken,
                service: new payout_service.PayoutService()
            });
            this.getPayoutCSV = getPayoutCsv.makeGetPayoutCSV({
                authToken: this.authToken,
                service: new payout_service.PayoutService()
            });
        }
        else {
            this.errorMessage = 'Failed to load payout details. payoutId or authToken is not provided.';
            this.errorEvent.emit({
                message: this.errorMessage,
                errorCode: ComponentError.ComponentErrorCodes.MISSING_PROPS,
                severity: ComponentError.ComponentErrorSeverity.ERROR
            });
        }
    }
    render() {
        if (this.errorMessage) {
            return utils$1.ErrorState(this.errorMessage);
        }
        return (index.h("payout-details-core", { getPayout: this.getPayout, getPayoutCSV: this.getPayoutCSV, "onError-event": this.handleErrorEvent }));
    }
    static get watchers() { return {
        "payoutId": ["propChanged"],
        "authToken": ["propChanged"]
    }; }
};

exports.justifi_payout_details = PayoutDetails;
