'use strict';

var index = require('./index-D5bL1DOi.js');
var payoutsListParamsState = require('./payouts-list-params-state-DZUKBmLC.js');
var parts = require('./parts-9jMf1erK.js');
var styledHost = require('./styled-host-DXNHOiqW.js');
require('./event-types-YOY5TKUN.js');
var utils = require('./utils-DqlrBltg.js');
require('./index-BCtVWU61.js');
require('./dinero-J-SRFKIR.js');
require('./_commonjsHelpers-BJu3ubxk.js');

const PayoutsListFilters = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.setParamsOnChange = (name, value) => {
            payoutsListParamsState.filterParams[name] = value;
        };
        this.handleDateInput = (name, value) => {
            const utcDate = utils.convertToUTC(value, { setEndOfDay: true });
            this.setParamsOnChange(name, utcDate);
        };
    }
    componentWillLoad() {
        const propsToSet = {
            created_after: this.createdAfter,
            created_before: this.createdBefore
        };
        Object.entries(propsToSet).forEach(([key, value]) => {
            if (value) {
                payoutsListParamsState.propsParams[key] = value;
            }
        });
    }
    render() {
        const filterMenuParams = Object.assign({}, payoutsListParamsState.filterParams);
        return (index.h(styledHost.StyledHost, { key: '3d52e500043d280ba63e03095096c77fe253106e' }, index.h("table-filters-menu", { key: '4dd85f33336a26692bbcdac30cdde6f4f091213a', params: filterMenuParams, clearParams: payoutsListParamsState.clearParams, part: parts.payoutsListFilterMenu }, index.h("div", { key: 'f093372ebbf5841a80cf8e05cd26c8f8c992db59', class: "grid-cols-2 gap-3 p-1" }, index.h("div", { key: 'cc4ed47e4b8373bd787621dda6e9327581d359cb', class: "p-2" }, index.h("form-control-date", { key: '3f176b4fb1ec7efadf2ce38479695f9d9df2b5f1', name: "created_after", label: "Created After", inputHandler: this.handleDateInput, defaultValue: utils.convertToLocal(this.createdAfter, { showInputDate: true }) ||
                utils.convertToLocal(payoutsListParamsState.filterParams.created_after, { showInputDate: true }), disabled: !!this.createdAfter, part: parts.createdAfterPayoutsListFilterParam })), index.h("div", { key: '5eabb3a72a3c223512ccf584cf5b7ee901594b30', class: "p-2" }, index.h("form-control-date", { key: '8ba7230275b3b89f75f1c9d5fa654c493d626940', name: "created_before", label: "Created Before", inputHandler: this.handleDateInput, defaultValue: utils.convertToLocal(this.createdBefore, { showInputDate: true }) ||
                utils.convertToLocal(payoutsListParamsState.filterParams.created_before, { showInputDate: true }), disabled: !!this.createdBefore, part: parts.createdBeforePayoutsListFilterParam }))))));
    }
};

exports.justifi_payouts_list_filters = PayoutsListFilters;
