'use strict';

var index = require('./index-D5bL1DOi.js');
var utils = require('./utils-DqlrBltg.js');
var insuranceState = require('./insurance-state-kH0kuTD8.js');
var parts = require('./parts-9jMf1erK.js');
var styledHost = require('./styled-host-DXNHOiqW.js');
var header2 = require('./header-2-BXQLJn1q.js');
require('./event-types-YOY5TKUN.js');
var skeleton = require('./skeleton-CbZBGO47.js');
require('./dinero-J-SRFKIR.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./index-BCtVWU61.js');

const SeasonInterruptionInsuranceLoading = () => (index.h("div", { class: "row gap-3" },
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "35%", height: "30px" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "70%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "40%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "40%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "100%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "80%" }))));

const SeasonInterruptionInsuranceCore = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.insuranceUpdated = index.createEvent(this, "insurance-updated");
        this.errorEvent = index.createEvent(this, "error-event");
        this.isLoading = true;
    }
    async validate() {
        return insuranceState.validateInsuranceValues();
    }
    componentWillLoad() {
        if (this.getQuote) {
            this.fetchData();
        }
    }
    ;
    fetchData() {
        this.isLoading = true;
        this.getQuote({
            payload: {
                checkout_id: this.checkoutId,
                policy_type: "season_interruption",
                primary_identity: {
                    state: this.primaryIdentityState,
                    email: this.primaryIdentityEmailAddress,
                    first_name: this.primaryIdentityFirstName,
                    last_name: this.primaryIdentityLastName,
                    postal_code: this.primaryIdentityPostalCode,
                    country: this.primaryIdentityCountry
                },
                policy_attributes: {
                    insurable_amount: this.policyAttributesInsurableAmount,
                    start_date: this.policyAttributesStartDate,
                    end_date: this.policyAttributesEndDate,
                    covered_identity: {
                        first_name: this.coveredIdentityFirstName,
                        last_name: this.coveredIdentityLastName
                    }
                }
            },
            onSuccess: ({ quote }) => {
                this.quote = quote;
                this.quote.product.description = utils.processHTML(this.quote.product.description, [
                    (html) => utils.removeAttribute(html, 'style'),
                    (html) => utils.addAttribute(html, 'a', 'part', parts.text)
                ]);
                this.quote.product.legal_disclaimer = utils.processHTML(this.quote.product.legal_disclaimer, [
                    (html) => utils.removeAttribute(html, 'style'),
                    (html) => utils.addAttribute(html, 'a', 'part', parts.text)
                ]);
                insuranceState.insuranceValues[quote.policy_type] = quote.accepted;
                this.isLoading = false;
            },
            onError: ({ error, code, severity }) => {
                this.isLoading = false;
                this.errorEvent.emit({
                    errorCode: code,
                    message: error,
                    severity,
                });
            }
        });
    }
    ;
    onChangeHandler(_name, value) {
        this.accepted = value;
        insuranceState.insuranceErrors[this.quote.policy_type] = false;
        this.toggleCoverage({
            quoteId: this.quote.id,
            payload: { accepted: this.accepted },
            onSuccess: () => {
                this.insuranceUpdated.emit();
                insuranceState.insuranceValues[this.quote.policy_type] = this.accepted;
            },
            onError: ({ error, code, severity }) => {
                this.errorEvent.emit({
                    errorCode: code,
                    message: error,
                    severity,
                });
            }
        });
    }
    get error() {
        var _a;
        return insuranceState.insuranceErrors[(_a = this.quote) === null || _a === void 0 ? void 0 : _a.policy_type];
    }
    render() {
        var _a, _b, _c, _d;
        if (this.isLoading)
            return (index.h(styledHost.StyledHost, null, index.h(SeasonInterruptionInsuranceLoading, null)));
        return (index.h(styledHost.StyledHost, null, index.h(header2.Header2, { text: (_a = this.quote) === null || _a === void 0 ? void 0 : _a.product.title, class: "fs-5 fw-bold pb-3" }), index.h("small", { innerHTML: (_b = this.quote) === null || _b === void 0 ? void 0 : _b.product.description, part: parts.text }), index.h("form-control-radio", { label: `Accept coverage for ${utils.formatCurrency((_c = this.quote) === null || _c === void 0 ? void 0 : _c.total_cents)}`, name: "opt-in", value: 'true', checked: this.accepted === 'true', inputHandler: this.onChangeHandler.bind(this),
            // don't wanna show error message, but need to show the red border
            errorText: this.error ? ' ' : undefined }), index.h("form-control-radio", { label: "Decline coverage", name: "opt-in", value: 'false', checked: this.accepted === 'false', inputHandler: this.onChangeHandler.bind(this), errorText: this.error ? ' ' : undefined }), index.h("div", { class: "invalid-feedback", style: { display: this.error ? 'block' : 'none' }, part: parts.textDanger }, "Please select an option"), index.h("small", { innerHTML: (_d = this.quote) === null || _d === void 0 ? void 0 : _d.product.legal_disclaimer, part: parts.text })));
    }
};

exports.justifi_season_interruption_insurance_core = SeasonInterruptionInsuranceCore;
