'use strict';

var index = require('./index-D5bL1DOi.js');
var terminalOrdersListParamsState = require('./terminal-orders-list-params-state-DZUKBmLC.js');
var parts = require('./parts-9jMf1erK.js');
var styledHost = require('./styled-host-DXNHOiqW.js');
require('./event-types-YOY5TKUN.js');
require('./config-state-Dz9bnWHg.js');
var utils = require('./utils-DqlrBltg.js');
require('./ComponentError-CEv9ltwy.js');
var Refund = require('./Refund-08OcZkXX.js');
require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./Dispute-CruQTF6_.js');
require('./index-BCtVWU61.js');
require('./dinero-J-SRFKIR.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./helpers-B5OCqlIM.js');
require('./state-options-CIT9xdTz.js');

const TerminalOrdersListFilters = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.setParamsOnChange = (name, value) => {
            terminalOrdersListParamsState.filterParams[name] = value;
        };
        this.handleDateInput = (name, value) => {
            const utcDate = utils.convertToUTC(value, { setExactTime: true });
            this.setParamsOnChange(name, utcDate);
        };
    }
    componentWillLoad() {
        const propsToSet = {
            order_status: this.orderStatus,
            order_type: this.orderType,
            created_after: this.createdAfter,
            created_before: this.createdBefore
        };
        Object.entries(propsToSet).forEach(([key, value]) => {
            if (value) {
                terminalOrdersListParamsState.propsParams[key] = value;
            }
        });
    }
    get terminalOrderStatusOptions() {
        return [
            { label: 'All', value: '' },
            { label: 'Created', value: Refund.TerminalOrderStatus.created },
            { label: 'Completed', value: Refund.TerminalOrderStatus.completed },
            { label: 'Submitted', value: Refund.TerminalOrderStatus.submitted },
            { label: 'In Progress', value: Refund.TerminalOrderStatus.in_progress },
            { label: 'On Hold', value: Refund.TerminalOrderStatus.on_hold },
            { label: 'Canceled', value: Refund.TerminalOrderStatus.canceled }
        ];
    }
    get terminalOrderTypeOptions() {
        return [
            { label: 'All', value: '' },
            { label: 'Boarding Only', value: Refund.TerminalOrderType.boardingOnly },
            { label: 'Boarding Shipping', value: Refund.TerminalOrderType.boardingShipping },
        ];
    }
    render() {
        const filterMenuParams = Object.assign({}, terminalOrdersListParamsState.filterParams);
        return (index.h(styledHost.StyledHost, { key: '24b9da56d6bef1aa545007f2dba95b1da7fa4f4d' }, index.h("table-filters-menu", { key: 'ac3c26800fff2176782cf8240916cfd7e9a20333', params: filterMenuParams, clearParams: terminalOrdersListParamsState.clearParams, part: parts.terminalOrdersListFilterMenu }, index.h("div", { key: 'cf11a3bc06453a9970120d0ac05334754a51181b', class: "grid-cols-2 gap-3 p-1" }, index.h("div", { key: 'e72c2e114463c57e0de6042f2b3c419359f416ab', class: "p-2" }, index.h("form-control-select", { key: 'b2a3d66f6c0bb9fcf1da45cddc0b9df78ffa5ef8', name: "order_status", label: "Order Status", options: this.terminalOrderStatusOptions, inputHandler: this.setParamsOnChange, defaultValue: this.orderStatus || terminalOrdersListParamsState.filterParams.order_status, disabled: !!this.orderStatus, part: parts.orderStatusTerminalOrdersListFilterParam })), index.h("div", { key: '944a5f0ff5ff2fb87bee60da154b8dd03660e4f3', class: "p-2" }, index.h("form-control-select", { key: '992921c6f9ecf20587f814f87a44179db3fe49fd', name: "order_type", label: "Order Type", options: this.terminalOrderTypeOptions, inputHandler: this.setParamsOnChange, defaultValue: this.orderType || terminalOrdersListParamsState.filterParams.order_type, disabled: !!this.orderType, part: parts.orderTypeTerminalOrdersListFilterParam })), index.h("div", { key: '5acb3775b09fd508cfc77bf4b309cf43ca71a47a', class: "p-2" }, index.h("form-control-date", { key: '2b712d2c2903f2d579ada15a0e27eb97cc38c2f9', name: "created_after", label: "Created After", inputHandler: this.handleDateInput, defaultValue: utils.convertToLocal(this.createdAfter, { showInputDateTime: true }) ||
                utils.convertToLocal(terminalOrdersListParamsState.filterParams.created_after, { showInputDateTime: true }), showTime: true, disabled: !!this.createdAfter, part: parts.createdAfterTerminalOrdersListFilterParam })), index.h("div", { key: '66dae53f3fe0a6147570b15e6e85f7a821d7a322', class: "p-2" }, index.h("form-control-date", { key: '3715aab2b7637c67b1373bd0135a8a35c2b5a34c', name: "created_before", label: "Created Before", inputHandler: this.handleDateInput, defaultValue: utils.convertToLocal(this.createdBefore, { showInputDateTime: true }) ||
                utils.convertToLocal(terminalOrdersListParamsState.filterParams.created_before, { showInputDateTime: true }), showTime: true, disabled: !!this.createdBefore, part: parts.createdBeforeTerminalOrdersListFilterParam }))))));
    }
};

exports.justifi_terminal_orders_list_filters = TerminalOrdersListFilters;
