'use strict';

var index = require('./index-D5bL1DOi.js');
var lodash = require('./lodash-CvSCBJ_8.js');
var terminalsListParamsState = require('./terminals-list-params-state-DZUKBmLC.js');
var parts = require('./parts-9jMf1erK.js');
var styledHost = require('./styled-host-DXNHOiqW.js');
require('./event-types-YOY5TKUN.js');
require('./config-state-Dz9bnWHg.js');
require('./dinero-J-SRFKIR.js');
require('./ComponentError-CEv9ltwy.js');
var Refund = require('./Refund-08OcZkXX.js');
require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./Dispute-CruQTF6_.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./index-BCtVWU61.js');
require('./utils-DqlrBltg.js');
require('./helpers-B5OCqlIM.js');
require('./state-options-CIT9xdTz.js');

const TerminalsListFilters = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.setParamsOnChange = (name, value) => {
            terminalsListParamsState.filterParams[name] = value;
        };
    }
    componentWillLoad() {
        // debounced input handler for text input
        this.debouncedSetParamsOnChange = lodash.lodashExports.debounce(this.setParamsOnChange, 300);
        const propsToSet = {
            terminal_id: this.terminalId,
            status: this.terminalStatus,
            terminal_order_id: this.terminalOrderId
        };
        Object.entries(propsToSet).forEach(([key, value]) => {
            if (value) {
                terminalsListParamsState.propsParams[key] = value;
            }
        });
    }
    get terminalStatusOptions() {
        return [
            { label: 'All', value: '' },
            { label: 'Connected', value: Refund.ITerminalStatus.connected },
            { label: 'Disconnected', value: Refund.ITerminalStatus.disconnected },
            { label: 'Unknown', value: Refund.ITerminalStatus.unknown },
            { label: 'Pending Configuration', value: Refund.ITerminalStatus.pending_configuration }
        ];
    }
    render() {
        const filterMenuParams = Object.assign({}, terminalsListParamsState.filterParams);
        return (index.h(styledHost.StyledHost, { key: 'a5fe1671dd03e1290544f3deaf5aa01b5d937d9d' }, index.h("table-filters-menu", { key: 'f7a3d95c1b0ad0b52b96f990fd56fdbe64643493', params: filterMenuParams, clearParams: terminalsListParamsState.clearParams, part: parts.terminalsListFilterMenu }, index.h("div", { key: '92b0144a5ab7eee377e053e9b006af846ac43d64', class: "grid-cols-2 gap-3 p-1" }, index.h("div", { key: '3970a2e11f3be7953af299be4825166a829e9a0a', class: "p-2" }, index.h("form-control-text", { key: '0653692eaffdb14b092643a9f3c1b8e126c942db', name: "terminal_id", label: "Terminal ID", inputHandler: this.debouncedSetParamsOnChange, defaultValue: this.terminalId || terminalsListParamsState.filterParams.terminal_id, disabled: !!this.terminalId, part: parts.terminalIdTerminalsListFilterParam })), index.h("div", { key: 'c9d152d0a2d7e7b7fd7e72693a2248a020545a24', class: "p-2" }, index.h("form-control-text", { key: '785e7b382d9cadb72e242a379f2525b2da5140de', name: "terminal_order_id", label: "Terminal Order ID", inputHandler: this.debouncedSetParamsOnChange, defaultValue: this.terminalOrderId || terminalsListParamsState.filterParams.terminal_order_id, disabled: !!this.terminalOrderId, part: parts.terminalOrderIdTerminalsListFilterParam })), index.h("div", { key: 'f4f1e79eb81a72dd25bb4f4c14450ca82657f213', class: "p-2" }, index.h("form-control-select", { key: '52b390e42309e13e2f09df0681392bbf8e84aed8', name: "status", label: "Status", options: this.terminalStatusOptions, inputHandler: this.setParamsOnChange, defaultValue: this.terminalStatus || terminalsListParamsState.filterParams.status, disabled: !!this.terminalStatus, part: parts.terminalStatusTerminalsListFilterParam }))))));
    }
};

exports.justifi_terminals_list_filters = TerminalsListFilters;
