'use strict';

// Basic
const color = 'color';
const fontFamily = 'font-family';
const backgroundColor = 'background-color';
// Typography
const text = `text ${color} ${fontFamily}`;
const textDanger = `text-danger ${text}`;
const heading = `heading ${text}`;
const heading1 = `heading-1 ${heading}`;
const heading2 = `heading-2 ${heading}`;
const heading3 = `heading-3 ${heading}`;
const heading4 = `heading-4 ${heading}`;
const heading5 = `heading-5 ${heading}`;
// Button
const button = `button ${text}`;
const buttonPrimary = `button-primary ${button}`;
const buttonSecondary = `button-secondary ${button}`;
const buttonLink = `button-link ${button}`;
const buttonLoading = `button-loading`;
const buttonDisabled = `button-disabled ${button}`;
// Input
const label = `label ${text}`;
const input = `input ${text} ${backgroundColor}`;
const inputGroup = `input-group ${input}`;
const inputInvalid = `input-invalid ${input}`;
const inputDisabled = `input-disabled ${input}`;
const inputFocused = `input-focused ${input}`;
const inputInvalidAndFocused = `input-invalid-and-focused ${input}`;
const inputRadio = `input-radio`;
const inputRadioFocused = `input-radio-focused ${inputRadio}`;
const inputRadioChecked = `input-radio-checked ${inputRadio}`;
const inputRadioCheckedFocused = `input-radio-checked-focused ${inputRadio}`;
const inputRadioInvalid = `input-radio-invalid ${inputRadio}`;
const inputCheckbox = `input-checkbox`;
const inputCheckboxInvalid = `input-checkbox-invalid ${inputCheckbox}`;
const inputCheckboxFocused = `input-checkbox-focused ${inputCheckbox}`;
const inputCheckboxChecked = `input-checkbox-checked ${inputCheckbox}`;
const inputCheckboxCheckedFocused = `input-checkbox-checked-focused ${inputCheckbox}`;
const inputAdornment = `input-adornment ${text}`;
// Alert
const alert = `alert ${text}`;
const alertDanger = `alert-danger ${alert}`;
// Tooltip
const tooltip = `tooltip ${text}`;
const tooltipIcon = `tooltip-icon ${text}`;
const tooltipInner = `tooltip-inner ${text}`;
// Card
const card = `card ${text} ${backgroundColor}`;
// Table
const table = `table ${text} ${backgroundColor}`;
const tableRow = `table-row ${text} ${backgroundColor}`;
const tableCell = `table-cell ${text} ${backgroundColor}`;
const tableHead = `table-head`;
const tableHeadRow = `table-head-row ${text} ${backgroundColor}`;
const tableHeadCell = `table-head-cell ${tableCell}`;
const tableFoot = `table-foot`;
const tableFootRow = `table-foot-row ${text} ${backgroundColor}`;
const tableFootCell = `table-foot-cell ${tableCell}`;
const tableCellEven = `table-cell-even ${tableCell}`;
const tableCellOdd = `table-cell-odd ${tableCell}`;
const getAlternateTableCellPart = (index) => index % 2 ? tableCellEven : tableCellOdd;
const tableEmpty = `table-empty ${text} ${backgroundColor}`;
const tableError = `table-error ${text} ${backgroundColor}`;
// Pagination
const paginationButton = `pagination-button ${button}`;
const paginationButtonDisabled = `pagination-button-disabled ${buttonDisabled}`;
const paginationButtonText = `pagination-button-text ${text}`;
const paginationButtonIcon = `pagination-button-icon ${text}`;
const paginationButtonIconNext = `pagination-button-icon-next ${paginationButtonIcon}`;
const paginationButtonIconPrevious = `pagination-button-icon-previous ${paginationButtonIcon}`;
// Loading spinner
const loadingSpinner = `loading-spinner`;
// Badge
const badge = `badge ${fontFamily}`;
const badgePrimary = `${badge} badge-primary`;
const badgeSecondary = `${badge} badge-secondary`;
const badgeSuccess = `${badge} badge-success`;
const badgeDanger = `${badge} badge-danger`;
const badgeWarning = `${badge} badge-warning`;
const badgeInfo = `${badge} badge-info`;
const badgeLight = `${badge} badge-light`;
const badgeDark = `${badge} badge-dark`;
// Dropdown-menu
const dropdownMenu = `dropdown-menu ${text}`;
const dropdownMenuButton = `dropdown-menu-button ${buttonPrimary}`;
// Radio List Item
const radioListItem = `radio-list-item ${text}`;
// Skeleton
const skeleton = `skeleton`;
// Image
const image = `image`;
// Component specific
// This allows specific sections of a component to be hidden, for example
// ::part(billing-form) { display: none; }
const billingForm = `billing-form`;
const checkoutSummary = `checkout-summary`;
// Filters
const filterMenu = `filter-menu`;
// Payments List Filters
const paymentsListFilterMenu = `${filterMenu} payments-list-filter-menu`;
const paymentsListFilterParam = `payments-list-filter-param`;
const paymentIdPaymentsListFilterParam = `${paymentsListFilterParam} payment-id-payments-list-filter-param`;
const terminalIdPaymentsListFilterParam = `${paymentsListFilterParam} terminal-id-payments-list-filter-param`;
const paymentStatusPaymentsListFilterParam = `${paymentsListFilterParam} payment-status-payments-list-filter-param`;
const createdAfterPaymentsListFilterParam = `${paymentsListFilterParam} created-after-payments-list-filter-param`;
const createdBeforePaymentsListFilterParam = `${paymentsListFilterParam} created-before-payments-list-filter-param`;
// Payouts List Filters
const payoutsListFilterMenu = `${filterMenu} payouts-list-filter-menu`;
const payoutsListFilterParam = `payouts-list-filter-param`;
const createdAfterPayoutsListFilterParam = `${payoutsListFilterParam} created-after-payouts-list-filter-param`;
const createdBeforePayoutsListFilterParam = `${payoutsListFilterParam} created-before-payouts-list-filter-param`;
// Checkouts List Filters
const checkoutsListFilterMenu = `${filterMenu} checkouts-list-filter-menu`;
const checkoutsListFilterParam = `checkouts-list-filter-param`;
const statusCheckoutsListFilterParam = `${checkoutsListFilterParam} checkout-status-checkouts-list-filter-param`;
const paymentModeCheckoutsListFilterParam = `${checkoutsListFilterParam} payment-mode-checkouts-list-filter-param`;
// Terminals List Filters
const terminalsListFilterMenu = `${filterMenu} terminals-list-filter-menu`;
const terminalsListFilterParam = `terminals-list-filter-param`;
const terminalIdTerminalsListFilterParam = `${terminalsListFilterParam} terminal-id-terminals-list-filter-param`;
const terminalOrderIdTerminalsListFilterParam = `${terminalsListFilterParam} terminal-order-id-terminals-list-filter-param`;
const terminalStatusTerminalsListFilterParam = `${terminalsListFilterParam} terminal-status-terminals-list-filter-param`;
// Terminal Orders List Filters
const terminalOrdersListFilterMenu = `${filterMenu} terminal-orders-list-filter-menu`;
const terminalOrdersListFilterParam = `terminal-orders-list-filter-param`;
const orderStatusTerminalOrdersListFilterParam = `${terminalOrdersListFilterParam} order-status-terminal-orders-list-filter-param`;
const orderTypeTerminalOrdersListFilterParam = `${terminalOrdersListFilterParam} order-type-terminal-orders-list-filter-param`;
const createdAfterTerminalOrdersListFilterParam = `${terminalOrdersListFilterParam} created-after-terminal-orders-list-filter-param`;
const createdBeforeTerminalOrdersListFilterParam = `${terminalOrdersListFilterParam} created-before-terminal-orders-list-filter-param`;

exports.alertDanger = alertDanger;
exports.badge = badge;
exports.badgeDanger = badgeDanger;
exports.badgeDark = badgeDark;
exports.badgeInfo = badgeInfo;
exports.badgeLight = badgeLight;
exports.badgePrimary = badgePrimary;
exports.badgeSecondary = badgeSecondary;
exports.badgeSuccess = badgeSuccess;
exports.badgeWarning = badgeWarning;
exports.billingForm = billingForm;
exports.buttonLink = buttonLink;
exports.buttonLoading = buttonLoading;
exports.buttonPrimary = buttonPrimary;
exports.buttonSecondary = buttonSecondary;
exports.card = card;
exports.checkoutSummary = checkoutSummary;
exports.checkoutsListFilterMenu = checkoutsListFilterMenu;
exports.createdAfterPaymentsListFilterParam = createdAfterPaymentsListFilterParam;
exports.createdAfterPayoutsListFilterParam = createdAfterPayoutsListFilterParam;
exports.createdAfterTerminalOrdersListFilterParam = createdAfterTerminalOrdersListFilterParam;
exports.createdBeforePaymentsListFilterParam = createdBeforePaymentsListFilterParam;
exports.createdBeforePayoutsListFilterParam = createdBeforePayoutsListFilterParam;
exports.createdBeforeTerminalOrdersListFilterParam = createdBeforeTerminalOrdersListFilterParam;
exports.dropdownMenu = dropdownMenu;
exports.dropdownMenuButton = dropdownMenuButton;
exports.getAlternateTableCellPart = getAlternateTableCellPart;
exports.heading1 = heading1;
exports.heading2 = heading2;
exports.heading3 = heading3;
exports.heading4 = heading4;
exports.heading5 = heading5;
exports.image = image;
exports.input = input;
exports.inputAdornment = inputAdornment;
exports.inputCheckbox = inputCheckbox;
exports.inputCheckboxChecked = inputCheckboxChecked;
exports.inputCheckboxCheckedFocused = inputCheckboxCheckedFocused;
exports.inputCheckboxFocused = inputCheckboxFocused;
exports.inputCheckboxInvalid = inputCheckboxInvalid;
exports.inputDisabled = inputDisabled;
exports.inputFocused = inputFocused;
exports.inputGroup = inputGroup;
exports.inputInvalid = inputInvalid;
exports.inputInvalidAndFocused = inputInvalidAndFocused;
exports.inputRadio = inputRadio;
exports.inputRadioChecked = inputRadioChecked;
exports.inputRadioCheckedFocused = inputRadioCheckedFocused;
exports.inputRadioFocused = inputRadioFocused;
exports.inputRadioInvalid = inputRadioInvalid;
exports.label = label;
exports.loadingSpinner = loadingSpinner;
exports.orderStatusTerminalOrdersListFilterParam = orderStatusTerminalOrdersListFilterParam;
exports.orderTypeTerminalOrdersListFilterParam = orderTypeTerminalOrdersListFilterParam;
exports.paginationButton = paginationButton;
exports.paginationButtonDisabled = paginationButtonDisabled;
exports.paginationButtonIconNext = paginationButtonIconNext;
exports.paginationButtonIconPrevious = paginationButtonIconPrevious;
exports.paginationButtonText = paginationButtonText;
exports.paymentIdPaymentsListFilterParam = paymentIdPaymentsListFilterParam;
exports.paymentModeCheckoutsListFilterParam = paymentModeCheckoutsListFilterParam;
exports.paymentStatusPaymentsListFilterParam = paymentStatusPaymentsListFilterParam;
exports.paymentsListFilterMenu = paymentsListFilterMenu;
exports.payoutsListFilterMenu = payoutsListFilterMenu;
exports.radioListItem = radioListItem;
exports.skeleton = skeleton;
exports.statusCheckoutsListFilterParam = statusCheckoutsListFilterParam;
exports.table = table;
exports.tableCell = tableCell;
exports.tableEmpty = tableEmpty;
exports.tableError = tableError;
exports.tableFoot = tableFoot;
exports.tableFootCell = tableFootCell;
exports.tableFootRow = tableFootRow;
exports.tableHead = tableHead;
exports.tableHeadCell = tableHeadCell;
exports.tableHeadRow = tableHeadRow;
exports.tableRow = tableRow;
exports.terminalIdPaymentsListFilterParam = terminalIdPaymentsListFilterParam;
exports.terminalIdTerminalsListFilterParam = terminalIdTerminalsListFilterParam;
exports.terminalOrderIdTerminalsListFilterParam = terminalOrderIdTerminalsListFilterParam;
exports.terminalOrdersListFilterMenu = terminalOrdersListFilterMenu;
exports.terminalStatusTerminalsListFilterParam = terminalStatusTerminalsListFilterParam;
exports.terminalsListFilterMenu = terminalsListFilterMenu;
exports.text = text;
exports.textDanger = textDanger;
exports.tooltip = tooltip;
exports.tooltipIcon = tooltipIcon;
exports.tooltipInner = tooltipInner;
