'use strict';

var index = require('./index-D5bL1DOi.js');
var utils$1 = require('./utils-DqlrBltg.js');
var paymentsStatus = require('./payments-status-DG50GuXR.js');
var utils = require('./utils-wkdkLmDI.js');
var styledHost = require('./styled-host-DXNHOiqW.js');
require('./event-types-YOY5TKUN.js');
var skeleton = require('./skeleton-CbZBGO47.js');
var badge = require('./badge-DDksduwk.js');
require('./dinero-J-SRFKIR.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./parts-9jMf1erK.js');

const PaymentDetailsLoading = () => (index.h("div", { class: "row gap-3" },
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "35%", height: "30px" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "70%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "40%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "40%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "100%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "80%" }))));

const PaymentDetailsCore = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.errorEvent = index.createEvent(this, "error-event");
        this.loading = true;
    }
    componentWillLoad() {
        if (this.getPaymentDetails) {
            this.fetchData();
        }
    }
    updateOnPropChange() {
        this.fetchData();
    }
    fetchData() {
        this.loading = true;
        this.getPaymentDetails({
            onSuccess: ({ payment }) => {
                this.payment = payment;
                this.errorMessage = null;
            },
            onError: ({ error, code, severity }) => {
                this.errorMessage = error;
                this.errorEvent.emit({
                    errorCode: code,
                    message: error,
                    severity,
                });
            },
            final: () => {
                this.loading = false;
            },
        });
    }
    render() {
        return (index.h(styledHost.StyledHost, { key: '5acae57b23c12cd033e876b7064fa1da53527113' }, this.loading && index.h(PaymentDetailsLoading, { key: 'db42d6d60e76de571551a20e01bea700ed4e16f4' }), !this.loading && this.errorMessage && utils.ErrorState(this.errorMessage), !this.loading && !this.errorMessage &&
            this.payment && (index.h("justifi-details", { key: '36e906b2df77fccb24603d1c7253d5b935e4465e', "error-message": this.errorMessage }, index.h(utils.EntityHeadInfo, { key: '49bc76fa5f5e58dc148d7037ff95271124498e5d', slot: "head-info", badge: (index.h("div", { class: "d-flex gap-1" }, paymentsStatus.MapPaymentStatusToBadge(this.payment.status), this.payment.expedited ? (index.h(badge.Badge, { variant: badge.BadgeVariant.WARNING, title: "Expedited", text: "Expedited" })) : null)), title: this.payment.formattedPaymentAmount(this.payment.amount) }, index.h(utils.EntityHeadInfoItem, { key: '4f22b26195f8d122d8fe6e40a19bbbb4004abea4', classes: "border-1 border-end", title: "Updated At", value: `${utils$1.formatDate(this.payment.updated_at)} ${utils$1.formatTime(this.payment.updated_at)}` }), index.h(utils.EntityHeadInfoItem, { key: '416770f35ca9cda497bd78b94f45add5a9aa183c', classes: "border-1 border-end", title: "Created At", value: `${utils$1.formatDate(this.payment.created_at)} ${utils$1.formatTime(this.payment.created_at)}` }), index.h(utils.EntityHeadInfoItem, { key: 'd51a299c1fb98496301acba116fbc8bd02308f16', title: "ID", value: this.payment.id })), index.h("div", { key: '6e7bd343cbad8f74b698f83941255a5eba2a712c', slot: 'detail-sections' }, index.h(utils.DetailSectionTitle, { key: 'c99dbf37a902826e4168820735a562632bf00fc1', sectionTitle: "Details" }), index.h("div", { key: '2d3e8d4483fa3043db2d3ee384723ef033b0fd77', class: "d-table gap-2 w-100" }, index.h(utils.DetailItem, { key: '4d9d3e926535cd2d90d5d9808383c34885b5f0bf', title: "Amount", value: this.payment.formattedPaymentAmount(this.payment.amount) }), index.h(utils.DetailItem, { key: '39d2a6c2cb0ee10a878fc80833e168d16ddb1420', title: "Fees", value: this.payment.formattedPaymentAmount(this.payment.fee_amount) }), index.h(utils.DetailItem, { key: 'b55e1317033cd5f1fe8778cec6764cc445fe30de', title: "Refunded", value: this.payment.formattedPaymentAmount(this.payment.amount_refunded) }), index.h(utils.DetailItem, { key: 'e08773e47e04eb24d78076a2012909e9cc9e66e2', title: "Net", value: this.payment.formattedPaymentAmount(this.payment.balance) }), index.h(utils.DetailItem, { key: 'd215a59f20ce0799cce191b7b1b8b9104adf31b2', title: "Status", value: paymentsStatus.MapPaymentStatusToBadge(this.payment.status) }), index.h(utils.DetailItem, { key: '7bdc91d6a9ea0ea6d1356e293be6b096cbe3fdd6', title: "Payment ID", value: this.payment.id }), index.h(utils.DetailItem, { key: 'df04e3d0f29519fb0155d6c3dbe2789777eea4e8', title: "Processing Fees", value: this.payment.formattedPaymentAmount(this.payment.fee_amount) }), index.h(utils.DetailItem, { key: '94e55b409ebe4d29c92f49b0e17b4934c40cec17', title: "Statement Descriptor", value: this.payment.statement_descriptor }), index.h(utils.DetailItem, { key: 'b16820e416b57838fb9ee41ebb7968d2d87b0922', title: "Description", value: this.payment.description }), index.h(utils.DetailItem, { key: 'f52579f2da829f16014a68e3f85f5544327e0da2', title: "Expedited", value: this.payment.expedited ? 'Yes' : 'No' })), this.payment.payment_method.card && [
            index.h(utils.DetailSectionTitle, { key: 'fb8174ebec4bff736f0d8ae9f25ec33592d083ba', sectionTitle: "Payment Method" }),
            index.h("div", { key: '301ae61c63f3290f109fe87fbd306a9fe5b650b1', class: "d-table gap-2 w-100" }, index.h(utils.DetailItem, { key: '90f7031b92d4c98fbf200acff5c69c8d7d3c6d59', title: "ID", value: this.payment.payment_method.card.id }), index.h(utils.DetailItem, { key: '06bc828cec434a7e25b16433569b95867feb509b', title: "Payment Type", value: "Card" }), index.h(utils.DetailItem, { key: '2ca0a51f91c7c8cfdc0ac9c5a4e7cb3e7af41e77', title: "Last 4 Numbers", value: this.payment.payment_method.lastFourDigits }), index.h(utils.DetailItem, { key: '9b4e0f3c62d491a3ce31a72181e7eb2258e27571', title: "Brand", value: utils$1.snakeCaseToHumanReadable(this.payment.payment_method.card.brand) }), index.h(utils.DetailItem, { key: '3f987dfd88521e1f3c5ed87fdb561abba6b15ffe', title: "Cardholder", value: this.payment.payment_method.payersName }))
        ], this.payment.payment_method.bank_account && [
            index.h(utils.DetailSectionTitle, { key: '5d6a4499fe5fcb49090b3846737304378ed72e9d', sectionTitle: "Payment Method" }),
            index.h("div", { key: 'cc4c4bdf5b4206e046263544dcc40b2647bd3d96', class: "d-table gap-2 w-100" }, index.h(utils.DetailItem, { key: '394957be1477b450529256420f47a2baf61ba0ad', title: "ID", value: this.payment.payment_method.bank_account.id }), index.h(utils.DetailItem, { key: '40256eb7252cf350b8044b911413adeb969fc149', title: "Last 4 Numbers", value: this.payment.last_four_digits }), index.h(utils.DetailItem, { key: '6753602b063fcd34b9e0db84438ba782e3eb858d', title: "Bank Name", value: this.payment.payment_method.bank_account.brand }), index.h(utils.DetailItem, { key: '1f216f44c78cbe79416241c7e9616bc778f60ab8', title: "Account Owner", value: this.payment.payment_method.payersName }))
        ], this.payment.metadata && [
            index.h(utils.DetailSectionTitle, { key: 'de040eda2eb0ad1d5c7c08d20a22da56dc0c05aa', sectionTitle: 'Metadata' }),
            index.h("div", { key: 'd4d990042524da1e655b40cad77af26642c1dc9f', class: "d-table gap-2 w-100" }, index.h(utils.CodeBlock, { key: '5468b34050c9159503862f8e12391299c603e8e8', metadata: this.payment.metadata }))
        ])))));
    }
    static get watchers() { return {
        "getPaymentDetails": ["updateOnPropChange"]
    }; }
};

exports.payment_details_core = PaymentDetailsCore;
