'use strict';

var index = require('./index-D5bL1DOi.js');
var paymentsStatus = require('./payments-status-DG50GuXR.js');
var utils = require('./utils-DqlrBltg.js');
var parts = require('./parts-9jMf1erK.js');

const defaultColumnsKeys = 'created_at,amount,status,payment_type,description,payers_name,last_four_digits';
const paymentTableColumns = {
    created_at: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The date and time each payment was made" }, "Date")),
    amount: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The dollar amount of each payment" }, "Amount")),
    status: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The current status of each payment" }, "Status")),
    payment_type: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The type of each payment" }, "Type")),
    description: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The payment description, if you provided one" }, "Description")),
    payers_name: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The name associated with the payment method" }, "Account Holder")),
    last_four_digits: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The brand and last 4 digits of the payment method" }, "Payment Method")),
};
const paymentTableCells = {
    created_at: (payment, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) },
        index.h("div", { class: "fw-bold" }, utils.convertToLocal(payment.created_at, { showDisplayDate: true })),
        index.h("div", { class: "fw-bold" }, utils.convertToLocal(payment.created_at, { showTime: true })))),
    amount: (payment, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payment.formattedPaymentAmount(payment.amount))),
    status: (payment, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, paymentsStatus.MapPaymentStatusToBadge(payment.status))),
    payment_type: (payment, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payment.payment_type)),
    description: (payment, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payment.description)),
    payers_name: (payment, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payment.payers_name)),
    last_four_digits: (payment, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payment.last_four_digits)),
};

exports.defaultColumnsKeys = defaultColumnsKeys;
exports.paymentTableCells = paymentTableCells;
exports.paymentTableColumns = paymentTableColumns;
