'use strict';

var index = require('./index-D5bL1DOi.js');
var utils$1 = require('./utils-DqlrBltg.js');
var utils = require('./utils-wkdkLmDI.js');
var button = require('./button-0HYMPryx.js');
var styledHost = require('./styled-host-DXNHOiqW.js');
require('./event-types-YOY5TKUN.js');
var payoutsStatus = require('./payouts-status-meuI7eBr.js');
var skeleton = require('./skeleton-CbZBGO47.js');
var badge = require('./badge-DDksduwk.js');
require('./dinero-J-SRFKIR.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./parts-9jMf1erK.js');

const PayoutDetailsLoading = () => (index.h("div", { class: "row gap-3" },
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "35%", height: "30px" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "70%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "40%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "40%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "100%" })),
    index.h("div", { class: "col-12" },
        index.h(skeleton.Skeleton, { width: "80%" }))));

const PayoutDetailsCore = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.errorEvent = index.createEvent(this, "error-event");
        this.loading = true;
        this.errorMessage = null;
        this.downloadCSV = () => {
            this.getPayoutCSV({
                payoutId: this.payout.id,
                onError: ({ error, code, severity }) => {
                    this.errorMessage = error;
                    this.errorEvent.emit({
                        message: error,
                        errorCode: code,
                        severity,
                    });
                },
            });
        };
    }
    componentWillLoad() {
        if (this.getPayout) {
            this.fetchData();
        }
    }
    getPayoutWatcher() {
        this.fetchData();
    }
    fetchData() {
        this.loading = true;
        this.getPayout({
            onSuccess: (payout) => {
                this.errorMessage = null;
                this.payout = payout;
                this.loading = false;
            },
            onError: ({ error, code, severity }) => {
                this.errorMessage = error;
                this.errorEvent.emit({
                    message: error,
                    errorCode: code,
                    severity,
                });
                this.loading = false;
            },
        });
    }
    render() {
        var _a;
        return (index.h(styledHost.StyledHost, { key: 'e05c4ce44c4c8f55c654b1bdf1cf6fe683cb9b81' }, this.loading && index.h(PayoutDetailsLoading, { key: 'e376fe6853e8d7f51c4341eed7b88706bf0f7b8a' }), !this.loading && this.errorMessage && utils.ErrorState(this.errorMessage), !this.loading && this.payout && (index.h("justifi-details", { key: '2dd14bbe8176fbb2ea33bc10c626295d6dc1e4e1', "error-message": this.errorMessage }, index.h(utils.EntityHeadInfo, { key: 'dd564d982ac3efb2f095655cf4cb8418811caf02', slot: "head-info", badge: (index.h("div", { class: "d-flex gap-1" }, payoutsStatus.MapPayoutStatusToBadge((_a = this.payout) === null || _a === void 0 ? void 0 : _a.status), this.payout.settlement_priority === 'expedited' ? (index.h(badge.Badge, { variant: badge.BadgeVariant.WARNING, title: "Expedited", text: "Expedited" })) : (index.h(badge.Badge, { variant: badge.BadgeVariant.SECONDARY, title: "Standard", text: "Standard" })))), title: this.payout.formattedPaymentAmount(this.payout.amount) }, index.h(utils.EntityHeadInfoItem, { key: 'a1fd083db968de7d1b4f14a40bee168face1d783', classes: "border-1 border-end", title: "Updated At", value: `${utils$1.formatDate(this.payout.updated_at)} ${utils$1.formatTime(this.payout.updated_at)}` }), index.h(utils.EntityHeadInfoItem, { key: '1ab1aa48b5b685e0f6b01bd3199884cc4e7a41a0', classes: "border-1 border-end", title: "Created At", value: `${utils$1.formatDate(this.payout.created_at)} ${utils$1.formatTime(this.payout.created_at)}` }), index.h(utils.EntityHeadInfoItem, { key: '7463594d15588fdb0f81c75d9951d8b15872ddec', title: "ID", value: this.payout.id }), index.h("div", { key: '8e6db2a97f3fbb3e6249dfaef88dbfdaad2067f1', class: "m-4" }, index.h(button.Button, { key: '3bfd46400ea58e57a83fc9872656113d69a77987', variant: "secondary", class: "btn btn-outline-secondary d-flex align-items-center", onClick: this.downloadCSV }, "Export CSV"))), index.h("div", { key: '427a17dabc56f57f7c91d36916516d78fc3fadf8', slot: 'detail-sections' }, index.h(utils.DetailSectionTitle, { key: '08b15fa861e7d560df9e6025f79bf4b1c0ca861a', sectionTitle: "Details" }), index.h("div", { key: '77977c92b829ac50ffb5af03860ae1966116b703', class: "d-table gap-2 w-100" }, index.h(utils.DetailItem, { key: '32f2044cb92d6870e053eb92de901e040c15ec2e', title: "Date paid", value: utils$1.formatDate(this.payout.deposits_at) }), index.h(utils.DetailItem, { key: '52e3acbe2a733e1d6f28a509b9eefaaffd94ee7a', title: "Statement Description", value: this.payout.description }), index.h(utils.DetailItem, { key: '62ad6df7ed23c6f5f8babacb4bd4b22636f1b42b', title: "Payout Method", value: this.payout.delivery_method }), index.h(utils.DetailItem, { key: '318d56c8cec9f35070df658bc1bb2aefa2f4fe75', title: "Amount", value: this.payout.formattedPaymentAmount(this.payout.amount) }), index.h(utils.DetailItem, { key: '49b8c56d9e17c94ea48f693fe296ded03956f62e', title: "Fee", value: this.payout.formattedPaymentAmount(this.payout.fees_total) })), index.h(utils.DetailSectionTitle, { key: 'a886b2c55ae3759319157ef962d976ca20e9f28c', sectionTitle: "Account" }), index.h("div", { key: '06f4475021fa8cd81dd42b7de5bf511275872d24', class: "d-table gap-2 w-100" }, index.h(utils.DetailItem, { key: '614a22ffb02c6b50381cad42b6ac96a08904bab7', title: "ID", value: this.payout.account_id }), index.h(utils.DetailItem, { key: 'fb5a846b307a56987d0f793a4ed340e2c883bc74', title: "Account Type", value: this.payout.bank_account.account_type }), index.h(utils.DetailItem, { key: '5cd13f1e3244b4e64dee2f68a1d85f1c4a3503a5', title: "Institution", value: this.payout.bank_account.account_type }), index.h(utils.DetailItem, { key: '4b09718e6f39c440016e6ddca4d93bc73e10255a', title: "Routing Number", value: this.payout.bank_account.routing_number }), index.h(utils.DetailItem, { key: '3fd5b3572698f7e84de5d047277389fb521dbe54', title: "Account Number", value: this.payout.bank_account.account_number_last4 })), this.payout.metadata && [
            index.h(utils.DetailSectionTitle, { key: '556639af0cc42f631033ce58c29c34fe72acbec7', sectionTitle: 'Metadata' }),
            index.h("div", { key: '5429777122823531e770ed074103385cf587d3ae', class: "d-table gap-2 w-100" }, index.h(utils.CodeBlock, { key: 'bfef600620b9a041678987fcf5abdb5b8dbc9672', metadata: this.payout.metadata }))
        ])))));
    }
    static get watchers() { return {
        "getPayout": ["getPayoutWatcher"]
    }; }
};

exports.payout_details_core = PayoutDetailsCore;
