'use strict';

var index = require('./index-D5bL1DOi.js');
var utils = require('./utils-DqlrBltg.js');
var payoutsStatus = require('./payouts-status-meuI7eBr.js');
var parts = require('./parts-9jMf1erK.js');

const defaultColumnsKeys = 'created_at,amount,status,payments_total,refunds_total,fees_total,other_total,csv';
const payoutTableColumns = {
    created_at: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The date the payout was deposited" }, "Created")),
    sub_account_name: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The sub account associated with the payout" }, "Sub Account")),
    payments_total: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The total payments amount associated with the payout" }, "Payments")),
    refunds_total: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The total refunds amount associated with the payout" }, "Refunds")),
    fees_total: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The total fees amount associated with the payout" }, "Fees")),
    other_total: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The total other amount" }, "Other")),
    amount: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The total amount of the payout" }, "Amount")),
    status: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "The real-time status of each payout" }, "Status")),
    csv: () => (index.h("th", { part: parts.tableHeadCell, scope: "col", title: "Export CSV" })),
};
const payoutTableCells = (downloadCSV) => ({
    created_at: (payout, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) },
        index.h("div", { class: "fw-bold" }, utils.convertToLocal(payout.created_at, { showDisplayDate: true })))),
    sub_account_name: (payout, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payout.sub_account_name)),
    payments_total: (payout, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payout.formattedPaymentAmount(payout.payments_total))),
    refunds_total: (payout, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payout.formattedPaymentAmount(payout.refunds_total))),
    fees_total: (payout, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payout.formattedPaymentAmount(payout.fees_total))),
    other_total: (payout, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payout.formattedPaymentAmount(payout.other_total))),
    amount: (payout, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payout.formattedPaymentAmount(payout.amount))),
    status: (payout, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) }, payoutsStatus.MapPayoutStatusToBadge(payout.status))),
    csv: (payout, index$1) => (index.h("td", { part: parts.getAlternateTableCellPart(index$1) },
        index.h("a", { href: "#", onClick: (event) => { event.preventDefault(); downloadCSV(payout.id); } }, "CSV"))),
});

exports.defaultColumnsKeys = defaultColumnsKeys;
exports.payoutTableCells = payoutTableCells;
exports.payoutTableColumns = payoutTableColumns;
