'use strict';

var index = require('./index-D5bL1DOi.js');
var table = require('./table-CxvETNS1.js');
var eventTypes = require('./event-types-YOY5TKUN.js');
require('./config-state-Dz9bnWHg.js');
require('./dinero-J-SRFKIR.js');
require('./ComponentError-CEv9ltwy.js');
require('./Refund-08OcZkXX.js');
var Pagination = require('./Pagination-Dediz133.js');
require('./Business-DCRzZf0w.js');
require('./Dispute-CruQTF6_.js');
var terminalOrdersTable = require('./terminal-orders-table-DTZUpjkG.js');
var terminalOrdersListParamsState = require('./terminal-orders-list-params-state-DZUKBmLC.js');
require('./parts-9jMf1erK.js');
require('./spinner-CIZFX7bz.js');
require('./index-BCtVWU61.js');
require('./_commonjsHelpers-BJu3ubxk.js');
require('./utils-DqlrBltg.js');
require('./helpers-B5OCqlIM.js');
require('./state-options-CIT9xdTz.js');
require('./badge-DDksduwk.js');

const TerminalOrdersListCore = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.clickEvent = index.createEvent(this, "click-event");
        this.errorEvent = index.createEvent(this, "error-event");
        this.terminalOrders = [];
        this.loading = true;
        this.paging = Pagination.pagingDefaults;
        this.pagingParams = {};
        this.handleClickPrevious = (beforeCursor) => {
            this.pagingParams = { before_cursor: beforeCursor };
            this.clickEvent.emit({ name: eventTypes.TableClickActions.previous });
        };
        this.handleClickNext = (afterCursor) => {
            this.pagingParams = { after_cursor: afterCursor };
            this.clickEvent.emit({ name: eventTypes.TableClickActions.next });
        };
        this.rowClickHandler = (e) => {
            const clickedOrderId = e.target.closest('tr').dataset.rowEntityId;
            if (!clickedOrderId)
                return;
            const orderData = this.terminalOrders.find((order) => order.id === clickedOrderId);
            this.clickEvent.emit({ name: eventTypes.TableClickActions.row, data: orderData });
        };
    }
    updateOnPropChange() {
        this.fetchData();
    }
    componentWillLoad() {
        this.terminalOrdersTable = new table.Table(this.terminalOrders, this.columns, terminalOrdersTable.terminalOrdersTableColumns, terminalOrdersTable.terminalOrdersTableCells);
        if (this.getTerminalOrders) {
            this.fetchData();
        }
        terminalOrdersListParamsState.onQueryParamsChange('set', () => {
            this.pagingParams = {};
        });
        terminalOrdersListParamsState.onQueryParamsChange('reset', () => {
            this.pagingParams = {};
            this.errorMessage = '';
        });
    }
    fetchData() {
        this.loading = true;
        this.getTerminalOrders({
            params: this.terminalOrderParams,
            onSuccess: async ({ terminalOrders, pagingInfo }) => {
                this.terminalOrders = terminalOrders;
                this.paging = pagingInfo;
                this.terminalOrdersTable.collectionData = this.terminalOrders;
            },
            onError: ({ error, code, severity }) => {
                this.errorMessage = error;
                this.errorEvent.emit({
                    errorCode: code,
                    message: error,
                    severity,
                });
            },
            final: () => { this.loading = false; },
        });
    }
    get terminalOrderParams() {
        const requestParams = terminalOrdersListParamsState.getRequestParams();
        const params = Object.assign(Object.assign({}, requestParams), this.pagingParams);
        return params;
    }
    get entityId() {
        return this.terminalOrders.map((terminalOrder) => terminalOrder.id);
    }
    get showEmptyState() {
        return !this.loading && !this.errorMessage && this.terminalOrdersTable.rowData.length < 1;
    }
    get showErrorState() {
        return !this.loading && !!this.errorMessage;
    }
    get showRowData() {
        return !this.showEmptyState && !this.showErrorState && !this.loading;
    }
    render() {
        return (index.h(table.TableWrapper, { key: '85a1a02fb87d8582cb58716fceab3037f2b2db59' }, index.h(table.TableComponent, { key: '16d1f186acc00b28437ebb5608a69b6b69fa7914' }, index.h(table.TableHead, { key: 'dce803614dd4c1fd7844aeeb9539cfa32368b277' }, index.h(table.TableHeadRow, { key: 'f8c81e2b7e35064e8f2699366045fdf63d0b6a25' }, this.terminalOrdersTable.columnData.map((column) => column))), index.h(table.TableBody, { key: 'f1d27f78f5985b0e7b0e24bc370e787d08d7d441' }, index.h(table.TableLoadingState, { key: '036e603cd4ba2785b931f9c101c73bda204e0c3b', columnSpan: this.terminalOrdersTable.columnKeys.length, isLoading: this.loading }), index.h(table.TableEmptyState, { key: '7b7e58eebc3644e05e989e6593cc0b995f52f3fc', isEmpty: this.showEmptyState, columnSpan: this.terminalOrdersTable.columnKeys.length }), index.h(table.TableErrorState, { key: '2ba2fa702cc279cfb4bb6116aef5f99bcc6cdeea', columnSpan: this.terminalOrdersTable.columnKeys.length, errorMessage: this.errorMessage }), this.showRowData && this.terminalOrdersTable.rowData.map((data, index$1) => (index.h(table.TableRow, { "data-test-id": "table-row", "data-row-entity-id": this.entityId[index$1], onClick: this.rowClickHandler }, data)))), this.paging && (index.h(table.TableFoot, { key: '8448f124fd6d5cb82983af8b163532e067d44e7f' }, index.h(table.TableFootRow, { key: '3172efc0062b99a291ef945c900321d4db112dda' }, index.h(table.TableFootCell, { key: '690c7414a1a3071a0d662c14ebe86b5f771da10a', colSpan: this.terminalOrdersTable.columnData.length }, index.h("pagination-menu", { key: '8034a4c00f149c1b720db9c78b91e6ea635bd86e', paging: Object.assign(Object.assign({}, this.paging), { handleClickPrevious: this.handleClickPrevious, handleClickNext: this.handleClickNext }) }))))))));
    }
    static get watchers() { return {
        "pagingParams": ["updateOnPropChange"],
        "getTerminalOrders": ["updateOnPropChange"],
        "columns": ["updateOnPropChange"]
    }; }
};

exports.terminal_orders_list_core = TerminalOrdersListCore;
