import { formatCurrency } from "../utils/utils";
export var PayoutBalanceTransactionType;
(function (PayoutBalanceTransactionType) {
    PayoutBalanceTransactionType["fee"] = "fee";
    PayoutBalanceTransactionType["payment"] = "payment";
    PayoutBalanceTransactionType["payout"] = "payout";
    PayoutBalanceTransactionType["sellerPaymentRefund"] = "seller_payment_refund";
    PayoutBalanceTransactionType["disputeAmountCollected"] = "dispute_amount_collected";
    PayoutBalanceTransactionType["disputeFeeCollected"] = "dispute_fee_collected";
    PayoutBalanceTransactionType["sellerPayment"] = "seller_payment";
    PayoutBalanceTransactionType["transfer"] = "transfer";
    PayoutBalanceTransactionType["partnerPlatformProceedsCredit"] = "partner_platform_proceeds_credit";
})(PayoutBalanceTransactionType || (PayoutBalanceTransactionType = {}));
export class PayoutBalanceTransaction {
    constructor(balanceTransaction) {
        this.id = balanceTransaction.id;
        this.account_id = balanceTransaction.account_id;
        this.payout_id = balanceTransaction.payout_id;
        this.financial_transaction_id = balanceTransaction.financial_transaction_id;
        this.amount = balanceTransaction.amount;
        this.fee = balanceTransaction.fee;
        this.net = balanceTransaction.net;
        this.currency = balanceTransaction.currency;
        this.source_id = balanceTransaction.source_id;
        this.description = balanceTransaction.description;
        this.txn_type = balanceTransaction.txn_type;
        this.created_at = balanceTransaction.created_at;
        this.available_on = balanceTransaction.available_on;
        this.updated_at = balanceTransaction.updated_at;
    }
    formattedPaymentAmount(amount) {
        return formatCurrency(amount, this.currency);
    }
}
;
