import { h } from "@stencil/core";
import { DetailItem, DetailSectionTitle } from "../../../ui-components/details/utils";
import { isEmptyObject } from "../../../utils/utils";
export class AdditionalQuestionsDetails {
    render() {
        if (!this.additionalQuestions || isEmptyObject(this.additionalQuestions))
            return null;
        return (h("div", null, h(DetailSectionTitle, { sectionTitle: "Additional Questions" }), h("div", { class: "d-table gap-2 w-100 mt-3" }, h("div", { class: "row gy-3" }, h("div", { class: "col-12 col-md-6" }, h(DetailItem, { title: "Business Revenue", value: this.additionalQuestions.business_revenue }), h(DetailItem, { title: "Business Payment Volume", value: this.additionalQuestions.business_payment_volume }))))));
    }
    static get is() { return "additional-questions-details"; }
    static get properties() {
        return {
            "additionalQuestions": {
                "type": "unknown",
                "attribute": "additional-questions",
                "mutable": false,
                "complexType": {
                    "original": "IAdditionalQuestions",
                    "resolved": "IAdditionalQuestions",
                    "references": {
                        "IAdditionalQuestions": {
                            "location": "import",
                            "path": "../../../api/Business",
                            "id": "src/api/Business.ts::IAdditionalQuestions"
                        }
                    }
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
}
