import { h } from "@stencil/core";
import { DetailItem, DetailSectionTitle } from "../../../ui-components/details/utils";
import { snakeCaseToHumanReadable } from "../../../utils/utils";
export class CoreInfoDetails {
    render() {
        if (!this.business) {
            return null;
        }
        ;
        return (h("div", null, h(DetailSectionTitle, { sectionTitle: "Business Core Info Details" }), h("div", { class: "d-table gap-2 w-100 mt-3" }, h("div", { class: "row gy-3" }, h("div", { class: "col-12 col-md-6" }, h(DetailItem, { title: "Legal Name", value: this.business.legal_name }), h(DetailItem, { title: "Doing Business As (DBA)", value: this.business.doing_business_as }), h(DetailItem, { title: "Business Classification", value: snakeCaseToHumanReadable(this.business.classification) }), h(DetailItem, { title: "Industry", value: this.business.industry })), h("div", { class: "col-12 col-md-6" }, h(DetailItem, { title: "Tax ID", value: this.business.tax_id }), h(DetailItem, { title: "Website URL", value: this.business.website_url }), h(DetailItem, { title: "Email Address", value: this.business.email }), h(DetailItem, { title: "Phone Number", value: this.business.phone }))))));
    }
    static get is() { return "core-info-details"; }
    static get properties() {
        return {
            "business": {
                "type": "unknown",
                "attribute": "business",
                "mutable": false,
                "complexType": {
                    "original": "Business",
                    "resolved": "Business",
                    "references": {
                        "Business": {
                            "location": "import",
                            "path": "../../../api/Business",
                            "id": "src/api/Business.ts::Business"
                        }
                    }
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
}
