import { h } from "@stencil/core";
import { DetailItem, DetailSectionTitle } from "../../../ui-components/details/utils";
import { isEmptyObject } from "../../../utils/utils";
export class LegalAddressDetails {
    render() {
        var _a, _b, _c, _d, _e, _f, _g;
        if (!this.legalAddress || isEmptyObject(this.legalAddress))
            return null;
        return (h("div", null, h(DetailSectionTitle, { sectionTitle: "Business Legal Address Details" }), h("div", { class: "d-table gap-2 w-100 mt-3" }, h("div", { class: "row gy-3" }, h("div", { class: "col-12 col-md-6" }, h(DetailItem, { title: "Country", value: (_a = this.legalAddress) === null || _a === void 0 ? void 0 : _a.country }), h(DetailItem, { title: "Legal Address", value: (_b = this.legalAddress) === null || _b === void 0 ? void 0 : _b.line1 }), h(DetailItem, { title: "Address Line 2", value: (_c = this.legalAddress) === null || _c === void 0 ? void 0 : _c.line2 })), h("div", { class: "col-12 col-md-6" }, h(DetailItem, { title: "City", value: (_d = this.legalAddress) === null || _d === void 0 ? void 0 : _d.city }), h(DetailItem, { title: "State", value: (_e = this.legalAddress) === null || _e === void 0 ? void 0 : _e.state }), h(DetailItem, { title: "Postal Code", value: (_g = (_f = this.legalAddress) === null || _f === void 0 ? void 0 : _f.postal_code) === null || _g === void 0 ? void 0 : _g.toString() }))))));
    }
    static get is() { return "legal-address-details"; }
    static get properties() {
        return {
            "legalAddress": {
                "type": "unknown",
                "attribute": "legal-address",
                "mutable": false,
                "complexType": {
                    "original": "IAddress",
                    "resolved": "IAddress",
                    "references": {
                        "IAddress": {
                            "location": "import",
                            "path": "../../../api/Business",
                            "id": "src/api/Business.ts::IAddress"
                        }
                    }
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
}
