import { Host, h } from "@stencil/core";
import { businessServiceReceivedOptions, recurringPaymentsOptions, seasonalBusinessOptions } from "../../utils/business-form-options";
import { CURRENCY_MASK } from "../../../../utils/form-input-masks";
import { heading2 } from "../../../../styles/parts";
export class AdditionalQuestions {
    constructor() {
        this.errors = {};
        this.additional_questions = {};
        this.inputHandler = this.inputHandler.bind(this);
    }
    componentDidLoad() {
        this.formController.errors.subscribe(errors => (this.errors = Object.assign({}, errors)));
        this.formController.values.subscribe(values => (this.additional_questions = Object.assign({}, values.additional_questions)));
    }
    inputHandler(name, value) {
        this.formController.setValues(Object.assign(Object.assign({}, this.formController.values.getValue()), { additional_questions: Object.assign(Object.assign({}, this.formController.values.getValue().additional_questions), { [name]: value }) }));
    }
    render() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
        const additionalQuestionsDefaultValue = this.formController.getInitialValues().additional_questions;
        return (h(Host, { key: 'e3e354a7cf470f658e0f95d37186b1f45771b673' }, h("fieldset", { key: '7fb001177a4f907d513eb5955063d446234ede0c' }, h("legend", { key: 'ee6b045a438be9f56345daad752e105640f1ca3d', part: heading2 }, "Additional Questions"), h("div", { key: 'ed114675357f3b70c34a3eb941fdb30e6219cdc9', class: "row gy-3" }, h("div", { key: 'b85c27c827cf5e5d0d556c343315e5eec736f538', class: "col-12 col-md-6" }, h("form-control-monetary-provisioning", { key: '4576f67fa74ba7c2ca9730468ddc52b055a3c496', name: "business_revenue", label: "What is the business' estimated annual revenue from its primary business activities?", inputHandler: this.inputHandler, errorText: (_b = (_a = this.errors) === null || _a === void 0 ? void 0 : _a.additional_questions) === null || _b === void 0 ? void 0 : _b.business_revenue, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_revenue, maskOptions: CURRENCY_MASK.WHOLE })), h("div", { key: '0614c60cc7daaf890ccb4888d41b0260a26f9a0e', class: "col-12 col-md-6" }, h("form-control-monetary-provisioning", { key: '2c435c1553714d75542e0e3bcf1d723f26b37da8', name: "business_payment_volume", label: "What is the business' annual credit card & ACH volume anticipated to process?", inputHandler: this.inputHandler, errorText: (_d = (_c = this.errors) === null || _c === void 0 ? void 0 : _c.additional_questions) === null || _d === void 0 ? void 0 : _d.business_payment_volume, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_payment_volume, maskOptions: CURRENCY_MASK.WHOLE })), h("div", { key: '8d4a19eb0b6b5707f4a423543d86ae50f6492efc', class: "col-12" }, h("form-control-select", { key: '2e49f907bae85cd4901e4aa4413284596fbed365', name: 'business_when_service_received', label: 'On average, how long after paying will your customers typically receive their goods or services?', inputHandler: this.inputHandler, errorText: (_f = (_e = this.errors) === null || _e === void 0 ? void 0 : _e.additional_questions) === null || _f === void 0 ? void 0 : _f.business_when_service_received, options: businessServiceReceivedOptions, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_when_service_received })), h("div", { key: '11bc4e0bbe2122b977cf8bc29ac0601ef941881c', class: "col-12" }, h("form-control-select", { key: 'c511b728971250dc3272c1ef9ff96131a9ac6a2e', name: 'business_recurring_payments', label: 'Does your business offer recurring payments?', inputHandler: this.inputHandler, errorText: (_h = (_g = this.errors) === null || _g === void 0 ? void 0 : _g.additional_questions) === null || _h === void 0 ? void 0 : _h.business_recurring_payments, options: recurringPaymentsOptions, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_recurring_payments })), h("div", { key: '5a40dfe41a9fca815cdf0eb7455b41615d1e6c76', class: "col-12" }, h("form-control-text", { key: 'd8aaf0f6d7d44b1b15ec76af198a0117493f08c6', name: 'business_recurring_payments_percentage', label: 'What percent of revenue is generated from each recurring payment type offered?', inputHandler: this.inputHandler, errorText: (_k = (_j = this.errors) === null || _j === void 0 ? void 0 : _j.additional_questions) === null || _k === void 0 ? void 0 : _k.business_recurring_payments_percentage, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_recurring_payments_percentage })), h("div", { key: 'b211bb865a60baf1ea00c81f76f000ff2a31d7bd', class: "col-12" }, h("form-control-select", { key: '4b693e7425e690a59e2c70646cca2b886b8a8796', name: 'business_seasonal', label: 'Is this business seasonal?', inputHandler: this.inputHandler, errorText: (_m = (_l = this.errors) === null || _l === void 0 ? void 0 : _l.additional_questions) === null || _m === void 0 ? void 0 : _m.business_seasonal, options: seasonalBusinessOptions, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_seasonal })), h("div", { key: 'e85b7fceb9cdc808afaf3559609b7519c9630266', class: "col-12" }, h("form-control-text", { key: 'ae4a6518c7499826f30376f1c902f694244059c7', name: 'business_other_payment_details', label: 'Is there anything else you would like us to know about how your customers pay the business?', inputHandler: this.inputHandler, errorText: (_p = (_o = this.errors) === null || _o === void 0 ? void 0 : _o.additional_questions) === null || _p === void 0 ? void 0 : _p.business_other_payment_details, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_other_payment_details }))))));
    }
    static get is() { return "justifi-additional-questions"; }
    static get properties() {
        return {
            "formController": {
                "type": "unknown",
                "attribute": "form-controller",
                "mutable": false,
                "complexType": {
                    "original": "FormController",
                    "resolved": "FormController",
                    "references": {
                        "FormController": {
                            "location": "import",
                            "path": "../../../../components",
                            "id": "src/components.d.ts::FormController"
                        }
                    }
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
    static get states() {
        return {
            "errors": {},
            "additional_questions": {}
        };
    }
}
