import { Host, h } from "@stencil/core";
import StateOptions from "../../../../utils/state-options";
import { numberOnlyHandler } from "../../../../ui-components/form/utils";
import { heading2 } from "../../../../styles/parts";
export class LegalAddressForm {
    constructor() {
        this.errors = {};
        this.inputHandler = this.inputHandler.bind(this);
    }
    componentDidLoad() {
        this.formController.errors.subscribe(errors => (this.errors = Object.assign({}, errors)));
        this.formController.values.subscribe(values => (this.legal_address = Object.assign({}, values.legal_address)));
    }
    inputHandler(name, value) {
        this.formController.setValues(Object.assign(Object.assign({}, this.formController.values.getValue()), { legal_address: Object.assign(Object.assign({}, this.formController.values.getValue().legal_address), { [name]: value }) }));
    }
    render() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
        const legalAddressDefaultValue = this.formController.getInitialValues().legal_address;
        return (h(Host, { key: '5b21d99717f9b24c0551c7a96acf68e53e7787bf' }, h("fieldset", { key: 'd63cbd20b2648405c50a819724e0f8cf556f7d26' }, h("legend", { key: 'c0acd14073f13f914015f40d39bf22fb58792434', part: heading2 }, "Business Legal Address"), h("div", { key: 'ee4cee6bd662816f822ee209aeda5e9664f6a64d', class: "row gy-3" }, h("div", { key: '86b258fd09e73cbd2475330419274732231f3871', class: "col-12" }, h("form-control-text", { key: '8d898a9ae448f07932afe2d8cfc2314b92d9c597', name: "line1", label: "Legal Address", inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.line1, errorText: (_b = (_a = this.errors) === null || _a === void 0 ? void 0 : _a.legal_address) === null || _b === void 0 ? void 0 : _b.line1 })), h("div", { key: '1a50c4b86a754035f71efacd39721219fcd54d60', class: "col-12" }, h("form-control-text", { key: '507b1451685e359a900f0bc7010ff39e3631daf2', name: "line2", label: "Address Line 2", inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.line2, errorText: (_d = (_c = this.errors) === null || _c === void 0 ? void 0 : _c.legal_address) === null || _d === void 0 ? void 0 : _d.line2 })), h("div", { key: '1446b4db5f86a3b18e3aceb78274ffe458dbd3db', class: "col-12" }, h("form-control-text", { key: 'e17e4bd95ad4290d18edde79cf05a6b3a105166c', name: "city", label: "City", inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.city, errorText: (_f = (_e = this.errors) === null || _e === void 0 ? void 0 : _e.legal_address) === null || _f === void 0 ? void 0 : _f.city })), h("div", { key: '9b880203bad9e104e6d1299ff73c83cba46ab563', class: "col-12" }, h("form-control-select", { key: '24e4df10f688c9a1b5f2af5217f03919bf7abec7', name: "state", label: "State", options: StateOptions, inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.state, errorText: (_h = (_g = this.errors) === null || _g === void 0 ? void 0 : _g.legal_address) === null || _h === void 0 ? void 0 : _h.state })), h("div", { key: '71f21b19602c268e3b6a839ce41ff9d4f8ffb8c4', class: "col-12" }, h("form-control-text", { key: 'ca71d3e21c5a0aea5367fa28ec1a2422ba9b1cf3', name: "postal_code", label: "Postal Code", inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.postal_code, errorText: (_k = (_j = this.errors) === null || _j === void 0 ? void 0 : _j.legal_address) === null || _k === void 0 ? void 0 : _k.postal_code, maxLength: 5, keyDownHandler: numberOnlyHandler })), h("div", { key: 'aaee0bf6a24ba182e002c1ffb49736fb622cde1f', class: "col-12" }, h("form-control-select", { key: '2b6486771818e584dcc195c304e5a6e16850b4a9', name: "country", label: "Country", options: [{ label: 'United States', value: 'USA' }], inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.country, errorText: (_m = (_l = this.errors) === null || _l === void 0 ? void 0 : _l.legal_address) === null || _m === void 0 ? void 0 : _m.country,
            // just for now so we skip handling country specificities
            disabled: true }))))));
    }
    static get is() { return "justifi-legal-address-form"; }
    static get properties() {
        return {
            "formController": {
                "type": "unknown",
                "attribute": "form-controller",
                "mutable": false,
                "complexType": {
                    "original": "FormController",
                    "resolved": "FormController",
                    "references": {
                        "FormController": {
                            "location": "import",
                            "path": "../../../../components",
                            "id": "src/components.d.ts::FormController"
                        }
                    }
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
    static get states() {
        return {
            "errors": {},
            "legal_address": {}
        };
    }
}
