import { Host, h } from "@stencil/core";
import StateOptions from "../../../../utils/state-options";
import { numberOnlyHandler } from "../../../../ui-components/form/utils";
export class IdentityAddressForm {
    constructor() {
        this.address = {};
        this.inputHandler = (name, value) => {
            this.address[name] = value;
            this.address = Object.assign({}, this.address);
        };
    }
    handleAddressChange(newValues) {
        this.handleFormUpdate(newValues);
    }
    render() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
        return (h(Host, { key: '136f90a2d2e8634c003a5f47af20d422b7cc59be' }, h("div", { key: 'e7441c2a0410381be43f8d0735fdf4e390f664f2', class: "row gy-3" }, h("div", { key: '93f23a3ba51716a88bf90628f395dbb3bc456cdc', class: "col-12 col-md-8" }, h("form-control-text", { key: 'f4801f6eb05d3a169142daa6b0d123ef84864de8', name: "line1", label: "Street Address", defaultValue: (_a = this.defaultValues) === null || _a === void 0 ? void 0 : _a.line1, errorText: (_b = this.errors) === null || _b === void 0 ? void 0 : _b.line1, inputHandler: this.inputHandler, helpText: "\u200B\u200BEnter your address exactly as stated on your driver's license. No PO Boxes." })), h("div", { key: 'e8ce49dcd4d3c6df3327d2c011ec1c0a080fb4f2', class: "col-12 col-md-4" }, h("form-control-text", { key: '8cbe92c156c4d410b712b2fc95c7bfe55be4e337', name: "line2", label: "Apartment, Suite, etc. (optional)", defaultValue: (_c = this.defaultValues) === null || _c === void 0 ? void 0 : _c.line2, errorText: (_d = this.errors) === null || _d === void 0 ? void 0 : _d.line2, inputHandler: this.inputHandler })), h("div", { key: '4cfcfc24268fd92ccaac110a8293e95bc9998af8', class: "col-12" }, h("form-control-text", { key: 'b2739b7fd7838ee73c9127fd8e9b0dd6dcd12210', name: "city", label: "City", defaultValue: (_e = this.defaultValues) === null || _e === void 0 ? void 0 : _e.city, errorText: (_f = this.errors) === null || _f === void 0 ? void 0 : _f.city, inputHandler: this.inputHandler })), h("div", { key: 'ce9e4974dcdab596dfcefef362d045ee2fea3648', class: "col-12 col-md-6" }, h("form-control-select", { key: 'c001d0a3d3b402768ec428c0e5760cf0e88c318d', name: "state", label: "State", defaultValue: (_g = this.defaultValues) === null || _g === void 0 ? void 0 : _g.state, options: StateOptions, errorText: (_h = this.errors) === null || _h === void 0 ? void 0 : _h.state, inputHandler: this.inputHandler })), h("div", { key: '7b73598a2b207db9ec2480ed37d163aa45128e6d', class: "col-12 col-md-6" }, h("form-control-text", { key: 'a070edca32110dc4ec238c486ae96852733ae924', name: "postal_code", label: "Postal Code", defaultValue: (_j = this.defaultValues) === null || _j === void 0 ? void 0 : _j.postal_code, errorText: (_k = this.errors) === null || _k === void 0 ? void 0 : _k.postal_code, maxLength: 5, keyDownHandler: numberOnlyHandler, inputHandler: this.inputHandler })), h("div", { key: '57b01955142ed533a65058b63cfd20598e8387c2', class: "col-12" }, h("form-control-select", { key: '8f07809025c039b4c39a452ddf2948f973a82d9a', name: "country", label: "Country", options: [{ label: 'United States', value: 'USA' }], inputHandler: this.inputHandler, defaultValue: (_l = this.defaultValues) === null || _l === void 0 ? void 0 : _l.country, errorText: (_m = this.errors) === null || _m === void 0 ? void 0 : _m.country,
            // just for now so we skip handling country specificities
            disabled: true })))));
    }
    static get is() { return "justifi-identity-address-form"; }
    static get properties() {
        return {
            "handleFormUpdate": {
                "type": "unknown",
                "attribute": "handle-form-update",
                "mutable": false,
                "complexType": {
                    "original": "(values: any) => void",
                    "resolved": "(values: any) => void",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            },
            "errors": {
                "type": "any",
                "attribute": "errors",
                "mutable": false,
                "complexType": {
                    "original": "any",
                    "resolved": "any",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "defaultValues": {
                "type": "any",
                "attribute": "default-values",
                "mutable": false,
                "complexType": {
                    "original": "any",
                    "resolved": "any",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            }
        };
    }
    static get states() {
        return {
            "address": {}
        };
    }
    static get watchers() {
        return [{
                "propName": "address",
                "methodName": "handleAddressChange"
            }];
    }
}
