import { h } from "@stencil/core";
import { Button } from "../../ui-components/button";
import { hasFilters } from "./utils";
import { dropdownMenu, dropdownMenuButton } from "../../styles/parts";
export class TableFiltersMenu {
    constructor() {
        this.showClearButton = false;
    }
    watchParamsHandler(newValue) {
        this.showClearButton = hasFilters(newValue);
    }
    show() {
        this.menu.classList.add('show');
    }
    hide() {
        this.menu.classList.remove('show');
    }
    componentWillLoad() {
        this.showClearButton = hasFilters(this.params);
    }
    render() {
        return (h("div", { key: 'b270a6f9e52e45e958bb02e31569d4f56135ee25', class: "d-flex gap-2" }, h("div", { key: '76d9eef0672c27ec28a95bc062f946739a2c5dc7', class: "dropdown pb-3" }, h("button", { key: '3de6afb2c92bde835ae894e7548b3e07b86fb0bf', type: "button dropdown-toggle", ref: (el) => (this.anchorButton = el), class: "btn btn-primary dropdown-toggle", part: dropdownMenuButton, "data-test-id": "open-filters-button", "data-bs-toggle": "dropdown" }, "Filters"), h("custom-popper", { key: 'de744460fb721b5949ca0cfcf6a751e4b6a008d0', offset: [20, 10], strategy: "fixed", anchorRef: this.anchorButton, trigger: "click" }, h("form", { key: 'c8b6d3e8e28b90fb3dedd80e71c7a8a0f30b6a8f', class: "dropdown-menu", part: dropdownMenu, "data-test-id": "filter-menu", ref: (el) => (this.menu = el), onSubmit: (e) => e.preventDefault() }, h("slot", { key: '44e50fab6d4f6c7a76f90659cced1c61e94ec43d' })))), h("div", { key: 'b5ec37cc1f28005c2b87b14bd10b74e619012ce5' }, h(Button, { key: '5bae9de44fcdb6e015ac3311945bdcee1887e827', variant: "secondary", onClick: () => this.clearParams(), hidden: !this.showClearButton, "data-test-id": "clear-filters-button" }, "Clear Filters"))));
    }
    static get is() { return "table-filters-menu"; }
    static get properties() {
        return {
            "params": {
                "type": "any",
                "attribute": "params",
                "mutable": false,
                "complexType": {
                    "original": "any",
                    "resolved": "any",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "clearParams": {
                "type": "unknown",
                "attribute": "clear-params",
                "mutable": false,
                "complexType": {
                    "original": "() => void",
                    "resolved": "() => void",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false
            }
        };
    }
    static get states() {
        return {
            "anchorButton": {},
            "menu": {},
            "showClearButton": {}
        };
    }
    static get watchers() {
        return [{
                "propName": "params",
                "methodName": "watchParamsHandler"
            }];
    }
    static get listeners() {
        return [{
                "name": "showEvent",
                "method": "show",
                "target": undefined,
                "capture": false,
                "passive": false
            }, {
                "name": "hideEvent",
                "method": "hide",
                "target": undefined,
                "capture": false,
                "passive": false
            }];
    }
}
