import { h } from "@stencil/core";
import { StyledHost } from "../../../ui-components";
import { checkoutStore } from "../../../store/checkout.store";
import { radioListItem } from "../../../styles/parts";
import { CardBrandLabels } from "../../checkout/payment-method-option-utils";
export class SavedPaymentMethods {
    constructor() {
        this.onPaymentMethodOptionClick = (paymentMethodId) => (e) => {
            e.preventDefault();
            checkoutStore.selectedPaymentMethod = paymentMethodId;
        };
        this.isAllowedPaymentMethod = (paymentMethod) => {
            if (paymentMethod.type === 'card' && checkoutStore.disableCreditCard) {
                return false;
            }
            if (paymentMethod.type === 'bank_account' && checkoutStore.disableBankAccount) {
                return false;
            }
            return true;
        };
    }
    componentWillLoad() {
        if (!checkoutStore.paymentMethods.length) {
            console.warn('No saved payment methods available.');
        }
        if (checkoutStore.disablePaymentMethodGroup) {
            console.warn('Payment method group is disabled.');
        }
    }
    render() {
        if (checkoutStore.disablePaymentMethodGroup) {
            return null;
        }
        return (h(StyledHost, null, h("div", { class: "saved-payment-methods" }, checkoutStore.paymentMethods.length ? checkoutStore.paymentMethods
            .filter(this.isAllowedPaymentMethod)
            .map((paymentMethod) => (h("div", { class: "radio-list-item p-3", part: radioListItem, onClick: this.onPaymentMethodOptionClick(paymentMethod === null || paymentMethod === void 0 ? void 0 : paymentMethod.id) }, h("form-control-radio", { name: "paymentMethodType", value: paymentMethod === null || paymentMethod === void 0 ? void 0 : paymentMethod.id, checked: checkoutStore.selectedPaymentMethod === (paymentMethod === null || paymentMethod === void 0 ? void 0 : paymentMethod.id), label: `${CardBrandLabels[paymentMethod === null || paymentMethod === void 0 ? void 0 : paymentMethod.brand] || ''} *${paymentMethod === null || paymentMethod === void 0 ? void 0 : paymentMethod.acct_last_four}` })))) : null)));
    }
    static get is() { return "justifi-saved-payment-methods"; }
    static get encapsulation() { return "shadow"; }
}
