import { h } from "@stencil/core";
import { filterParams, propsParams, clearParams } from "./payouts-list-params-state";
import { StyledHost } from "../../ui-components";
import { convertToLocal, convertToUTC } from "../../utils/utils";
import { createdAfterPayoutsListFilterParam, createdBeforePayoutsListFilterParam, payoutsListFilterMenu } from "../../styles/parts";
export class PayoutsListFilters {
    constructor() {
        this.setParamsOnChange = (name, value) => {
            filterParams[name] = value;
        };
        this.handleDateInput = (name, value) => {
            const utcDate = convertToUTC(value, { setEndOfDay: true });
            this.setParamsOnChange(name, utcDate);
        };
    }
    componentWillLoad() {
        const propsToSet = {
            created_after: this.createdAfter,
            created_before: this.createdBefore
        };
        Object.entries(propsToSet).forEach(([key, value]) => {
            if (value) {
                propsParams[key] = value;
            }
        });
    }
    render() {
        const filterMenuParams = Object.assign({}, filterParams);
        return (h(StyledHost, { key: '3d52e500043d280ba63e03095096c77fe253106e' }, h("table-filters-menu", { key: '4dd85f33336a26692bbcdac30cdde6f4f091213a', params: filterMenuParams, clearParams: clearParams, part: payoutsListFilterMenu }, h("div", { key: 'f093372ebbf5841a80cf8e05cd26c8f8c992db59', class: "grid-cols-2 gap-3 p-1" }, h("div", { key: 'cc4ed47e4b8373bd787621dda6e9327581d359cb', class: "p-2" }, h("form-control-date", { key: '3f176b4fb1ec7efadf2ce38479695f9d9df2b5f1', name: "created_after", label: "Created After", inputHandler: this.handleDateInput, defaultValue: convertToLocal(this.createdAfter, { showInputDate: true }) ||
                convertToLocal(filterParams.created_after, { showInputDate: true }), disabled: !!this.createdAfter, part: createdAfterPayoutsListFilterParam })), h("div", { key: '5eabb3a72a3c223512ccf584cf5b7ee901594b30', class: "p-2" }, h("form-control-date", { key: '8ba7230275b3b89f75f1c9d5fa654c493d626940', name: "created_before", label: "Created Before", inputHandler: this.handleDateInput, defaultValue: convertToLocal(this.createdBefore, { showInputDate: true }) ||
                convertToLocal(filterParams.created_before, { showInputDate: true }), disabled: !!this.createdBefore, part: createdBeforePayoutsListFilterParam }))))));
    }
    static get is() { return "justifi-payouts-list-filters"; }
    static get encapsulation() { return "shadow"; }
    static get properties() {
        return {
            "createdAfter": {
                "type": "string",
                "attribute": "created-after",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "createdBefore": {
                "type": "string",
                "attribute": "created-before",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            }
        };
    }
}
