import { h } from "@stencil/core";
import { ButtonSpinner } from "./button-spinner";
import { buttonLoading, buttonPrimary, buttonSecondary } from "../styles/parts";
export const Button = (props, children) => {
    const variantToButton = {
        primary: buttonPrimary,
        secondary: buttonSecondary,
    };
    const getCSSParts = () => {
        return `${variantToButton[props.variant]} ${(props.isLoading) ? buttonLoading : ''}`;
    };
    return (h("button", Object.assign({ class: `btn btn-${props.variant}`, onClick: props.clickHandler, part: getCSSParts() }, props), props.isLoading ? ButtonSpinner() : children));
};
