import { h } from "@stencil/core";
import { StyledHost } from "../styled-host/styled-host";
import { Header1 } from "../headers/header-1";
import { Header2 } from "../headers/header-2";
import { Header3 } from "../headers/header-3";
export class Header {
    constructor() {
        this.levels = {
            h1: Header1,
            h2: Header2,
            h3: Header3,
        };
        this.level = 'h1';
    }
    render() {
        const HeaderComponent = this.levels[this.level];
        return (h(StyledHost, { key: '91910c2913cd5085875d33d79e33136bcf78cb14' }, h(HeaderComponent, { key: 'd915085a734fa1abb5dc03d722c954139794ace3', text: this.text, class: this.class })));
    }
    static get is() { return "justifi-header"; }
    static get encapsulation() { return "shadow"; }
    static get properties() {
        return {
            "text": {
                "type": "string",
                "attribute": "text",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            },
            "level": {
                "type": "string",
                "attribute": "level",
                "mutable": false,
                "complexType": {
                    "original": "keyof typeof this.levels",
                    "resolved": "\"h1\" | \"h2\" | \"h3\"",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false,
                "defaultValue": "'h1'"
            },
            "class": {
                "type": "string",
                "attribute": "class",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": false,
                "setter": false,
                "reflect": false
            }
        };
    }
}
