import { h, F as Fragment, r as registerInstance, c as createEvent } from './index-N3w5zrz2.js';
import { E as ErrorState } from './utils-sZ_6zOKQ.js';
import { S as StyledHost } from './styled-host-DtvbNFVU.js';
import './event-types-CZfYo5-1.js';
import { S as Skeleton } from './skeleton-D1Z4a8af.js';
import './parts-CKg_luIy.js';

const BusinessDetailsLoading = () => {
    const Block = () => (h("div", { class: "mt-5" },
        h(Skeleton, { width: "40%", height: "1.5rem" }),
        h("hr", null),
        h("div", { class: "row g-3" },
            h("div", { class: "col-12 col-md-6" },
                h(Skeleton, null),
                h(Skeleton, null),
                h(Skeleton, null)),
            h("div", { class: "col-12 col-md-6" },
                h(Skeleton, null),
                h(Skeleton, null),
                h(Skeleton, null)))));
    return (h(Fragment, null,
        h(Block, null),
        h(Block, null),
        h(Block, null),
        h(Block, null)));
};

var RENDER_STATES;
(function (RENDER_STATES) {
    RENDER_STATES["LOADING"] = "loading";
    RENDER_STATES["READY"] = "ready";
    RENDER_STATES["ERROR"] = "error";
})(RENDER_STATES || (RENDER_STATES = {}));
const BusinessDetailsCore = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.errorEvent = createEvent(this, "error-event");
        this.renderState = RENDER_STATES.LOADING;
    }
    async componentWillLoad() {
        if (this.getBusiness) {
            this.fetchData();
        }
    }
    fetchData() {
        this.renderState = RENDER_STATES.LOADING;
        this.getBusiness({
            onSuccess: ({ business }) => {
                this.business = business;
                this.renderState = RENDER_STATES.READY;
            },
            onError: ({ error, code, severity }) => {
                this.errorMessage = error;
                this.renderState = RENDER_STATES.ERROR;
                this.errorEvent.emit({
                    errorCode: code,
                    message: error,
                    severity,
                });
            }
        });
    }
    render() {
        if (this.renderState === RENDER_STATES.LOADING) {
            return (h(StyledHost, null, h(BusinessDetailsLoading, null)));
        }
        if (this.renderState === RENDER_STATES.ERROR) {
            return h(StyledHost, null, ErrorState(this.errorMessage));
        }
        return (h(StyledHost, null, h("justifi-details", { "error-message": this.errorMessage }, h("div", { slot: 'detail-sections' }, h("core-info-details", { business: this.business }), h("legal-address-details", { legalAddress: this.business.legal_address }), h("representative-details", { representative: this.business.representative }), h("owner-details", { owners: this.business.owners }), h("additional-questions-details", { additionalQuestions: this.business.additional_questions })))));
    }
};

export { BusinessDetailsCore as business_details_core };
