import { c as create$3, a as create$6 } from './index.esm-BCNUj0Dx.js';
import { k as postalValidation, l as stateValidation, m as cityValidation, n as lineTwoValidation, q as lineOneValidation, u as ssnValidation, v as dobValidation, p as phoneValidation, e as emailValidation, x as identityTitleValidation, y as identityNameValidation } from './schema-validations-DLWfpHyI.js';

const addressSchema = (allowOptionalFields) => {
    const schema = create$3({
        line1: lineOneValidation.required('Enter street address'),
        line2: lineTwoValidation.nullable(),
        city: cityValidation.required('Enter city'),
        state: stateValidation.required('Select state'),
        postal_code: postalValidation.required('Enter postal code'),
        country: create$6().required('Select country')
    });
    const easySchema = create$3({
        line1: lineOneValidation.nullable(),
        line2: lineTwoValidation.nullable(),
        city: cityValidation.nullable(),
        state: stateValidation.nullable(),
        postal_code: postalValidation.nullable(),
        country: create$6().required('Select country')
    });
    return allowOptionalFields ? easySchema : schema;
};

const identitySchema = (role, allowOptionalFields) => {
    const schema = create$3({
        name: identityNameValidation.required(`Enter ${role} name`),
        title: identityTitleValidation.required(`Enter ${role} title`),
        email: emailValidation.required(`Enter ${role} email`),
        phone: phoneValidation.required('Enter phone number'),
        dob_full: dobValidation(role).required('Enter date of birth'),
        ssn_last4: create$6().nullable(),
        identification_number: ssnValidation,
        address: addressSchema(allowOptionalFields),
    });
    const easySchema = create$3({
        name: identityNameValidation.required(`Enter ${role} name`),
        title: identityTitleValidation.nullable(),
        email: emailValidation.nullable(),
        phone: phoneValidation.nullable(),
        dob_full: dobValidation(role).nullable(),
        ssn_last4: create$6().nullable(),
        identification_number: ssnValidation.nullable(),
        address: addressSchema(allowOptionalFields),
    });
    return allowOptionalFields ? easySchema : schema;
};

export { addressSchema as a, identitySchema as i };
