import { r as registerInstance, h, H as Host } from './index-N3w5zrz2.js';
import { ay as alertDanger, G as heading2 } from './parts-CKg_luIy.js';
import { a as businessServiceReceivedOptions, r as recurringPaymentsOptions, s as seasonalBusinessOptions, b as businessClassificationOptions } from './business-form-options-CgssATyg.js';
import { C as CURRENCY_MASK, T as TAX_ID_MASKS, P as PHONE_MASKS, S as SSN_MASK } from './form-input-masks-B-iV5cYd.js';
import { C as CoreBusinessInfo } from './Business-BCoP0TAV.js';
import { d as deconstructDate } from './helpers-Mu7LQT-w.js';
import { S as StateOptions } from './state-options-BX8GieXu.js';
import { n as numberOnlyHandler } from './utils-BnjCmwMr.js';

const FormAlert = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    render() {
        if (!this.text) {
            return null;
        }
        if (this.hideAlert) {
            return null;
        }
        return (h("div", { class: 'alert alert-danger d-flex align-items-center', role: 'alert', part: alertDanger }, h("svg", { xmlns: "http://www.w3.org/2000/svg", width: "20", height: "20", fill: "currentColor", class: "bi bi-exclamation-triangle-fill flex-shrink-0 me-2", viewBox: "0 0 16 16", role: "img", "aria-label": "Warning:" }, h("path", { d: "M8.982 1.566a1.13 1.13 0 0 0-1.96 0L.165 13.233c-.457.778.091 1.767.98 1.767h13.713c.889 0 1.438-.99.98-1.767L8.982 1.566zM8 5c.535 0 .954.462.9.995l-.35 3.507a.552.552 0 0 1-1.1 0L7.1 5.995A.905.905 0 0 1 8 5zm.002 6a1 1 0 1 1 0 2 1 1 0 0 1 0-2z" })), h("div", null, this.text)));
    }
};

const AdditionalQuestions = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.errors = {};
        this.additional_questions = {};
        this.inputHandler = this.inputHandler.bind(this);
    }
    componentDidLoad() {
        this.formController.errors.subscribe(errors => (this.errors = Object.assign({}, errors)));
        this.formController.values.subscribe(values => (this.additional_questions = Object.assign({}, values.additional_questions)));
    }
    inputHandler(name, value) {
        this.formController.setValues(Object.assign(Object.assign({}, this.formController.values.getValue()), { additional_questions: Object.assign(Object.assign({}, this.formController.values.getValue().additional_questions), { [name]: value }) }));
    }
    render() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
        const additionalQuestionsDefaultValue = this.formController.getInitialValues().additional_questions;
        return (h(Host, { key: 'e3e354a7cf470f658e0f95d37186b1f45771b673' }, h("fieldset", { key: '7fb001177a4f907d513eb5955063d446234ede0c' }, h("legend", { key: 'ee6b045a438be9f56345daad752e105640f1ca3d', part: heading2 }, "Additional Questions"), h("div", { key: 'ed114675357f3b70c34a3eb941fdb30e6219cdc9', class: "row gy-3" }, h("div", { key: 'b85c27c827cf5e5d0d556c343315e5eec736f538', class: "col-12 col-md-6" }, h("form-control-monetary-provisioning", { key: '4576f67fa74ba7c2ca9730468ddc52b055a3c496', name: "business_revenue", label: "What is the business' estimated annual revenue from its primary business activities?", inputHandler: this.inputHandler, errorText: (_b = (_a = this.errors) === null || _a === void 0 ? void 0 : _a.additional_questions) === null || _b === void 0 ? void 0 : _b.business_revenue, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_revenue, maskOptions: CURRENCY_MASK.WHOLE })), h("div", { key: '0614c60cc7daaf890ccb4888d41b0260a26f9a0e', class: "col-12 col-md-6" }, h("form-control-monetary-provisioning", { key: '2c435c1553714d75542e0e3bcf1d723f26b37da8', name: "business_payment_volume", label: "What is the business' annual credit card & ACH volume anticipated to process?", inputHandler: this.inputHandler, errorText: (_d = (_c = this.errors) === null || _c === void 0 ? void 0 : _c.additional_questions) === null || _d === void 0 ? void 0 : _d.business_payment_volume, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_payment_volume, maskOptions: CURRENCY_MASK.WHOLE })), h("div", { key: '8d4a19eb0b6b5707f4a423543d86ae50f6492efc', class: "col-12" }, h("form-control-select", { key: '2e49f907bae85cd4901e4aa4413284596fbed365', name: 'business_when_service_received', label: 'On average, how long after paying will your customers typically receive their goods or services?', inputHandler: this.inputHandler, errorText: (_f = (_e = this.errors) === null || _e === void 0 ? void 0 : _e.additional_questions) === null || _f === void 0 ? void 0 : _f.business_when_service_received, options: businessServiceReceivedOptions, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_when_service_received })), h("div", { key: '11bc4e0bbe2122b977cf8bc29ac0601ef941881c', class: "col-12" }, h("form-control-select", { key: 'c511b728971250dc3272c1ef9ff96131a9ac6a2e', name: 'business_recurring_payments', label: 'Does your business offer recurring payments?', inputHandler: this.inputHandler, errorText: (_h = (_g = this.errors) === null || _g === void 0 ? void 0 : _g.additional_questions) === null || _h === void 0 ? void 0 : _h.business_recurring_payments, options: recurringPaymentsOptions, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_recurring_payments })), h("div", { key: '5a40dfe41a9fca815cdf0eb7455b41615d1e6c76', class: "col-12" }, h("form-control-text", { key: 'd8aaf0f6d7d44b1b15ec76af198a0117493f08c6', name: 'business_recurring_payments_percentage', label: 'What percent of revenue is generated from each recurring payment type offered?', inputHandler: this.inputHandler, errorText: (_k = (_j = this.errors) === null || _j === void 0 ? void 0 : _j.additional_questions) === null || _k === void 0 ? void 0 : _k.business_recurring_payments_percentage, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_recurring_payments_percentage })), h("div", { key: 'b211bb865a60baf1ea00c81f76f000ff2a31d7bd', class: "col-12" }, h("form-control-select", { key: '4b693e7425e690a59e2c70646cca2b886b8a8796', name: 'business_seasonal', label: 'Is this business seasonal?', inputHandler: this.inputHandler, errorText: (_m = (_l = this.errors) === null || _l === void 0 ? void 0 : _l.additional_questions) === null || _m === void 0 ? void 0 : _m.business_seasonal, options: seasonalBusinessOptions, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_seasonal })), h("div", { key: 'e85b7fceb9cdc808afaf3559609b7519c9630266', class: "col-12" }, h("form-control-text", { key: 'ae4a6518c7499826f30376f1c902f694244059c7', name: 'business_other_payment_details', label: 'Is there anything else you would like us to know about how your customers pay the business?', inputHandler: this.inputHandler, errorText: (_p = (_o = this.errors) === null || _o === void 0 ? void 0 : _o.additional_questions) === null || _p === void 0 ? void 0 : _p.business_other_payment_details, defaultValue: additionalQuestionsDefaultValue === null || additionalQuestionsDefaultValue === void 0 ? void 0 : additionalQuestionsDefaultValue.business_other_payment_details }))))));
    }
};

const BusinessCoreInfo = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.errors = {};
        this.coreInfo = {};
        this.inputHandler = this.inputHandler.bind(this);
    }
    componentDidLoad() {
        this.formController.values.subscribe(values => (this.coreInfo = Object.assign({}, new CoreBusinessInfo(values))));
        this.formController.errors.subscribe(errors => {
            this.errors = Object.assign({}, errors);
        });
    }
    inputHandler(name, value) {
        this.formController.setValues(Object.assign(Object.assign({}, this.formController.values.getValue()), { [name]: value }));
    }
    render() {
        const coreInfoDefaultValue = this.formController.getInitialValues();
        return (h(Host, { key: '75bbee71e68fb0dafa609838f4d3e22bf4388332' }, h("fieldset", { key: '1e1cc71bfd46b278ad3f7d3a73d5b126fbf19533' }, h("legend", { key: '341b82942f116b4a2b0b29ce505fda3a153f88ec', part: heading2 }, "General Info"), h("div", { key: 'e97b3c3a38f888795c24c887d42854c79f1f7b34', class: "row gy-3" }, h("div", { key: '6d560585e9843143c836a302ad83b19719732467', class: "col-12" }, h("form-control-text", { key: '9868049d15e3f2552feba3ff6fa6b1ab43c7ae9c', name: "legal_name", label: "Legal Name", defaultValue: coreInfoDefaultValue.legal_name, errorText: this.errors.legal_name, inputHandler: this.inputHandler })), h("div", { key: 'f77c1d66117c29b6f5963a99bbb531f76242d052', class: "col-12" }, h("form-control-text", { key: '2708d678c35d4fa9838cd3fd834c77105b94feff', name: "doing_business_as", label: "Doing Business As (DBA)", defaultValue: coreInfoDefaultValue.doing_business_as, errorText: this.errors.doing_business_as, inputHandler: this.inputHandler })), h("div", { key: 'bb17f23c8f7fc1be73524dce8ed11ce9a9524a21', class: "col-12 col-md-8" }, h("form-control-select", { key: 'bc4175a9ed29127d89cf9c6135448c80733f6959', name: "classification", label: "Business Classification", options: businessClassificationOptions, defaultValue: coreInfoDefaultValue.classification, errorText: this.errors.classification, inputHandler: this.inputHandler })), h("div", { key: '6c5faad25c64ec50023be5128b8b0527584f9a7c', class: "col-12 col-md-4" }, h("form-control-date", { key: '54a151222d7eabc40a66ffbd5d0dba2e765cd135', name: "date_of_incorporation", label: "Date of Incorporation", defaultValue: coreInfoDefaultValue.date_of_incorporation, errorText: this.errors.date_of_incorporation, inputHandler: this.inputHandler })), h("div", { key: '5a562ba1811a319d2f5dd10197be2e1ecb94da8b', class: "col-12 col-md-6" }, h("form-control-text", { key: '03780a900fd4c176e5658b0784ef57eb48d2b3f7', name: "industry", label: "Industry", defaultValue: coreInfoDefaultValue.industry, errorText: this.errors.industry, inputHandler: this.inputHandler })), h("div", { key: '96e4110eb7b40f87a804b24a2ec94defca0be899', class: "col-12 col-md-6" }, h("form-control-number-masked", { key: '3cfda64e576a93bbed143b34c235b5388dade635', name: "tax_id", label: "Tax ID", defaultValue: coreInfoDefaultValue.tax_id, errorText: this.errors.tax_id, inputHandler: this.inputHandler, mask: TAX_ID_MASKS.US })), h("div", { key: '6a6e4d87838f2666c2750662c1f031f3b8d0effe', class: "col-12" }, h("form-control-text", { key: '68f28a6b78e2df1cd69631097a001369722d8081', name: "website_url", label: "Website URL", defaultValue: coreInfoDefaultValue.website_url, errorText: this.errors.website_url, inputHandler: this.inputHandler })), h("div", { key: '8a334f64bc214d1211772e5a5018b82dadd88d1a', class: "col-12 col-md-6" }, h("form-control-text", { key: '639888a2d30e785e1d403830c718b7991f28285a', name: "email", label: "Email Address", defaultValue: coreInfoDefaultValue.email, errorText: this.errors.email, inputHandler: this.inputHandler })), h("div", { key: 'b4aac33c17ce96c5c9a9ce5a90f322f69941df5e', class: "col-12 col-md-6" }, h("form-control-number-masked", { key: 'c384d24cc34fefca964a5eb412b28360361ab780', name: "phone", label: "Phone Number", defaultValue: coreInfoDefaultValue.phone, errorText: this.errors.phone, inputHandler: this.inputHandler, mask: PHONE_MASKS.US }))))));
    }
};

const BusinessRepresentative = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.errors = {};
        this.representative = {};
        this.inputHandler = (name, value) => {
            this.formController.setValues(Object.assign(Object.assign({}, this.formController.values.getValue()), { representative: Object.assign(Object.assign({}, this.formController.values.getValue().representative), { [name]: value }) }));
        };
        this.onAddressFormUpdate = (values) => {
            this.formController.setValues(Object.assign(Object.assign({}, this.formController.values.getValue()), { representative: Object.assign(Object.assign({}, this.formController.values.getValue().representative), { address: Object.assign(Object.assign({}, this.formController.values.getValue().representative.address), values) }) }));
        };
        this.onDateOfBirthUpdate = (event) => {
            const dob_values = deconstructDate(event.detail);
            this.formController.setValues(Object.assign(Object.assign({}, this.formController.values.getValue()), { representative: Object.assign(Object.assign({}, this.formController.values.getValue().representative), { dob_day: dob_values.dob_day, dob_month: dob_values.dob_month, dob_year: dob_values.dob_year }) }));
        };
    }
    get identificationNumberLabel() {
        return this.representative.ssn_last4 ? 'Update SSN (optional)' : 'SSN';
    }
    componentDidLoad() {
        this.formController.errors.subscribe(errors => (this.errors = Object.assign({}, errors.representative)));
        this.formController.values.subscribe(values => (this.representative = Object.assign({}, values.representative)));
    }
    render() {
        const representativeDefaultValue = this.formController.getInitialValues().representative;
        return (h(Host, { key: '88bd35928331776d5cbb7d085fd55a76fde1a084' }, h("fieldset", { key: '202c40f332352c2f4d3c8a136888c39c67379e5f' }, h("legend", { key: 'a0b5043b348b1d8632a6bf0fe2d4309a8132d1f7', part: heading2 }, "Representative"), h("div", { key: 'ba50c004e2b37f384dd8af63b1e0e397abadb9de', class: "row gy-3" }, h("div", { key: 'b85bf5fb0da9e8feae19dbebb0a911362e914601', class: "col-12 col-md-8" }, h("form-control-text", { key: '95f849c7c0ba0c67bdc0a55727e00755e03897ef', name: "name", label: "Full Name", defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.name, errorText: this.errors.name, inputHandler: this.inputHandler })), h("div", { key: '074067a3ce960b678ea38d53b84adda24e60754c', class: "col-12 col-md-4" }, h("form-control-text", { key: '7ef397af32b7c0f79eeae1499bf3d3d147961c96', name: "title", label: "Title", defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.title, errorText: this.errors.title, inputHandler: this.inputHandler })), h("div", { key: 'a26bfd8a0824aaa12c6ffa48ac58c2bccc7236ef', class: "col-12 col-md-6" }, h("form-control-text", { key: '39174c4b812462d1aa28824bca550e3f6e1d98b4', name: "email", label: "Email Address", defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.email, errorText: this.errors.email, inputHandler: this.inputHandler })), h("div", { key: 'ed0a2c52e4df0c43b2536dfd1ff3692a4e5716d9', class: "col-12 col-md-6" }, h("form-control-number-masked", { key: '07bdcc1dd2e1473b64218eb28c8cdcf1cdce2a91', name: "phone", label: "Phone Number", defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.phone, errorText: this.errors.phone, inputHandler: this.inputHandler, mask: PHONE_MASKS.US })), h("div", { key: '96092fd371ec82a8f8ebbf8bc4e3064768d4ad97', class: "col-12 col-md-4" }, h("form-control-date", { key: 'c24980f126c056aff139e897fdef9795905ea89b', name: "dob_full", label: "Birth Date", defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.dob_full, errorText: this.errors.dob_full, inputHandler: this.inputHandler, onFormControlInput: this.onDateOfBirthUpdate })), h("div", { key: '9d1695fa6e68bb4ae9a8184dcb5e15d588474ab8', class: "col-12 col-md-8" }, h("form-control-number-masked", { key: '8d8a56c08fb06f1a54baf3ee3d6e31a684205290', name: "identification_number", label: this.identificationNumberLabel, defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.identification_number, errorText: this.errors.identification_number, inputHandler: this.inputHandler, mask: SSN_MASK })), h("div", { key: '22fa5e16517e14ab031aa5e7e95ea77bd7b28986', class: "col-12" }, h("justifi-identity-address-form", { key: '4a990de739a0ae6fbf1f6a621ff7c0078517e970', errors: this.errors.address, defaultValues: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.address, handleFormUpdate: this.onAddressFormUpdate }))))));
    }
};

const LegalAddressForm = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.errors = {};
        this.inputHandler = this.inputHandler.bind(this);
    }
    componentDidLoad() {
        this.formController.errors.subscribe(errors => (this.errors = Object.assign({}, errors)));
        this.formController.values.subscribe(values => (this.legal_address = Object.assign({}, values.legal_address)));
    }
    inputHandler(name, value) {
        this.formController.setValues(Object.assign(Object.assign({}, this.formController.values.getValue()), { legal_address: Object.assign(Object.assign({}, this.formController.values.getValue().legal_address), { [name]: value }) }));
    }
    render() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
        const legalAddressDefaultValue = this.formController.getInitialValues().legal_address;
        return (h(Host, { key: '5b21d99717f9b24c0551c7a96acf68e53e7787bf' }, h("fieldset", { key: 'd63cbd20b2648405c50a819724e0f8cf556f7d26' }, h("legend", { key: 'c0acd14073f13f914015f40d39bf22fb58792434', part: heading2 }, "Business Legal Address"), h("div", { key: 'ee4cee6bd662816f822ee209aeda5e9664f6a64d', class: "row gy-3" }, h("div", { key: '86b258fd09e73cbd2475330419274732231f3871', class: "col-12" }, h("form-control-text", { key: '8d898a9ae448f07932afe2d8cfc2314b92d9c597', name: "line1", label: "Legal Address", inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.line1, errorText: (_b = (_a = this.errors) === null || _a === void 0 ? void 0 : _a.legal_address) === null || _b === void 0 ? void 0 : _b.line1 })), h("div", { key: '1a50c4b86a754035f71efacd39721219fcd54d60', class: "col-12" }, h("form-control-text", { key: '507b1451685e359a900f0bc7010ff39e3631daf2', name: "line2", label: "Address Line 2", inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.line2, errorText: (_d = (_c = this.errors) === null || _c === void 0 ? void 0 : _c.legal_address) === null || _d === void 0 ? void 0 : _d.line2 })), h("div", { key: '1446b4db5f86a3b18e3aceb78274ffe458dbd3db', class: "col-12" }, h("form-control-text", { key: 'e17e4bd95ad4290d18edde79cf05a6b3a105166c', name: "city", label: "City", inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.city, errorText: (_f = (_e = this.errors) === null || _e === void 0 ? void 0 : _e.legal_address) === null || _f === void 0 ? void 0 : _f.city })), h("div", { key: '9b880203bad9e104e6d1299ff73c83cba46ab563', class: "col-12" }, h("form-control-select", { key: '24e4df10f688c9a1b5f2af5217f03919bf7abec7', name: "state", label: "State", options: StateOptions, inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.state, errorText: (_h = (_g = this.errors) === null || _g === void 0 ? void 0 : _g.legal_address) === null || _h === void 0 ? void 0 : _h.state })), h("div", { key: '71f21b19602c268e3b6a839ce41ff9d4f8ffb8c4', class: "col-12" }, h("form-control-text", { key: 'ca71d3e21c5a0aea5367fa28ec1a2422ba9b1cf3', name: "postal_code", label: "Postal Code", inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.postal_code, errorText: (_k = (_j = this.errors) === null || _j === void 0 ? void 0 : _j.legal_address) === null || _k === void 0 ? void 0 : _k.postal_code, maxLength: 5, keyDownHandler: numberOnlyHandler })), h("div", { key: 'aaee0bf6a24ba182e002c1ffb49736fb622cde1f', class: "col-12" }, h("form-control-select", { key: '2b6486771818e584dcc195c304e5a6e16850b4a9', name: "country", label: "Country", options: [{ label: 'United States', value: 'USA' }], inputHandler: this.inputHandler, defaultValue: legalAddressDefaultValue === null || legalAddressDefaultValue === void 0 ? void 0 : legalAddressDefaultValue.country, errorText: (_m = (_l = this.errors) === null || _l === void 0 ? void 0 : _l.legal_address) === null || _m === void 0 ? void 0 : _m.country,
            // just for now so we skip handling country specificities
            disabled: true }))))));
    }
};

export { FormAlert as form_alert, AdditionalQuestions as justifi_additional_questions, BusinessCoreInfo as justifi_business_core_info, BusinessRepresentative as justifi_business_representative, LegalAddressForm as justifi_legal_address_form };
