import { r as registerInstance, c as createEvent, h, H as Host } from './index-N3w5zrz2.js';
import { Y as inputCheckboxInvalid, Z as inputCheckboxCheckedFocused, _ as inputCheckboxFocused, $ as inputCheckboxChecked, a0 as inputCheckbox, l as label } from './parts-CKg_luIy.js';
import { F as FormControlHelpText } from './form-control-help-text-mOLCXs00.js';
import { F as FormControlErrorText } from './form-control-error-text-Bk3yfpFX.js';
import './event-types-CZfYo5-1.js';

const CheckboxInput = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.formControlInput = createEvent(this, "formControlInput");
        this.formControlBlur = createEvent(this, "formControlBlur");
        this.isFocused = false;
        this.handleFormControlInput = (event) => {
            event.preventDefault();
            const target = event.target;
            const name = target.getAttribute('name');
            this.inputHandler(name, target.checked);
            this.formControlInput.emit({ name, value: target.value });
        };
        this.updateInput = (newValue) => {
            this.checkboxElement.checked = newValue;
        };
    }
    get part() {
        if (this.errorText) {
            return inputCheckboxInvalid;
        }
        if (this.isFocused && this.checked) {
            return inputCheckboxCheckedFocused;
        }
        if (this.isFocused) {
            return inputCheckboxFocused;
        }
        if (this.checked) {
            return inputCheckboxChecked;
        }
        return inputCheckbox;
    }
    render() {
        return (h(Host, { key: 'f574898ffe8a3d666d4b95721cf4f3f3866f8632' }, h("div", { key: '185ac07832d140b467162e2bdacb90ea0640d460', class: 'form-group d-flex flex-column' }, h("div", { key: 'c610e4c989b6c8529253ef73e39d4e58f0efd1e3', class: "form-check" }, h("input", { key: '7abfbfed27e3ad2c0a46a5f30b0681d54673c1fb', ref: el => (this.checkboxElement = el), type: "checkbox", id: this.name, name: this.name, onFocus: () => this.isFocused = true, onBlur: () => {
                this.isFocused = false;
                this.formControlBlur.emit();
            }, onInput: this.handleFormControlInput, part: this.part, class: this.errorText ? 'form-check-input is-invalid' : 'form-check-input', disabled: this.disabled, checked: this.checked }), h("label", { key: '9c505e1d0926690eb32d2d9621d6c144cfe27f6a', class: "form-check-label", htmlFor: this.name, part: label }, this.label)), h(FormControlHelpText, { key: 'fc7933d29f06ef533fe45025184d5c8cdd24cdd1', helpText: this.helpText, name: this.name }), h(FormControlErrorText, { key: '29879fd2d7c04a26eb999bb2f9991bc38515994b', errorText: this.errorText, name: this.name }))));
    }
};

export { CheckboxInput as form_control_checkbox };
