import { r as registerInstance, c as createEvent, h, H as Host } from './index-N3w5zrz2.js';
import { c as input, l as label, b as inputInvalid, T as inputDisabled, a as inputFocused } from './parts-CKg_luIy.js';
import { F as FormControlErrorText } from './form-control-error-text-Bk3yfpFX.js';
import './event-types-CZfYo5-1.js';

const DateInput = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.formControlInput = createEvent(this, "formControlInput");
        this.formControlBlur = createEvent(this, "formControlBlur");
        this.isFocused = false;
        this.maxDate = this.currentDate;
        this.handleFormControlInput = (event) => {
            const dateValue = event.target.value;
            this.inputHandler(this.name, dateValue);
            this.formControlInput.emit({ name: this.name, value: dateValue });
        };
    }
    handleDefaultValueChange(newValue) {
        this.updateInput(newValue);
    }
    get currentDate() {
        if (!this.showTime) {
            return new Date().toISOString().split('T')[0];
        }
        else {
            return new Date().toISOString().slice(0, 16);
        }
    }
    componentDidLoad() {
        this.updateInput(this.defaultValue);
    }
    updateInput(value) {
        this.dateInput.value = value;
    }
    get part() {
        let part = input;
        if (this.errorText) {
            part = inputInvalid;
        }
        if (this.disabled) {
            part = inputDisabled;
        }
        if (this.isFocused) {
            part = inputFocused;
        }
        return part;
    }
    render() {
        return (h(Host, { key: '42d56dc5835b06508f48e7eb8b5dca063d32dd5f' }, h("div", { key: '9a111c9f90604df8c32f66d1f0bcb05ebca9bad5', class: "form-group d-flex flex-column" }, h("div", { key: 'bec15b51e5d0f03cd4a69abcc3f0ee727262479b', class: "d-flex gap-2" }, h("label", { key: 'b57723374131e145d8c1307d7b94a5240ead9b4b', part: label, class: "form-label", htmlFor: this.name }, this.label), h("form-control-tooltip", { key: '2c03597da3e1db9fafd25a3835ee9b72dcb54a6d', helpText: this.helpText })), h("input", { key: 'b5e7e7b38fc6ba6c68cf1773e8ad68f09663a1cd', type: this.showTime ? 'datetime-local' : 'date', ref: el => (this.dateInput = el), id: this.name, name: this.name, onFocus: () => this.isFocused = true, onBlur: () => {
                this.isFocused = false;
                this.formControlBlur.emit();
            }, onInput: this.handleFormControlInput, part: this.part, class: this.errorText ? 'form-control is-invalid' : 'form-control', disabled: this.disabled, max: this.maxDate }), h(FormControlErrorText, { key: '4ac80bbeaa886a8822b641f3643c6a36d1bbe111', errorText: this.errorText, name: this.name }))));
    }
    static get watchers() { return {
        "defaultValue": ["handleDefaultValueChange"]
    }; }
};

export { DateInput as form_control_date };
