import { r as registerInstance, c as createEvent, h, H as Host, a as getElement } from './index-N3w5zrz2.js';
import { F as FormControlErrorText } from './form-control-error-text-Bk3yfpFX.js';
import { i as inputInvalidAndFocused, b as inputInvalid, a as inputFocused, T as inputDisabled, c as input, l as label } from './parts-CKg_luIy.js';

const FileInput = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.formControlInput = createEvent(this, "formControlInput");
        this.formControlBlur = createEvent(this, "formControlBlur");
    }
    render() {
        return (h(Host, { key: '09a00c508e5f8a6760a10596caa60e39650ae3dc', exportparts: "label,input,input-invalid" }, h("div", { key: 'af053f126524dc7dc5f02d5f6ef871012097e1a4', class: "form-group d-flex flex-column" }, h("div", { key: 'e7cbe9ae561c54c14ef4bf1adb4405f93e52a0da', class: "d-flex align-items-start gap-2" }, h("label", { key: '84173f53d2d70e8f3728cd5ed69dff4fa86ee659', part: "label", class: "form-label", htmlFor: this.name }, this.label), h("form-control-tooltip", { key: 'a5f6fa27696c3cb673c5b10a7cf7049c2be1d113', helpText: this.helpText })), h("input", { key: '8f39d6dfaa711830059c04fcbb0b99600d269000', type: "file", name: this.name, part: `input ${this.errorText ? "input-invalid " : ""}${this.disabled ? "input-disabled" : ""}`, class: this.errorText ? "form-control is-invalid" : "form-control", multiple: this.multiple, disabled: this.disabled, onBlur: () => this.formControlBlur.emit(), onChange: () => this.errorText = "" }), h(FormControlErrorText, { key: 'f9c61d2900f3a0776895c51d9f1aa42e6aabac4b', errorText: this.errorText, name: this.name }))));
    }
    get el() { return getElement(this); }
};

const TextInput = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.formControlInput = createEvent(this, "formControlInput");
        this.formControlBlur = createEvent(this, "formControlBlur");
        this.isFocused = false;
        this.handleFormControlInput = (event) => {
            const target = event.target;
            const name = target.getAttribute('name');
            this.inputHandler(name, target.value);
            this.formControlInput.emit({ name, value: target.value });
        };
        this.updateInput = (newValue) => {
            const inputElement = this.el.querySelector('textarea');
            if (inputElement) {
                inputElement.value = newValue || '';
            }
        };
    }
    handleDefaultValueChange(newValue) {
        this.updateInput(newValue);
    }
    componentDidLoad() {
        this.updateInput(this.defaultValue);
    }
    get part() {
        if (this.isFocused && this.errorText) {
            return inputInvalidAndFocused;
        }
        if (this.errorText) {
            return inputInvalid;
        }
        if (this.isFocused) {
            return inputFocused;
        }
        if (this.disabled) {
            return inputDisabled;
        }
        return input;
    }
    render() {
        return (h(Host, { key: '8b7aa0820fe8e28893564b1db81f9a46af19ba5a' }, h("div", { key: '430c5979f3926703d09bbe33319634b77d8061e4', class: "form-group d-flex flex-column" }, h("label", { key: '74e5ea2805d737f43350d95ee95a3de0b3283661', part: label, class: "form-label", htmlFor: this.name }, this.label), h("textarea", { key: '64d7394cb65fcb16330c34efee4b343b7017be92', id: this.name, name: this.name, onFocus: () => this.isFocused = true, onBlur: () => {
                this.isFocused = false;
                this.formControlBlur.emit();
            }, onInput: this.handleFormControlInput, onKeyDown: this.keyDownHandler, onPaste: this.keyDownHandler, maxLength: this.maxLength, part: this.part, class: this.errorText ? 'form-control is-invalid' : 'form-control', disabled: this.disabled }), h("form-control-help-text", { key: '83b3b2f47a805d6896cc7b2c43bb57fce3242c4c', helpText: this.helpText, name: this.name }), h("form-control-error-text", { key: '9670a3995f4530352df05956bbd6827def43baed', errorText: this.errorText, name: this.name }))));
    }
    get el() { return getElement(this); }
    static get watchers() { return {
        "defaultValue": ["handleDefaultValueChange"]
    }; }
};

export { FileInput as form_control_file_v2, TextInput as form_control_textarea };
