import { r as registerInstance, c as createEvent, h, H as Host, a as getElement } from './index-N3w5zrz2.js';
import { i as inputInvalidAndFocused, a as inputFocused, b as inputInvalid, c as input, l as label } from './parts-CKg_luIy.js';
import { F as FormControlHelpText } from './form-control-help-text-mOLCXs00.js';
import { F as FormControlErrorText } from './form-control-error-text-Bk3yfpFX.js';
import './event-types-CZfYo5-1.js';

const NumberInput = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.formControlInput = createEvent(this, "formControlInput");
        this.formControlBlur = createEvent(this, "formControlBlur");
        this.isFocused = false;
        this.handleFormControlInput = (event) => {
            const target = event.target;
            const name = target.getAttribute('name');
            this.inputHandler(name, target.value);
            this.formControlInput.emit({ name, value: target.value });
        };
        this.updateInput = (newValue) => {
            const inputElement = this.el.querySelector('input');
            if (inputElement) {
                inputElement.value = newValue || '';
            }
        };
    }
    handleDefaultValueChange(newValue) {
        this.updateInput(newValue);
    }
    componentDidLoad() {
        this.updateInput(this.defaultValue);
    }
    get part() {
        if (this.isFocused && this.errorText) {
            return inputInvalidAndFocused;
        }
        if (this.isFocused) {
            return inputFocused;
        }
        if (this.errorText) {
            return inputInvalid;
        }
        return input;
    }
    render() {
        return (h(Host, { key: '0c518001e14574c5c7bce66643ec03571eb80e86' }, h("div", { key: 'd09fbf1cd01990d2d73fe8ca3b0ee59ba48b4631', class: 'form-group d-flex flex-column' }, h("label", { key: '51476220a170a30e6fb8eabb06c0dc16b5231a59', part: label, class: "form-label", htmlFor: this.name }, this.label), h("input", { key: '3d31c0cbb62e9f9957994b3a4d2fc26330aa4ee8', id: this.name, name: this.name, onFocus: () => this.isFocused = true, onBlur: () => {
                this.isFocused = false;
                this.formControlBlur.emit();
            }, onInput: this.handleFormControlInput, part: this.part, class: this.errorText ? 'form-control is-invalid' : 'form-control', type: "number", disabled: this.disabled }), h(FormControlHelpText, { key: '48241a9ebf6118a0b231d05b7aa14ade91e105b7', helpText: this.helpText, name: this.name }), h(FormControlErrorText, { key: '53b60709bd2c431e93fe411c498df28dca5dbc30', errorText: this.errorText, name: this.name }))));
    }
    get el() { return getElement(this); }
    static get watchers() { return {
        "defaultValue": ["handleDefaultValueChange"]
    }; }
};

export { NumberInput as form_control_number };
