import { r as registerInstance, c as createEvent, h, H as Host } from './index-N3w5zrz2.js';
import { a2 as inputRadioInvalid, a3 as inputRadioCheckedFocused, a4 as inputRadioChecked, a5 as inputRadioFocused, a6 as inputRadio, l as label } from './parts-CKg_luIy.js';

const RadioInput = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.formControlInput = createEvent(this, "formControlInput");
        this.formControlBlur = createEvent(this, "formControlBlur");
        this.isFocused = false;
        this.handleFormControlInput = (event) => {
            const target = event.target;
            const name = target.getAttribute('name');
            this.inputHandler(name, this.value);
            this.formControlInput.emit({ name, value: this.value });
        };
    }
    get part() {
        if (this.errorText) {
            return inputRadioInvalid;
        }
        if (this.isFocused && this.checked) {
            return inputRadioCheckedFocused;
        }
        if (this.checked) {
            return inputRadioChecked;
        }
        if (this.isFocused) {
            return inputRadioFocused;
        }
        return inputRadio;
    }
    render() {
        return (h(Host, { key: 'd14a72683af8b1acaa69c203939b736a4c0dccb1', class: 'form-group d-flex flex-column' }, h("div", { key: '7c6f41ce758caf8c4dde203bdfa01088295a0d1c', class: "form-check" }, h("input", { key: '44577027dce61879ecf2eb697040364d4a383e3e', ref: el => (this.radioElement = el), type: "radio", id: `${this.name}-${this.value}`, name: this.name, onFocus: () => this.isFocused = true, onBlur: () => {
                this.isFocused = false;
                this.formControlBlur.emit();
            }, onChange: this.handleFormControlInput, part: this.part, class: this.errorText ? 'form-check-input is-invalid' : 'form-check-input', disabled: this.disabled, value: this.value, checked: this.checked }), h("label", { key: '865a2e9b10774fd3e8c1352a20eb8c8b08d0adc4', class: "form-check-label", htmlFor: `${this.name}-${this.value}`, part: label }, this.label)), h("form-control-help-text", { key: '8b9e73b963315bb209ed1a7f086d86020c56fc3b', helpText: this.helpText, name: this.name }), h("form-control-error-text", { key: 'a64d416e7683886a2846594b33f5205545fd3bf9', errorText: this.errorText, name: this.name })));
    }
};

export { RadioInput as form_control_radio };
