import { C as ComponentErrorSeverity } from './ComponentError-BhrFjjAs.js';
import { g as getErrorCode, a as getErrorMessage } from './utils-BZvep88z.js';

const makeGetPayoutCSV = ({ authToken, service }) => async ({ payoutId, onError }) => {
    try {
        const { data } = await service.fetchCSV(payoutId, authToken);
        const a = document.createElement('a');
        a.href = data.csv_url;
        a.click();
    }
    catch (error) {
        const errorMessage = getErrorMessage(error);
        const code = getErrorCode(error === null || error === void 0 ? void 0 : error.code);
        onError({
            error: errorMessage,
            code,
            severity: ComponentErrorSeverity.ERROR,
        });
    }
};

export { makeGetPayoutCSV as m };
