import { S as StateOptions } from './state-options-BX8GieXu.js';

function getStateAbbreviation(stateName) {
    const state = StateOptions.find(s => s.label === stateName);
    return state ? state.value : stateName;
}
// filterNumber is intended to be used to format a string that contains a single digit to a two digit string. 
function filterNumber(num) {
    if (/^\d$/.test(num)) {
        return '0' + num;
    }
    return num;
}
function constructDate(year, month, day) {
    if (!year || !month || !day) {
        return;
    }
    return `${year}-${filterNumber(month)}-${filterNumber(day)}`;
}
function deconstructDate(formInput) {
    const dateString = formInput.value;
    const [dob_year, dob_month, dob_day] = dateString.split('-');
    return { dob_year, dob_month, dob_day };
}
function checkProvisioningStatus(business) {
    return business.associated_accounts.length > 0;
}

export { constructDate as a, checkProvisioningStatus as c, deconstructDate as d, filterNumber as f, getStateAbbreviation as g };
