import { r as registerInstance, c as createEvent, h } from './index-N3w5zrz2.js';
import { E as ErrorState } from './utils-sZ_6zOKQ.js';
import { B as BusinessService } from './business.service-BPBxsb8B.js';
import { m as makeGetBusiness } from './get-business-BSRtbTh7.js';
import { C as ComponentErrorSeverity, a as ComponentErrorCodes } from './ComponentError-BhrFjjAs.js';
import { c as checkPkgVersion, J as JustifiAnalytics } from './check-pkg-version-Cic-MeLf.js';
import './parts-CKg_luIy.js';
import './Api-BCeKXDaf.js';
import './config-state-B3mtRA6f.js';
import './index-BAq5IUBW.js';
import './utils-Cu5hITuT.js';
import './dinero-DizZAUMY.js';
import './_commonjsHelpers-BFTU3MAI.js';
import './Refund-DBHZkemk.js';
import './Dispute-BH0Xfn-F.js';
import './Pagination-CLHwhyvu.js';
import './Business-BCoP0TAV.js';
import './helpers-Mu7LQT-w.js';
import './state-options-BX8GieXu.js';
import './utils-BZvep88z.js';
import './package-BRJ4FIJH.js';

const BusinessDetails = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.errorEvent = createEvent(this, "error-event");
        this.errorMessage = null;
        this.handleErrorEvent = event => {
            this.errorMessage = event.detail.message;
            this.errorEvent.emit(event.detail);
        };
    }
    componentWillLoad() {
        checkPkgVersion();
        this.analytics = new JustifiAnalytics(this);
        this.initializeGetBusiness();
    }
    disconnectedCallback() {
        var _a;
        (_a = this.analytics) === null || _a === void 0 ? void 0 : _a.cleanup();
    }
    ;
    initializeGetBusiness() {
        if (!this.businessId || !this.authToken) {
            this.errorMessage = 'Invalid business id or auth token';
            this.errorEvent.emit({
                errorCode: ComponentErrorCodes.MISSING_PROPS,
                message: this.errorMessage,
                severity: ComponentErrorSeverity.ERROR,
            });
            return;
        }
        this.getBusiness = makeGetBusiness({
            id: this.businessId,
            authToken: this.authToken,
            service: new BusinessService(),
        });
    }
    render() {
        if (this.errorMessage) {
            return ErrorState(this.errorMessage);
        }
        return (h("business-details-core", { getBusiness: this.getBusiness, "onError-event": this.handleErrorEvent }));
    }
};

export { BusinessDetails as justifi_business_details };
