import { r as registerInstance, h } from './index-N3w5zrz2.js';
import './config-state-B3mtRA6f.js';
import './dinero-DizZAUMY.js';
import './ComponentError-BhrFjjAs.js';
import { I as ICheckoutStatus, a as ICheckoutPaymentModeParam } from './Refund-DBHZkemk.js';
import './Pagination-CLHwhyvu.js';
import './Business-BCoP0TAV.js';
import './Dispute-BH0Xfn-F.js';
import { f as filterParams, p as propsParams, c as clearParams } from './checkouts-list-params-state-DFWVMJRJ.js';
import { e as checkoutsListFilterMenu, s as statusCheckoutsListFilterParam, p as paymentModeCheckoutsListFilterParam } from './parts-CKg_luIy.js';
import { S as StyledHost } from './styled-host-DtvbNFVU.js';
import './event-types-CZfYo5-1.js';
import './index-BAq5IUBW.js';
import './_commonjsHelpers-BFTU3MAI.js';
import './utils-Cu5hITuT.js';
import './helpers-Mu7LQT-w.js';
import './state-options-BX8GieXu.js';

const CheckoutsListFilters = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.setParamsOnChange = (name, value) => {
            filterParams[name] = value;
        };
    }
    componentWillLoad() {
        const propsToSet = {
            status: this.checkoutStatus,
            payment_mode: this.paymentMode,
        };
        Object.entries(propsToSet).forEach(([key, value]) => {
            if (value) {
                propsParams[key] = value;
            }
        });
    }
    get checkoutStatusOptions() {
        return [
            { label: 'All', value: '' },
            { label: 'Created', value: ICheckoutStatus.created },
            { label: 'Completed', value: ICheckoutStatus.completed },
            { label: 'Attempted', value: ICheckoutStatus.attempted },
            { label: 'Expired', value: ICheckoutStatus.expired },
        ];
    }
    get checkoutPaymentModeOptions() {
        return [
            { label: 'All', value: '' },
            { label: 'E-commerce', value: ICheckoutPaymentModeParam.ecom },
            { label: 'BNPL', value: ICheckoutPaymentModeParam.bnpl },
        ];
    }
    render() {
        const filterMenuParams = Object.assign({}, filterParams);
        return (h(StyledHost, { key: '05a4d429a1acd7bbaf202872523284e2b2cd3677' }, h("table-filters-menu", { key: 'abf61654a75212537af580f3bfd2646042eaba8a', params: filterMenuParams, clearParams: clearParams, part: checkoutsListFilterMenu }, h("div", { key: 'f8e5cfe4b0a23723d0df939a1d1873adffcb1da9', class: "grid-cols-2 gap-3 p-1" }, h("div", { key: 'd9e23e96a7269b3609e690a1e64e8c20bd125cb7', class: "p-2" }, h("form-control-select", { key: 'e1899dbc615be07486bc54f8baa395bee776d8ce', name: "status", label: "Status", options: this.checkoutStatusOptions, inputHandler: this.setParamsOnChange, defaultValue: this.checkoutStatus || filterParams.status, disabled: !!this.checkoutStatus, part: statusCheckoutsListFilterParam })), h("div", { key: 'bedbc26d9d9f6906013ef4b80542d9031822b19c', class: "p-2" }, h("form-control-select", { key: '3bfef7fabeb85a29304e11093005bb1f58b23f41', name: "payment_mode", label: "Payment Mode", options: this.checkoutPaymentModeOptions, inputHandler: this.setParamsOnChange, defaultValue: this.paymentMode || filterParams.payment_mode, disabled: !!this.paymentMode, part: paymentModeCheckoutsListFilterParam }))))));
    }
};

export { CheckoutsListFilters as justifi_checkouts_list_filters };
