import { r as registerInstance, c as createEvent, h } from './index-N3w5zrz2.js';
import { P as PaymentService } from './payment.service-BTVtIbcY.js';
import { m as makeGetPaymentDetails } from './get-payment-details-B193kh7P.js';
import { E as ErrorState } from './utils-sZ_6zOKQ.js';
import { C as ComponentErrorSeverity, a as ComponentErrorCodes } from './ComponentError-BhrFjjAs.js';
import { c as checkPkgVersion, J as JustifiAnalytics } from './check-pkg-version-Cic-MeLf.js';
import './Api-BCeKXDaf.js';
import './config-state-B3mtRA6f.js';
import './index-BAq5IUBW.js';
import './utils-Cu5hITuT.js';
import './dinero-DizZAUMY.js';
import './_commonjsHelpers-BFTU3MAI.js';
import './Refund-DBHZkemk.js';
import './Dispute-BH0Xfn-F.js';
import './Pagination-CLHwhyvu.js';
import './Business-BCoP0TAV.js';
import './helpers-Mu7LQT-w.js';
import './state-options-BX8GieXu.js';
import './utils-BZvep88z.js';
import './parts-CKg_luIy.js';
import './package-BRJ4FIJH.js';

const PaymentDetails = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.errorEvent = createEvent(this, "error-event");
        this.errorMessage = null;
        this.paymentService = new PaymentService();
        this.handleErrorEvent = event => {
            this.errorMessage = event.detail.message;
            this.errorEvent.emit(event.detail);
        };
    }
    componentWillLoad() {
        checkPkgVersion();
        this.analytics = new JustifiAnalytics(this);
        this.initializeGetPaymentDetails();
    }
    disconnectedCallback() {
        var _a;
        (_a = this.analytics) === null || _a === void 0 ? void 0 : _a.cleanup();
    }
    ;
    propChanged() {
        this.initializeGetPaymentDetails();
    }
    initializeGetPaymentDetails() {
        if (this.paymentId && this.authToken) {
            this.getPaymentDetails = makeGetPaymentDetails({
                id: this.paymentId,
                authToken: this.authToken,
                service: new PaymentService()
            });
        }
        else {
            this.errorMessage = 'Payment ID and Auth Token are required';
            this.errorEvent.emit({
                message: this.errorMessage,
                errorCode: ComponentErrorCodes.MISSING_PROPS,
                severity: ComponentErrorSeverity.ERROR,
            });
        }
    }
    render() {
        if (this.errorMessage) {
            return ErrorState(this.errorMessage);
        }
        return (h("payment-details-core", { getPaymentDetails: this.getPaymentDetails, "onError-event": this.handleErrorEvent }));
    }
    static get watchers() { return {
        "paymentId": ["propChanged"],
        "authToken": ["propChanged"]
    }; }
};

export { PaymentDetails as justifi_payment_details };
