import { r as registerInstance, h } from './index-N3w5zrz2.js';
import { l as lodashExports } from './lodash-BqWxUrkh.js';
import { f as filterParams, p as propsParams, c as clearParams } from './terminals-list-params-state-DFWVMJRJ.js';
import { y as terminalsListFilterMenu, z as terminalIdTerminalsListFilterParam, A as terminalOrderIdTerminalsListFilterParam, B as terminalStatusTerminalsListFilterParam } from './parts-CKg_luIy.js';
import { S as StyledHost } from './styled-host-DtvbNFVU.js';
import './event-types-CZfYo5-1.js';
import './config-state-B3mtRA6f.js';
import './dinero-DizZAUMY.js';
import './ComponentError-BhrFjjAs.js';
import { d as ITerminalStatus } from './Refund-DBHZkemk.js';
import './Pagination-CLHwhyvu.js';
import './Business-BCoP0TAV.js';
import './Dispute-BH0Xfn-F.js';
import './_commonjsHelpers-BFTU3MAI.js';
import './index-BAq5IUBW.js';
import './utils-Cu5hITuT.js';
import './helpers-Mu7LQT-w.js';
import './state-options-BX8GieXu.js';

const TerminalsListFilters = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.setParamsOnChange = (name, value) => {
            filterParams[name] = value;
        };
    }
    componentWillLoad() {
        // debounced input handler for text input
        this.debouncedSetParamsOnChange = lodashExports.debounce(this.setParamsOnChange, 300);
        const propsToSet = {
            terminal_id: this.terminalId,
            status: this.terminalStatus,
            terminal_order_id: this.terminalOrderId
        };
        Object.entries(propsToSet).forEach(([key, value]) => {
            if (value) {
                propsParams[key] = value;
            }
        });
    }
    get terminalStatusOptions() {
        return [
            { label: 'All', value: '' },
            { label: 'Connected', value: ITerminalStatus.connected },
            { label: 'Disconnected', value: ITerminalStatus.disconnected },
            { label: 'Unknown', value: ITerminalStatus.unknown },
            { label: 'Pending Configuration', value: ITerminalStatus.pending_configuration }
        ];
    }
    render() {
        const filterMenuParams = Object.assign({}, filterParams);
        return (h(StyledHost, { key: 'a5fe1671dd03e1290544f3deaf5aa01b5d937d9d' }, h("table-filters-menu", { key: 'f7a3d95c1b0ad0b52b96f990fd56fdbe64643493', params: filterMenuParams, clearParams: clearParams, part: terminalsListFilterMenu }, h("div", { key: '92b0144a5ab7eee377e053e9b006af846ac43d64', class: "grid-cols-2 gap-3 p-1" }, h("div", { key: '3970a2e11f3be7953af299be4825166a829e9a0a', class: "p-2" }, h("form-control-text", { key: '0653692eaffdb14b092643a9f3c1b8e126c942db', name: "terminal_id", label: "Terminal ID", inputHandler: this.debouncedSetParamsOnChange, defaultValue: this.terminalId || filterParams.terminal_id, disabled: !!this.terminalId, part: terminalIdTerminalsListFilterParam })), h("div", { key: 'c9d152d0a2d7e7b7fd7e72693a2248a020545a24', class: "p-2" }, h("form-control-text", { key: '785e7b382d9cadb72e242a379f2525b2da5140de', name: "terminal_order_id", label: "Terminal Order ID", inputHandler: this.debouncedSetParamsOnChange, defaultValue: this.terminalOrderId || filterParams.terminal_order_id, disabled: !!this.terminalOrderId, part: terminalOrderIdTerminalsListFilterParam })), h("div", { key: 'f4f1e79eb81a72dd25bb4f4c14450ca82657f213', class: "p-2" }, h("form-control-select", { key: '52b390e42309e13e2f09df0681392bbf8e84aed8', name: "status", label: "Status", options: this.terminalStatusOptions, inputHandler: this.setParamsOnChange, defaultValue: this.terminalStatus || filterParams.status, disabled: !!this.terminalStatus, part: terminalStatusTerminalsListFilterParam }))))));
    }
};

export { TerminalsListFilters as justifi_terminals_list_filters };
