import { h } from './index-N3w5zrz2.js';
import { M as MapPaymentStatusToBadge } from './payments-status-CawBLR48.js';
import { a as convertToLocal } from './utils-Cu5hITuT.js';
import { R as tableHeadCell, S as getAlternateTableCellPart } from './parts-CKg_luIy.js';

const defaultColumnsKeys = 'created_at,amount,status,payment_type,description,payers_name,last_four_digits';
const paymentTableColumns = {
    created_at: () => (h("th", { part: tableHeadCell, scope: "col", title: "The date and time each payment was made" }, "Date")),
    amount: () => (h("th", { part: tableHeadCell, scope: "col", title: "The dollar amount of each payment" }, "Amount")),
    status: () => (h("th", { part: tableHeadCell, scope: "col", title: "The current status of each payment" }, "Status")),
    payment_type: () => (h("th", { part: tableHeadCell, scope: "col", title: "The type of each payment" }, "Type")),
    description: () => (h("th", { part: tableHeadCell, scope: "col", title: "The payment description, if you provided one" }, "Description")),
    payers_name: () => (h("th", { part: tableHeadCell, scope: "col", title: "The name associated with the payment method" }, "Account Holder")),
    last_four_digits: () => (h("th", { part: tableHeadCell, scope: "col", title: "The brand and last 4 digits of the payment method" }, "Payment Method")),
};
const paymentTableCells = {
    created_at: (payment, index) => (h("td", { part: getAlternateTableCellPart(index) },
        h("div", { class: "fw-bold" }, convertToLocal(payment.created_at, { showDisplayDate: true })),
        h("div", { class: "fw-bold" }, convertToLocal(payment.created_at, { showTime: true })))),
    amount: (payment, index) => (h("td", { part: getAlternateTableCellPart(index) }, payment.formattedPaymentAmount(payment.amount))),
    status: (payment, index) => (h("td", { part: getAlternateTableCellPart(index) }, MapPaymentStatusToBadge(payment.status))),
    payment_type: (payment, index) => (h("td", { part: getAlternateTableCellPart(index) }, payment.payment_type)),
    description: (payment, index) => (h("td", { part: getAlternateTableCellPart(index) }, payment.description)),
    payers_name: (payment, index) => (h("td", { part: getAlternateTableCellPart(index) }, payment.payers_name)),
    last_four_digits: (payment, index) => (h("td", { part: getAlternateTableCellPart(index) }, payment.last_four_digits)),
};

export { paymentTableCells as a, defaultColumnsKeys as d, paymentTableColumns as p };
