import { r as registerInstance, c as createEvent, h } from './index-N3w5zrz2.js';
import { V as image, W as buttonLink, X as card } from './parts-CKg_luIy.js';

const TerminalQuantitySelector = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.selectedQuantityChange = createEvent(this, "selectedQuantityChange");
        this.limit = Infinity;
        this.selectedQuantity = 0;
        this.removeUnit = () => {
            if (this.selectedQuantity > 0) {
                this.selectedQuantity--;
                this.selectedQuantityChange.emit({ modelName: this.modelName, quantity: this.selectedQuantity });
            }
        };
        this.addUnit = () => {
            if (this.limit > 0) {
                this.selectedQuantity++;
                this.selectedQuantityChange.emit({ modelName: this.modelName, quantity: this.selectedQuantity });
            }
        };
    }
    render() {
        return (h("div", { key: 'd852cfed7f6fc5bc67a319ffd19926d6729095b7', class: "rounded shadow-sm card p-2", part: card }, h("div", { key: 'bf4fb9a1b1860528269adaf8ee9d73e6fa20f0f2', class: "d-flex gap-3" }, h("div", { key: '1623bc5acb98c0c75a8353b3bcc0dcefb5178a44', class: "d-flex align-items-center" }, h("img", { key: '0001169ea6e54c20ff10a31a181ae82a51fb1a11', src: this.imageUrl, alt: this.modelName, height: 75, width: 75, part: image })), h("div", { key: '99d2991c109dc169c1ba978ee1cbcced811abaf7', class: "d-flex flex-column flex-grow-1 gap-3 p-4 justify-content-center" }, h("div", { key: 'f6fbd4c33657f830d9550f77b28d3f4090e21b7e', class: "row" }, h("div", { key: 'c08c5e4fc1fec82a0d7ac7f406aab1f2aec952a4', class: "col-6 d-flex gap-2" }, this.modelName, h("form-control-tooltip", { key: 'ca881d29e0439991b423a3d10a85b2f9cfb4cb24', helpText: this.description })), h("div", { key: '5cf5c3e64f3de63f2c3bc559ec42e243d1c38a34', class: "col-6 d-flex justify-content-end align-items-center" }, h("button", { key: '2622ab45644914758646cf80222253febb935980', class: "p-0 minus btn", onClick: this.removeUnit, part: buttonLink }, "-"), h("div", { key: 'e91139090d1706202d9cd9d9b51e1f8beb6a0b5f', class: "w-25 text-center" }, this.selectedQuantity), h("button", { key: '14a1a45ffbf2b8606359e20ad73b85a6945cd592', class: "p-0 plus btn", onClick: this.addUnit, part: buttonLink }, "+")))))));
    }
};

export { TerminalQuantitySelector as terminal_quantity_selector };
