import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import './config-state.js';
import './dinero.js';
import { E as EntityDocumentType } from './Refund.js';
import './Pagination.js';
import './Business.js';
import { d as defineCustomElement$3 } from './custom-popper2.js';
import { d as defineCustomElement$2 } from './form-control-file2.js';
import { d as defineCustomElement$1 } from './form-control-tooltip2.js';

const BankAccountDocumentFormInputs = /*@__PURE__*/ proxyCustomElement(class BankAccountDocumentFormInputs extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
    }
    render() {
        return (h("div", { key: '23f5fa6b191b3feea7677a85a421002642a86f50', class: "row gy-3" }, h("div", { key: 'da9d9698f15aeb4bb05baef8fb63c630fcff8a82', class: "col-12" }, h("form-control-file", { key: 'b84a8ec1753210f74989c04b5520f0e94c5a083d', name: "voided_check", label: "Voided Check", documentType: EntityDocumentType.voidedCheck, inputHandler: this.inputHandler, onFileSelected: this.storeFiles, errorText: this.errors["voided_check"], multiple: true })), h("div", { key: '06d442df900406f122970bde6b2b293f2c9080ee', class: "col-12" }, h("form-control-file", { key: 'b3dc1d48900c5932c4d59f8b31a323193f0e86b4', name: "bank_statement", label: "Bank Statement", documentType: EntityDocumentType.bankStatement, inputHandler: this.inputHandler, onFileSelected: this.storeFiles, errorText: this.errors["bank_statement"], multiple: true }))));
    }
}, [0, "bank-account-document-form-inputs", {
        "inputHandler": [16, "input-handler"],
        "errors": [8],
        "storeFiles": [16, "store-files"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["bank-account-document-form-inputs", "custom-popper", "form-control-file", "form-control-tooltip"];
    components.forEach(tagName => { switch (tagName) {
        case "bank-account-document-form-inputs":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, BankAccountDocumentFormInputs);
            }
            break;
        case "custom-popper":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "form-control-file":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "form-control-tooltip":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { BankAccountDocumentFormInputs as B, defineCustomElement as d };
