import { c as create$3 } from './form.js';
import { c as postalValidation, d as stateValidation, e as cityValidation, l as lineTwoValidation, f as lineOneValidation, i as identityNameValidation } from './schema-validations.js';

const billingFormSchema = (postalOnly) => {
    const fullBillingForm = create$3({
        name: identityNameValidation.required('Enter full name'),
        address_line1: lineOneValidation.required('Enter street address'),
        address_line2: lineTwoValidation.nullable(),
        address_city: cityValidation.required('Enter city'),
        address_state: stateValidation.required('Select state'),
        address_postal_code: postalValidation.required('Enter postal code'),
    });
    const postalForm = create$3({
        name: identityNameValidation.nullable(),
        address_line1: lineOneValidation.nullable(),
        address_line2: lineTwoValidation.nullable(),
        address_city: cityValidation.nullable(),
        address_state: stateValidation.nullable(),
        address_postal_code: postalValidation.required('Enter postal code'),
    });
    return postalOnly ? postalForm : fullBillingForm;
};

export { billingFormSchema as b };
