import { c as create$3, a as create$6 } from './form.js';
import { c as postalValidation, d as stateValidation, e as cityValidation, l as lineTwoValidation, f as lineOneValidation } from './schema-validations.js';

const addressSchema = (allowOptionalFields) => {
    const schema = create$3({
        line1: lineOneValidation.required('Enter street address'),
        line2: lineTwoValidation.nullable(),
        city: cityValidation.required('Enter city'),
        state: stateValidation.required('Select state'),
        postal_code: postalValidation.required('Enter postal code'),
        country: create$6().required('Select country')
    });
    const easySchema = create$3({
        line1: lineOneValidation.nullable(),
        line2: lineTwoValidation.nullable(),
        city: cityValidation.nullable(),
        state: stateValidation.nullable(),
        postal_code: postalValidation.nullable(),
        country: create$6().required('Select country')
    });
    return allowOptionalFields ? easySchema : schema;
};

export { addressSchema as a };
