import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { P as PHONE_MASKS, S as SSN_MASK } from './form-input-masks.js';
import { d as deconstructDate } from './helpers.js';
import { h as heading2 } from './parts.js';
import { d as defineCustomElement$7 } from './custom-popper2.js';
import { d as defineCustomElement$6 } from './form-control-date2.js';
import { d as defineCustomElement$5 } from './form-control-number-masked2.js';
import { d as defineCustomElement$4 } from './form-control-select2.js';
import { d as defineCustomElement$3 } from './form-control-text2.js';
import { d as defineCustomElement$2 } from './form-control-tooltip2.js';
import { d as defineCustomElement$1 } from './identity-address-form.js';

const BusinessRepresentative = /*@__PURE__*/ proxyCustomElement(class BusinessRepresentative extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.errors = {};
        this.representative = {};
        this.inputHandler = (name, value) => {
            this.formController.setValues(Object.assign(Object.assign({}, this.formController.values.getValue()), { representative: Object.assign(Object.assign({}, this.formController.values.getValue().representative), { [name]: value }) }));
        };
        this.onAddressFormUpdate = (values) => {
            this.formController.setValues(Object.assign(Object.assign({}, this.formController.values.getValue()), { representative: Object.assign(Object.assign({}, this.formController.values.getValue().representative), { address: Object.assign(Object.assign({}, this.formController.values.getValue().representative.address), values) }) }));
        };
        this.onDateOfBirthUpdate = (event) => {
            const dob_values = deconstructDate(event.detail);
            this.formController.setValues(Object.assign(Object.assign({}, this.formController.values.getValue()), { representative: Object.assign(Object.assign({}, this.formController.values.getValue().representative), { dob_day: dob_values.dob_day, dob_month: dob_values.dob_month, dob_year: dob_values.dob_year }) }));
        };
    }
    get identificationNumberLabel() {
        return this.representative.ssn_last4 ? 'Update SSN (optional)' : 'SSN';
    }
    componentDidLoad() {
        this.formController.errors.subscribe(errors => (this.errors = Object.assign({}, errors.representative)));
        this.formController.values.subscribe(values => (this.representative = Object.assign({}, values.representative)));
    }
    render() {
        const representativeDefaultValue = this.formController.getInitialValues().representative;
        return (h(Host, { key: '88bd35928331776d5cbb7d085fd55a76fde1a084' }, h("fieldset", { key: '202c40f332352c2f4d3c8a136888c39c67379e5f' }, h("legend", { key: 'a0b5043b348b1d8632a6bf0fe2d4309a8132d1f7', part: heading2 }, "Representative"), h("div", { key: 'ba50c004e2b37f384dd8af63b1e0e397abadb9de', class: "row gy-3" }, h("div", { key: 'b85bf5fb0da9e8feae19dbebb0a911362e914601', class: "col-12 col-md-8" }, h("form-control-text", { key: '95f849c7c0ba0c67bdc0a55727e00755e03897ef', name: "name", label: "Full Name", defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.name, errorText: this.errors.name, inputHandler: this.inputHandler })), h("div", { key: '074067a3ce960b678ea38d53b84adda24e60754c', class: "col-12 col-md-4" }, h("form-control-text", { key: '7ef397af32b7c0f79eeae1499bf3d3d147961c96', name: "title", label: "Title", defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.title, errorText: this.errors.title, inputHandler: this.inputHandler })), h("div", { key: 'a26bfd8a0824aaa12c6ffa48ac58c2bccc7236ef', class: "col-12 col-md-6" }, h("form-control-text", { key: '39174c4b812462d1aa28824bca550e3f6e1d98b4', name: "email", label: "Email Address", defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.email, errorText: this.errors.email, inputHandler: this.inputHandler })), h("div", { key: 'ed0a2c52e4df0c43b2536dfd1ff3692a4e5716d9', class: "col-12 col-md-6" }, h("form-control-number-masked", { key: '07bdcc1dd2e1473b64218eb28c8cdcf1cdce2a91', name: "phone", label: "Phone Number", defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.phone, errorText: this.errors.phone, inputHandler: this.inputHandler, mask: PHONE_MASKS.US })), h("div", { key: '96092fd371ec82a8f8ebbf8bc4e3064768d4ad97', class: "col-12 col-md-4" }, h("form-control-date", { key: 'c24980f126c056aff139e897fdef9795905ea89b', name: "dob_full", label: "Birth Date", defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.dob_full, errorText: this.errors.dob_full, inputHandler: this.inputHandler, onFormControlInput: this.onDateOfBirthUpdate })), h("div", { key: '9d1695fa6e68bb4ae9a8184dcb5e15d588474ab8', class: "col-12 col-md-8" }, h("form-control-number-masked", { key: '8d8a56c08fb06f1a54baf3ee3d6e31a684205290', name: "identification_number", label: this.identificationNumberLabel, defaultValue: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.identification_number, errorText: this.errors.identification_number, inputHandler: this.inputHandler, mask: SSN_MASK })), h("div", { key: '22fa5e16517e14ab031aa5e7e95ea77bd7b28986', class: "col-12" }, h("justifi-identity-address-form", { key: '4a990de739a0ae6fbf1f6a621ff7c0078517e970', errors: this.errors.address, defaultValues: representativeDefaultValue === null || representativeDefaultValue === void 0 ? void 0 : representativeDefaultValue.address, handleFormUpdate: this.onAddressFormUpdate }))))));
    }
}, [0, "justifi-business-representative", {
        "formController": [16, "form-controller"],
        "errors": [32],
        "representative": [32]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["justifi-business-representative", "custom-popper", "form-control-date", "form-control-number-masked", "form-control-select", "form-control-text", "form-control-tooltip", "justifi-identity-address-form"];
    components.forEach(tagName => { switch (tagName) {
        case "justifi-business-representative":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, BusinessRepresentative);
            }
            break;
        case "custom-popper":
            if (!customElements.get(tagName)) {
                defineCustomElement$7();
            }
            break;
        case "form-control-date":
            if (!customElements.get(tagName)) {
                defineCustomElement$6();
            }
            break;
        case "form-control-number-masked":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "form-control-select":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "form-control-text":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "form-control-tooltip":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "justifi-identity-address-form":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { BusinessRepresentative as B, defineCustomElement as d };
