import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { D as DetailSectionTitle, a as DetailItem } from './utils.js';
import { s as snakeCaseToHumanReadable } from './utils2.js';

const CoreInfoDetails = /*@__PURE__*/ proxyCustomElement(class CoreInfoDetails extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
    }
    render() {
        if (!this.business) {
            return null;
        }
        return (h("div", null, h(DetailSectionTitle, { sectionTitle: "Business Core Info Details" }), h("div", { class: "d-table gap-2 w-100 mt-3" }, h("div", { class: "row gy-3" }, h("div", { class: "col-12 col-md-6" }, h(DetailItem, { title: "Legal Name", value: this.business.legal_name }), h(DetailItem, { title: "Doing Business As (DBA)", value: this.business.doing_business_as }), h(DetailItem, { title: "Business Classification", value: snakeCaseToHumanReadable(this.business.classification) }), h(DetailItem, { title: "Industry", value: this.business.industry })), h("div", { class: "col-12 col-md-6" }, h(DetailItem, { title: "Tax ID", value: this.business.tax_id }), h(DetailItem, { title: "Website URL", value: this.business.website_url }), h(DetailItem, { title: "Email Address", value: this.business.email }), h(DetailItem, { title: "Phone Number", value: this.business.phone }))))));
    }
}, [0, "core-info-details", {
        "business": [16]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["core-info-details"];
    components.forEach(tagName => { switch (tagName) {
        case "core-info-details":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, CoreInfoDetails);
            }
            break;
    } });
}
defineCustomElement();

export { CoreInfoDetails as C, defineCustomElement as d };
