import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { N as inputCheckboxInvalid, O as inputCheckboxCheckedFocused, P as inputCheckboxFocused, Q as inputCheckboxChecked, R as inputCheckbox, l as label } from './parts.js';
import { F as FormControlHelpText } from './form-control-help-text3.js';
import { F as FormControlErrorText } from './form-control-error-text.js';
import './details.js';
import './event-types.js';
import './justifi-radio-list-item2.js';

const CheckboxInput = /*@__PURE__*/ proxyCustomElement(class CheckboxInput extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.formControlInput = createEvent(this, "formControlInput", 7);
        this.formControlBlur = createEvent(this, "formControlBlur", 7);
        this.isFocused = false;
        this.handleFormControlInput = (event) => {
            event.preventDefault();
            const target = event.target;
            const name = target.getAttribute('name');
            this.inputHandler(name, target.checked);
            this.formControlInput.emit({ name, value: target.value });
        };
        this.updateInput = (newValue) => {
            this.checkboxElement.checked = newValue;
        };
    }
    get part() {
        if (this.errorText) {
            return inputCheckboxInvalid;
        }
        if (this.isFocused && this.checked) {
            return inputCheckboxCheckedFocused;
        }
        if (this.isFocused) {
            return inputCheckboxFocused;
        }
        if (this.checked) {
            return inputCheckboxChecked;
        }
        return inputCheckbox;
    }
    render() {
        return (h(Host, { key: 'f574898ffe8a3d666d4b95721cf4f3f3866f8632' }, h("div", { key: '185ac07832d140b467162e2bdacb90ea0640d460', class: 'form-group d-flex flex-column' }, h("div", { key: 'c610e4c989b6c8529253ef73e39d4e58f0efd1e3', class: "form-check" }, h("input", { key: '7abfbfed27e3ad2c0a46a5f30b0681d54673c1fb', ref: el => (this.checkboxElement = el), type: "checkbox", id: this.name, name: this.name, onFocus: () => this.isFocused = true, onBlur: () => {
                this.isFocused = false;
                this.formControlBlur.emit();
            }, onInput: this.handleFormControlInput, part: this.part, class: this.errorText ? 'form-check-input is-invalid' : 'form-check-input', disabled: this.disabled, checked: this.checked }), h("label", { key: '9c505e1d0926690eb32d2d9621d6c144cfe27f6a', class: "form-check-label", htmlFor: this.name, part: label }, this.label)), h(FormControlHelpText, { key: 'fc7933d29f06ef533fe45025184d5c8cdd24cdd1', helpText: this.helpText, name: this.name }), h(FormControlErrorText, { key: '29879fd2d7c04a26eb999bb2f9991bc38515994b', errorText: this.errorText, name: this.name }))));
    }
}, [0, "form-control-checkbox", {
        "label": [1],
        "name": [8],
        "helpText": [1, "help-text"],
        "errorText": [1, "error-text"],
        "checked": [4],
        "inputHandler": [16, "input-handler"],
        "disabled": [4],
        "isFocused": [32]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["form-control-checkbox"];
    components.forEach(tagName => { switch (tagName) {
        case "form-control-checkbox":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, CheckboxInput);
            }
            break;
    } });
}
defineCustomElement();

export { CheckboxInput as C, defineCustomElement as d };
