import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { F as FormControlErrorText } from './form-control-error-text.js';
import { d as defineCustomElement$2 } from './custom-popper2.js';
import { d as defineCustomElement$1 } from './form-control-tooltip2.js';

const FileInput = /*@__PURE__*/ proxyCustomElement(class FileInput extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.formControlInput = createEvent(this, "formControlInput", 7);
        this.formControlBlur = createEvent(this, "formControlBlur", 7);
    }
    render() {
        return (h(Host, { key: '09a00c508e5f8a6760a10596caa60e39650ae3dc', exportparts: "label,input,input-invalid" }, h("div", { key: 'af053f126524dc7dc5f02d5f6ef871012097e1a4', class: "form-group d-flex flex-column" }, h("div", { key: 'e7cbe9ae561c54c14ef4bf1adb4405f93e52a0da', class: "d-flex align-items-start gap-2" }, h("label", { key: '84173f53d2d70e8f3728cd5ed69dff4fa86ee659', part: "label", class: "form-label", htmlFor: this.name }, this.label), h("form-control-tooltip", { key: 'a5f6fa27696c3cb673c5b10a7cf7049c2be1d113', helpText: this.helpText })), h("input", { key: '8f39d6dfaa711830059c04fcbb0b99600d269000', type: "file", name: this.name, part: `input ${this.errorText ? "input-invalid " : ""}${this.disabled ? "input-disabled" : ""}`, class: this.errorText ? "form-control is-invalid" : "form-control", multiple: this.multiple, disabled: this.disabled, onBlur: () => this.formControlBlur.emit(), onChange: () => this.errorText = "" }), h(FormControlErrorText, { key: 'f9c61d2900f3a0776895c51d9f1aa42e6aabac4b', errorText: this.errorText, name: this.name }))));
    }
    get el() { return this; }
}, [0, "form-control-file-v2", {
        "label": [1],
        "name": [8],
        "helpText": [1, "help-text"],
        "errorText": [1, "error-text"],
        "multiple": [4],
        "inputHandler": [16, "input-handler"],
        "disabled": [4],
        "files": [32]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["form-control-file-v2", "custom-popper", "form-control-tooltip"];
    components.forEach(tagName => { switch (tagName) {
        case "form-control-file-v2":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, FileInput);
            }
            break;
        case "custom-popper":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "form-control-tooltip":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { FileInput as F, defineCustomElement as d };
