import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { S as StyledHost } from './styled-host.js';
import { B as Button } from './button.js';

const JustifiButton = /*@__PURE__*/ proxyCustomElement(class JustifiButton extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.variant = 'primary';
        this.type = 'button';
    }
    render() {
        return (h(StyledHost, { key: '9058c69dafff70a5c678ab1c3bcf23912334fdb0' }, h(Button, { key: 'e338ce5761834c0a971970bb1d2085ec9f88eb65', variant: this.variant, isLoading: this.isLoading, clickHandler: this.clickHandler, class: this.class, type: this.type, disabled: this.disabled, style: this.customStyle }, this.text)));
    }
}, [1, "justifi-button", {
        "text": [1],
        "variant": [1],
        "isLoading": [4, "is-loading"],
        "clickHandler": [16, "click-handler"],
        "disabled": [4],
        "type": [1],
        "class": [1],
        "customStyle": [1, "custom-style"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["justifi-button"];
    components.forEach(tagName => { switch (tagName) {
        case "justifi-button":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, JustifiButton);
            }
            break;
    } });
}
defineCustomElement();

export { JustifiButton as J, defineCustomElement as d };
