import { proxyCustomElement, HTMLElement } from '@stencil/core/internal/client';
import { s as setConfigState } from './config-state.js';

const ConfigProvider = /*@__PURE__*/ proxyCustomElement(class ConfigProvider extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.apiOrigin = "https://wc-proxy.justifi.ai";
        this.iframeOrigin = "https://components.justifi.ai";
        this.accountId = '';
    }
    componentWillLoad() {
        setConfigState({
            apiOrigin: this.apiOrigin,
            iframeOrigin: this.iframeOrigin,
            accountId: this.accountId
        });
    }
    render() {
        return null;
    }
}, [0, "justifi-config-provider", {
        "apiOrigin": [1, "api-origin"],
        "iframeOrigin": [1, "iframe-origin"],
        "accountId": [1, "account-id"]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["justifi-config-provider"];
    components.forEach(tagName => { switch (tagName) {
        case "justifi-config-provider":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, ConfigProvider);
            }
            break;
    } });
}
defineCustomElement$1();

const JustifiConfigProvider = ConfigProvider;
const defineCustomElement = defineCustomElement$1;

export { JustifiConfigProvider, defineCustomElement };
