import { h, proxyCustomElement, HTMLElement } from '@stencil/core/internal/client';
import { S as StyledHost } from './styled-host.js';
import { H as Header1 } from './header-1.js';
import { H as Header2 } from './header-2.js';
import { W as heading3 } from './parts.js';

const Header3 = (props) => {
    return h("h3", { class: `header-3 ${props === null || props === void 0 ? void 0 : props.class}`, part: heading3 }, props.text);
};

const Header = /*@__PURE__*/ proxyCustomElement(class Header extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.levels = {
            h1: Header1,
            h2: Header2,
            h3: Header3,
        };
        this.level = 'h1';
    }
    render() {
        const HeaderComponent = this.levels[this.level];
        return (h(StyledHost, { key: '91910c2913cd5085875d33d79e33136bcf78cb14' }, h(HeaderComponent, { key: 'd915085a734fa1abb5dc03d722c954139794ace3', text: this.text, class: this.class })));
    }
}, [1, "justifi-header", {
        "text": [1],
        "level": [1],
        "class": [1]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["justifi-header"];
    components.forEach(tagName => { switch (tagName) {
        case "justifi-header":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, Header);
            }
            break;
    } });
}
defineCustomElement();

export { Header as H, defineCustomElement as d };
