import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { f as filterParams, p as propsParams, c as clearParams } from './payouts-list-params-state.js';
import { af as payoutsListFilterMenu, ag as createdAfterPayoutsListFilterParam, ah as createdBeforePayoutsListFilterParam } from './parts.js';
import { S as StyledHost } from './styled-host.js';
import './details.js';
import './event-types.js';
import './justifi-radio-list-item2.js';
import { h as convertToUTC, e as convertToLocal } from './utils2.js';
import { d as defineCustomElement$5 } from './custom-popper2.js';
import { d as defineCustomElement$4 } from './form-control-date2.js';
import { d as defineCustomElement$3 } from './form-control-tooltip2.js';
import { d as defineCustomElement$2 } from './table-filters-menu2.js';

const PayoutsListFilters = /*@__PURE__*/ proxyCustomElement(class PayoutsListFilters extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.setParamsOnChange = (name, value) => {
            filterParams[name] = value;
        };
        this.handleDateInput = (name, value) => {
            const utcDate = convertToUTC(value, { setEndOfDay: true });
            this.setParamsOnChange(name, utcDate);
        };
    }
    componentWillLoad() {
        const propsToSet = {
            created_after: this.createdAfter,
            created_before: this.createdBefore
        };
        Object.entries(propsToSet).forEach(([key, value]) => {
            if (value) {
                propsParams[key] = value;
            }
        });
    }
    render() {
        const filterMenuParams = Object.assign({}, filterParams);
        return (h(StyledHost, { key: '3d52e500043d280ba63e03095096c77fe253106e' }, h("table-filters-menu", { key: '4dd85f33336a26692bbcdac30cdde6f4f091213a', params: filterMenuParams, clearParams: clearParams, part: payoutsListFilterMenu }, h("div", { key: 'f093372ebbf5841a80cf8e05cd26c8f8c992db59', class: "grid-cols-2 gap-3 p-1" }, h("div", { key: 'cc4ed47e4b8373bd787621dda6e9327581d359cb', class: "p-2" }, h("form-control-date", { key: '3f176b4fb1ec7efadf2ce38479695f9d9df2b5f1', name: "created_after", label: "Created After", inputHandler: this.handleDateInput, defaultValue: convertToLocal(this.createdAfter, { showInputDate: true }) ||
                convertToLocal(filterParams.created_after, { showInputDate: true }), disabled: !!this.createdAfter, part: createdAfterPayoutsListFilterParam })), h("div", { key: '5eabb3a72a3c223512ccf584cf5b7ee901594b30', class: "p-2" }, h("form-control-date", { key: '8ba7230275b3b89f75f1c9d5fa654c493d626940', name: "created_before", label: "Created Before", inputHandler: this.handleDateInput, defaultValue: convertToLocal(this.createdBefore, { showInputDate: true }) ||
                convertToLocal(filterParams.created_before, { showInputDate: true }), disabled: !!this.createdBefore, part: createdBeforePayoutsListFilterParam }))))));
    }
}, [1, "justifi-payouts-list-filters", {
        "createdAfter": [1, "created-after"],
        "createdBefore": [1, "created-before"]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["justifi-payouts-list-filters", "custom-popper", "form-control-date", "form-control-tooltip", "table-filters-menu"];
    components.forEach(tagName => { switch (tagName) {
        case "justifi-payouts-list-filters":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, PayoutsListFilters);
            }
            break;
        case "custom-popper":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "form-control-date":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "form-control-tooltip":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "table-filters-menu":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
    } });
}
defineCustomElement$1();

const JustifiPayoutsListFilters = PayoutsListFilters;
const defineCustomElement = defineCustomElement$1;

export { JustifiPayoutsListFilters, defineCustomElement };
