import { proxyCustomElement, HTMLElement, createEvent, h } from '@stencil/core/internal/client';
import { S as StyledHost } from './styled-host.js';
import { r as radioListItem } from './parts.js';
import { d as defineCustomElement$2 } from './form-control-help-text2.js';
import { d as defineCustomElement$1 } from './form-control-radio2.js';

const JustifiRadioListItem = /*@__PURE__*/ proxyCustomElement(class JustifiRadioListItem extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.radioClick = createEvent(this, "radio-click", 7);
        this.checked = false;
        this.hidden = false;
        this.handleClick = () => {
            this.radioClick.emit(this.value);
        };
    }
    render() {
        return (h(StyledHost, { key: '492a73e2bab02c04aa8733ce0b9ab801e5ff8875' }, h("div", { key: 'c095a98ba11739b85ece4c7bb0e0c30e7e08ec7b', class: `radio-list-item p-3 ${this.class || ''}`, part: radioListItem, onClick: this.handleClick, hidden: this.hidden }, h("form-control-radio", { key: 'e76be985c8c7a69799869e58b9c9b749e7bd363f', name: this.name, value: this.value, checked: this.checked, label: this.label }))));
    }
}, [1, "justifi-radio-list-item", {
        "name": [1],
        "value": [1],
        "label": [1],
        "checked": [4],
        "hidden": [4],
        "class": [1]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["justifi-radio-list-item", "form-control-help-text", "form-control-radio"];
    components.forEach(tagName => { switch (tagName) {
        case "justifi-radio-list-item":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, JustifiRadioListItem);
            }
            break;
        case "form-control-help-text":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "form-control-radio":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { JustifiRadioListItem as J, defineCustomElement as d };
