import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { S as StyledHost } from './styled-host.js';
import { S as Skeleton } from './skeleton.js';

const JustifiSkeleton$1 = /*@__PURE__*/ proxyCustomElement(class JustifiSkeleton extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
    }
    render() {
        return (h(StyledHost, { key: '9928d91672d7ce5854f08d190dc55d8dd1d763e9' }, h(Skeleton, { key: 'eb9bf35e904235d89cb06a2ee4de3edc8e05b12b', component: this.component, height: this.height, width: this.width, className: this.class, styles: this.customStyle })));
    }
}, [1, "justifi-skeleton", {
        "component": [1],
        "height": [8],
        "width": [8],
        "class": [1],
        "customStyle": [16, "custom-style"]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["justifi-skeleton"];
    components.forEach(tagName => { switch (tagName) {
        case "justifi-skeleton":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, JustifiSkeleton$1);
            }
            break;
    } });
}
defineCustomElement$1();

const JustifiSkeleton = JustifiSkeleton$1;
const defineCustomElement = defineCustomElement$1;

export { JustifiSkeleton, defineCustomElement };
