import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { r as radioListItem } from './parts.js';
import { S as StyledHost } from './styled-host.js';
import './details.js';
import './event-types.js';
import './justifi-radio-list-item2.js';
import { d as defineCustomElement$2 } from './form-control-help-text2.js';
import { d as defineCustomElement$1 } from './form-control-radio2.js';

const PaymentMethodOption = /*@__PURE__*/ proxyCustomElement(class PaymentMethodOption extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
    }
    render() {
        return (h(StyledHost, { key: 'a8c7ba94cf471c0b12f65c6fa9be1d1b6fc28910', class: "payment-method" }, h("div", { key: 'fae8daae8c7b3d00a5ba7a713522766bfe41dfae', class: "radio-list-item p-3", part: radioListItem, onClick: this.clickHandler, hidden: this.radioButtonHidden }, h("form-control-radio", { key: '51b8f509374e771c9e0cd7ff463c8a3d3b9d9a35', name: "paymentMethodType", value: this.paymentMethodOptionId, checked: this.isSelected, label: this.label }))));
    }
}, [1, "payment-method-option", {
        "paymentMethodOptionId": [1, "payment-method-option-id"],
        "isSelected": [4, "is-selected"],
        "clickHandler": [16, "click-handler"],
        "radioButtonHidden": [4, "radio-button-hidden"],
        "label": [1]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["payment-method-option", "form-control-help-text", "form-control-radio"];
    components.forEach(tagName => { switch (tagName) {
        case "payment-method-option":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, PaymentMethodOption);
            }
            break;
        case "form-control-help-text":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "form-control-radio":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { PaymentMethodOption as P, defineCustomElement as d };
