import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import './Business.js';
import { a as BusinessFormClickActions } from './event-types2.js';
import { B as Button } from './button.js';
import './details.js';
import './event-types.js';
import './justifi-radio-list-item2.js';

const PaymentProvisioningFormButtons = /*@__PURE__*/ proxyCustomElement(class PaymentProvisioningFormButtons extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
    }
    get showPreviousStepButton() {
        return this.currentStep > 0;
    }
    get showNextStepButton() {
        return this.currentStep < this.totalSteps;
    }
    get showSubmitButton() {
        return this.currentStep === this.totalSteps;
    }
    render() {
        return (h("div", { key: '5869ed8c350e3a1ae5fe62dcd04493f432eecff7', class: 'd-flex gap-2' }, h(Button, { key: 'b1e8c2fff97e9a053d715860a43ddd78c99b255a', variant: "secondary", type: "button", onClick: () => this.previousStepButtonOnClick(), disabled: this.formDisabled, hidden: !this.showPreviousStepButton }, "Previous"), h(Button, { key: '8696fe4f0bde5434e51f05f67b39a8e5b2f550bf', variant: "primary", type: "button", onClick: (e) => this.nextStepButtonOnClick(e, BusinessFormClickActions.nextStep), disabled: this.formDisabled, isLoading: this.formLoading, hidden: !this.showNextStepButton }, "Next"), h(Button, { key: 'b1750a849d60244bdb3cf82690c6cbd15b6e1110', variant: "primary", type: "submit", onClick: (e) => this.nextStepButtonOnClick(e, BusinessFormClickActions.submit), disabled: this.formDisabled, isLoading: this.formLoading, hidden: !this.showSubmitButton }, "Submit")));
    }
}, [0, "justifi-payment-provisioning-form-buttons", {
        "currentStep": [2, "current-step"],
        "totalSteps": [2, "total-steps"],
        "formLoading": [4, "form-loading"],
        "formDisabled": [4, "form-disabled"],
        "previousStepButtonOnClick": [16, "previous-step-button-on-click"],
        "nextStepButtonOnClick": [16, "next-step-button-on-click"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["justifi-payment-provisioning-form-buttons"];
    components.forEach(tagName => { switch (tagName) {
        case "justifi-payment-provisioning-form-buttons":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, PaymentProvisioningFormButtons);
            }
            break;
    } });
}
defineCustomElement();

export { PaymentProvisioningFormButtons as P, defineCustomElement as d };
