import { A as Api } from './Api.js';
import './Refund.js';
import './Pagination.js';
import './Business.js';

const api = Api();
class PaymentService {
    async fetchPayments(accountId, authToken, params) {
        const endpoint = `account/${accountId}/payments`;
        return api.get({ endpoint, params, authToken });
    }
    async fetchPayment(paymentId, authToken) {
        const endpoint = `payments/${paymentId}`;
        return api.get({ endpoint, authToken });
    }
    async fetchPaymentTransactions(paymentId, authToken, params) {
        const endpoint = `payments/${paymentId}/payment_balance_transactions`;
        return api.get({ endpoint, params, authToken });
    }
}

export { PaymentService as P };
