import { A as Api } from './Api.js';
import './Refund.js';
import './Pagination.js';
import './Business.js';

const api = Api();
class PayoutService {
    async fetchPayouts(accountId, authToken, params) {
        const endpoint = `account/${accountId}/payouts`;
        return api.get({ authToken, endpoint, params });
    }
    async fetchPayout(payoutId, authToken) {
        const endpoint = `payouts/${payoutId}`;
        return api.get({ authToken, endpoint });
    }
    async fetchCSV(payoutId, authToken) {
        const endpoint = `reports/payouts/${payoutId}`;
        return api.get({ authToken, endpoint });
    }
    async fetchPayoutTransactions(accountId, authToken, params) {
        const endpoint = `balance_transactions`;
        const headers = { 'sub-account': accountId };
        return api.get({ authToken, endpoint, params, headers });
    }
}

export { PayoutService as P };
