import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { c as create$3, a as create$6, F as FormController } from './form.js';
import { D as DisputeResponseFormStep, f as fileInputHandler } from './file-input-handler.js';
import { _ as heading5 } from './parts.js';
import { d as defineCustomElement$5 } from './custom-popper2.js';
import { d as defineCustomElement$4 } from './form-control-date2.js';
import { d as defineCustomElement$3 } from './form-control-file-v22.js';
import { d as defineCustomElement$2 } from './form-control-text2.js';
import { d as defineCustomElement$1 } from './form-control-tooltip2.js';

const ProductOrServiceSchema = create$3({
    product_description: create$6().nullable(),
    service_date: create$6().nullable(),
});

const ProductOrService = /*@__PURE__*/ proxyCustomElement(class ProductOrService extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.documentErrors = {};
        this.errors = {};
        this.documents = { service_documentation: [] };
        this.inputHandler = (name, value) => {
            this.form.setValues(Object.assign(Object.assign({}, this.form.values.getValue()), { [name]: value }));
        };
    }
    async validateAndSubmit(onSuccess) {
        const documentList = Object.values(this.documents).flat();
        this.form.validateAndSubmit((formData) => onSuccess(formData, documentList, DisputeResponseFormStep.productOrService));
    }
    ;
    componentWillLoad() {
        this.form = new FormController(ProductOrServiceSchema);
    }
    componentDidLoad() {
        this.form.errors.subscribe(errors => {
            this.errors = Object.assign({}, errors);
        });
    }
    render() {
        var _a, _b, _c;
        return (h("div", { key: 'f1f7d30bd481b5e3b49d9aaffd6e9bc1266b3c17' }, h("div", { key: 'c41caefa4937db6b0669cd28e84b6918c719d8f0', class: "row gy-3" }, h("div", { key: 'be3b622f366017c7a8bdddfc363a0a46216de2ea', class: "col-12" }, h("h2", { key: '39374858f492c6e20e637dab0c73356fb6c6499d', class: "h5", part: heading5 }, "Product & Service Details")), h("div", { key: 'c910f0b2a6c1574f2b09348e4d3b889a675bbfeb', class: "col-12" }, h("form-control-text", { key: '636616c14d388dd25c33d81220231f2e7b36ec2f', label: "Product Description", name: "product_description", defaultValue: (_a = this.disputeResponse) === null || _a === void 0 ? void 0 : _a.product_description, inputHandler: this.inputHandler, errorText: this.errors.product_description })), h("div", { key: '44da2982c48cd5da994aec38f5196205b25c4868', class: "col-12" }, h("form-control-date", { key: '6b5ff071f9e941caaadff9fbaf18501524f71fce', label: "Service Date", name: "service_date", defaultValue: (_b = this.disputeResponse) === null || _b === void 0 ? void 0 : _b.service_date, inputHandler: this.inputHandler, errorText: this.errors.service_date })), h("div", { key: '8ae3d7fbc3826f932ee14d98a48d90cf913606af', class: "col-12" }, h("form-control-file-v2", { key: '5990ebe0df1e74fd7b1d6a6cf1dd8d08cd680a68', label: "Service Documentation", name: "service_documentation", onChange: (e) => fileInputHandler(e, this.documents), errorText: (_c = this.documentErrors) === null || _c === void 0 ? void 0 : _c.service_documentation })))));
    }
}, [0, "justifi-product-or-service", {
        "disputeResponse": [8, "dispute-response"],
        "documentErrors": [8, "document-errors"],
        "form": [32],
        "errors": [32],
        "documents": [32],
        "validateAndSubmit": [64]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["justifi-product-or-service", "custom-popper", "form-control-date", "form-control-file-v2", "form-control-text", "form-control-tooltip"];
    components.forEach(tagName => { switch (tagName) {
        case "justifi-product-or-service":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, ProductOrService);
            }
            break;
        case "custom-popper":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "form-control-date":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "form-control-file-v2":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "form-control-text":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "form-control-tooltip":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { ProductOrService as P, defineCustomElement as d };
