import { proxyCustomElement, HTMLElement, createEvent, h } from '@stencil/core/internal/client';
import { S as StyledHost } from './styled-host.js';
import './details.js';
import './event-types.js';
import './justifi-radio-list-item2.js';
import { d as defineCustomElement$1 } from './form-control-checkbox2.js';

const SaveNewPaymentMethod = /*@__PURE__*/ proxyCustomElement(class SaveNewPaymentMethod extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.checkboxChanged = createEvent(this, "checkboxChanged", 7);
        this.isChecked = false;
    }
    handleCheckboxChange(_name, value) {
        this.isChecked = value;
        this.checkboxChanged.emit(this.isChecked);
    }
    render() {
        return (h(StyledHost, { key: 'd1d049867d908af91cc7bcd1b841345082344263' }, h("div", { key: '4159e5a8608f123f18542874e6589fdad133ffac', class: "mt-4 form-check" }, h("form-control-checkbox", { key: '2c202be08024fe72c0b1ee9894b392a8084f23e1', label: "Save new payment method", name: "saveNewPaymentMethod", checked: this.isChecked, inputHandler: this.handleCheckboxChange.bind(this) }))));
    }
}, [1, "justifi-save-new-payment-method", {
        "isChecked": [32]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["justifi-save-new-payment-method", "form-control-checkbox"];
    components.forEach(tagName => { switch (tagName) {
        case "justifi-save-new-payment-method":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, SaveNewPaymentMethod);
            }
            break;
        case "form-control-checkbox":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { SaveNewPaymentMethod as S, defineCustomElement as d };
