import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { t as text } from './parts.js';
import { c as formatCurrency } from './utils2.js';
import { c as checkoutStore } from './checkout.store.js';
import { S as StyledHost } from './styled-host.js';
import './details.js';
import './event-types.js';
import './justifi-radio-list-item2.js';

const Summary = /*@__PURE__*/ proxyCustomElement(class Summary extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
    }
    render() {
        return (h(StyledHost, { key: '1bafeffc42f1e98f50551ca971f52e8294782168' }, h("section", { key: 'bf1a89bf030ae5a953abe092d0a5c543ed7f543f' }, h("div", { key: 'ce0b98733c2e158c1caef43b751513a0565ecfc6' }, h("div", { key: '8d0525c31ac3a93a5ce1aa2afde5c9bd7da26dc0', part: text }, checkoutStore === null || checkoutStore === void 0 ? void 0 : checkoutStore.paymentDescription), h("div", { key: '7885858ddcd2819522fa08fbbc2d3dce2f0132f6' }, h("span", { key: '57ce1d9a9dd1269c4d958c78210565e9cb68d22a', part: text }, "Total"), "\u00A0", h("span", { key: '0b6673bd2c841cb0e50db93c148bfe15f96b577a', part: text }, formatCurrency(+(checkoutStore === null || checkoutStore === void 0 ? void 0 : checkoutStore.totalAmount))))))));
    }
}, [1, "justifi-checkout-summary"]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["justifi-checkout-summary"];
    components.forEach(tagName => { switch (tagName) {
        case "justifi-checkout-summary":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, Summary);
            }
            break;
    } });
}
defineCustomElement();

export { Summary as S, defineCustomElement as d };
