import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { B as Button } from './button.js';
import { a6 as dropdownMenuButton, a7 as dropdownMenu } from './parts.js';
import { d as defineCustomElement$1 } from './custom-popper2.js';

const hasFilters = (params) => {
    const paginationKeys = ['after_cursor', 'before_cursor'];
    const paramKeys = Object.keys(params);
    const filterKeys = paramKeys.filter((paramKey) => !paginationKeys.includes(paramKey));
    return !!filterKeys.length;
};

const TableFiltersMenu = /*@__PURE__*/ proxyCustomElement(class TableFiltersMenu extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.showClearButton = false;
    }
    watchParamsHandler(newValue) {
        this.showClearButton = hasFilters(newValue);
    }
    show() {
        this.menu.classList.add('show');
    }
    hide() {
        this.menu.classList.remove('show');
    }
    componentWillLoad() {
        this.showClearButton = hasFilters(this.params);
    }
    render() {
        return (h("div", { key: 'b270a6f9e52e45e958bb02e31569d4f56135ee25', class: "d-flex gap-2" }, h("div", { key: '76d9eef0672c27ec28a95bc062f946739a2c5dc7', class: "dropdown pb-3" }, h("button", { key: '3de6afb2c92bde835ae894e7548b3e07b86fb0bf', type: "button dropdown-toggle", ref: (el) => (this.anchorButton = el), class: "btn btn-primary dropdown-toggle", part: dropdownMenuButton, "data-test-id": "open-filters-button", "data-bs-toggle": "dropdown" }, "Filters"), h("custom-popper", { key: 'de744460fb721b5949ca0cfcf6a751e4b6a008d0', offset: [20, 10], strategy: "fixed", anchorRef: this.anchorButton, trigger: "click" }, h("form", { key: 'c8b6d3e8e28b90fb3dedd80e71c7a8a0f30b6a8f', class: "dropdown-menu", part: dropdownMenu, "data-test-id": "filter-menu", ref: (el) => (this.menu = el), onSubmit: (e) => e.preventDefault() }, h("slot", { key: '44e50fab6d4f6c7a76f90659cced1c61e94ec43d' })))), h("div", { key: 'b5ec37cc1f28005c2b87b14bd10b74e619012ce5' }, h(Button, { key: '5bae9de44fcdb6e015ac3311945bdcee1887e827', variant: "secondary", onClick: () => this.clearParams(), hidden: !this.showClearButton, "data-test-id": "clear-filters-button" }, "Clear Filters"))));
    }
    static get watchers() { return {
        "params": ["watchParamsHandler"]
    }; }
}, [4, "table-filters-menu", {
        "params": [8],
        "clearParams": [16, "clear-params"],
        "anchorButton": [32],
        "menu": [32],
        "showClearButton": [32]
    }, [[0, "showEvent", "show"], [0, "hideEvent", "hide"]], {
        "params": ["watchParamsHandler"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["table-filters-menu", "custom-popper"];
    components.forEach(tagName => { switch (tagName) {
        case "table-filters-menu":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, TableFiltersMenu);
            }
            break;
        case "custom-popper":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { TableFiltersMenu as T, defineCustomElement as d };
