import { BusinessFormClickActions, BusinessFormStep } from "../components/business-forms/utils/event-types";
import { DisputeManagementClickActions, DisputeResponseFormStep } from "../components/dispute-management/event-types";
import { TableClickActions } from "../ui-components/table/event-types";
import { ComponentErrorCodes, ComponentErrorSeverity } from "./ComponentError";
export interface ComponentClickEvent {
    name: BusinessFormClickActions | DisputeManagementClickActions | TableClickActions;
    data?: any;
}
export interface ComponentSubmitEvent {
    response: any;
    metadata?: any;
}
export interface ComponentFormStepCompleteEvent {
    formStep: BusinessFormStep | DisputeResponseFormStep;
    response?: any;
    metadata?: any;
}
export interface ComponentErrorEvent {
    errorCode: ComponentErrorCodes;
    message: string;
    severity?: ComponentErrorSeverity;
    data?: any;
}
