import { Address, IAddress } from './Business';
export interface Identity {
    address?: IAddress;
    created_at?: string;
    dob_day?: string;
    dob_month?: string;
    dob_year?: string;
    documents?: Document[];
    email?: string;
    id?: string;
    business_id?: string;
    is_owner?: boolean;
    metadata?: any;
    name?: string;
    phone?: string;
    platform_account_id?: string;
    identification_number?: string;
    ssn_last4?: string;
    title?: string;
    updated_at?: string;
}
export declare class Owner implements Identity {
    address?: Address;
    created_at?: string;
    dob_day?: string;
    dob_month?: string;
    dob_year?: string;
    dob_full?: string;
    documents?: Document[];
    email?: string;
    id?: string;
    business_id?: string;
    is_owner?: boolean;
    metadata?: any;
    name?: string;
    phone?: string;
    platform_account_id?: string;
    identification_number?: string;
    ssn_last4?: string;
    title?: string;
    updated_at?: string;
    constructor(owner: Identity);
    get payload(): {
        address: {
            platform_account_id: string;
            line1: string;
            line2: string;
            postal_code: string;
            city: string;
            state: string;
            country: string;
        };
        dob_day: string;
        dob_month: string;
        dob_year: string;
        email: string;
        identification_number: string;
        is_owner: boolean;
        metadata: any;
        name: string;
        phone: string;
        platform_account_id: string;
        title: string;
    };
}
export declare class Representative implements Identity {
    address?: Address;
    created_at?: string;
    dob_day?: string;
    dob_month?: string;
    dob_year?: string;
    dob_full?: string;
    documents?: Document[];
    email?: string;
    id?: string;
    business_id?: string;
    is_owner?: boolean;
    metadata?: any;
    name?: string;
    phone?: string;
    platform_account_id?: string;
    identification_number?: string;
    ssn_last4?: string;
    title?: string;
    updated_at?: string;
    constructor(representative: Identity);
    get payload(): {
        address: {
            platform_account_id: string;
            line1: string;
            line2: string;
            postal_code: string;
            city: string;
            state: string;
            country: string;
        };
        dob_day: string;
        dob_month: string;
        dob_year: string;
        email: string;
        is_owner: boolean;
        identification_number: string;
        metadata: any;
        name: string;
        phone: string;
        platform_account_id: string;
        title: string;
    };
}
