import { CurrencyTypes } from "./Payment";
export declare enum PaymentBalanceTxnType {
    payment = "payment",
    paymentFee = "payment_fee",
    payout = "payout",
    refund = "refund",
    feeRefund = "fee_refund",
    dispute = "dispute",
    disputeFee = "dispute_fee",
    disputeFeeRefund = "dispute_fee_refund",
    disputeRefund = "dispute_refund",
    applicationFeeReturned = "application_fee_returned"
}
export interface IPaymentBalanceTransaction {
    id: string;
    amount: number;
    balance: number;
    currency: CurrencyTypes;
    financial_transaction_id: string;
    payment_id: string;
    payment_balance_txn_type: PaymentBalanceTxnType;
    source_id: string;
    source_type: string;
    created_at: string;
    updated_at: string;
}
export declare class PaymentBalanceTransaction implements IPaymentBalanceTransaction {
    id: string;
    amount: number;
    balance: number;
    currency: CurrencyTypes;
    financial_transaction_id: string;
    payment_id: string;
    payment_balance_txn_type: PaymentBalanceTxnType;
    source_id: string;
    source_type: string;
    created_at: string;
    updated_at: string;
    constructor(balanceTransaction: IPaymentBalanceTransaction);
    get displayTransactionId(): string;
    formattedPaymentAmount(amount: number): string;
}
