import { TerminalModelName } from "./TerminalModel";
export interface TerminalsQueryParams {
    terminal_id?: string;
    terminal_order_id?: string;
    status?: string;
}
export declare enum ITerminalStatus {
    connected = "connected",
    disconnected = "disconnected",
    unknown = "unknown",
    pending_configuration = "pending_configuration"
}
export interface ITerminal {
    id?: string | null;
    status?: ITerminalStatus;
    account_id?: string | null;
    platform_account_id?: string | null;
    gateway_ref_id?: string | null;
    provider?: TerminalProviders | null;
    provider_id?: string | null;
    provider_serial_number?: string | null;
    created_at?: string | null;
    updated_at?: string | null;
    verified_at?: string | null;
    nickname?: string | null;
    model_name?: TerminalModelName | null;
}
export declare enum TerminalProviders {
    verifone = "verifone"
}
export declare class Terminal implements ITerminal {
    id: string;
    status: ITerminalStatus;
    account_id: string;
    platform_account_id: string;
    provider: TerminalProviders;
    provider_id: string;
    provider_serial_number: string;
    created_at: string;
    updated_at: string;
    verified_at: string;
    nickname: string;
    sub_account_name: string;
    model_name: TerminalModelName;
    constructor(data: ITerminal);
}
