import { EventEmitter } from '../../../stencil-public-runtime';
import { BusinessFormServerErrors, IBusiness } from '../../../api/Business';
import JustifiAnalytics from '../../../api/Analytics';
import { ComponentClickEvent, ComponentErrorEvent, ComponentSubmitEvent } from '../../../api/ComponentEvents';
export declare class BusinessForm {
    isLoading: boolean;
    isSaving: boolean;
    errorMessage: BusinessFormServerErrors;
    authToken: string;
    businessId: string;
    hideErrors?: boolean;
    formTitle?: string;
    removeTitle?: boolean;
    submitEvent: EventEmitter<ComponentSubmitEvent>;
    clickEvent: EventEmitter<ComponentClickEvent>;
    errorEvent: EventEmitter<ComponentErrorEvent>;
    private getBusiness;
    private patchBusiness;
    analytics: JustifiAnalytics;
    componentWillLoad(): void;
    disconnectedCallback(): void;
    get title(): string;
    get disabledState(): boolean;
    get businessEndpoint(): string;
    private formController;
    instantiateBusiness: (data: IBusiness) => void;
    private initializeApi;
    private sendData;
    private validateAndSubmit;
    handleReponse(response: any): void;
    render(): any;
}
