import { EventEmitter } from '../../../../stencil-public-runtime';
import { FormController } from '../../../../ui-components/form/form';
import { IBankAccount, EntityDocument, EntityDocumentStorage, FileSelectEvent, ComponentErrorEvent, ComponentFormStepCompleteEvent } from '../../../../api';
export declare class BusinessBankAccountFormStepCore {
    formController: FormController;
    errors: any;
    bankAccount: IBankAccount;
    existingDocuments: any;
    documentData: EntityDocumentStorage;
    isLoading: boolean;
    businessId: string;
    getBusiness: Function;
    postBankAccount: Function;
    postDocumentRecord: Function;
    allowOptionalFields?: boolean;
    stepCompleteEvent: EventEmitter<ComponentFormStepCompleteEvent>;
    errorEvent: EventEmitter<ComponentErrorEvent>;
    formLoading: EventEmitter<boolean>;
    watchHandler(newValue: boolean): void;
    validateAndSubmit({ onSuccess }: {
        onSuccess: any;
    }): Promise<void>;
    componentWillLoad(): void;
    componentDidLoad(): void;
    initializeFormController: () => void;
    inputHandler: (name: string, value: string) => void;
    storeFiles: (e: CustomEvent<FileSelectEvent>) => void;
    get postPayload(): {
        account_owner_name: string;
        account_type: string;
        account_number: string;
        routing_number: string;
        bank_name: string;
        nickname: string;
        business_id: string;
    };
    get existingBankAccount(): boolean;
    private getData;
    private sendData;
    private postBankAccountData;
    private postBusinessDocuments;
    private postDocumentRecordData;
    handleDocRecordResponse: (docData: EntityDocument, response: any) => boolean;
    uploadDocument: (docData: EntityDocument) => Promise<boolean>;
    handleUploadResponse: (response: any) => boolean;
    render(): any;
}
