import { EventEmitter } from '../../../../stencil-public-runtime';
import { Identity } from '../../../../api/Identity';
import { FormController } from '../../../../ui-components/form/form';
import { ComponentErrorEvent, ComponentFormStepCompleteEvent } from '../../../../api/ComponentEvents';
export declare class BusinessRepresentativeFormStepCore {
    formController: FormController;
    errors: any;
    representative: Identity;
    isLoading: boolean;
    getBusiness: Function;
    patchBusiness: Function;
    allowOptionalFields?: boolean;
    stepCompleteEvent: EventEmitter<ComponentFormStepCompleteEvent>;
    errorEvent: EventEmitter<ComponentErrorEvent>;
    formLoading: EventEmitter<boolean>;
    validateAndSubmit({ onSuccess }: {
        onSuccess: any;
    }): Promise<void>;
    get patchPayload(): {
        representative: {
            address: {
                platform_account_id: string;
                line1: string;
                line2: string;
                postal_code: string;
                city: string;
                state: string;
                country: string;
            };
            dob_day: string;
            dob_month: string;
            dob_year: string;
            email: string;
            is_owner: boolean;
            identification_number: string;
            metadata: any;
            name: string;
            phone: string;
            platform_account_id: string;
            title: string;
        };
    };
    componentWillLoad(): void;
    componentDidLoad(): void;
    private getData;
    private sendData;
    render(): any;
}
