import { EventEmitter } from '../../../../stencil-public-runtime';
import { FormController } from '../../../../ui-components/form/form';
import { IAddress } from '../../../../api/Business';
import { ComponentErrorEvent, ComponentFormStepCompleteEvent } from '../../../../api/ComponentEvents';
export declare class LegalAddressFormStepCore {
    formController: FormController;
    errors: any;
    legal_address: IAddress;
    isLoading: boolean;
    getBusiness: Function;
    patchBusiness: Function;
    allowOptionalFields?: boolean;
    stepCompleteEvent: EventEmitter<ComponentFormStepCompleteEvent>;
    errorEvent: EventEmitter<ComponentErrorEvent>;
    formLoading: EventEmitter<boolean>;
    validateAndSubmit({ onSuccess }: {
        onSuccess: any;
    }): Promise<void>;
    get patchPayload(): {
        legal_address: {
            platform_account_id: string;
            line1: string;
            line2: string;
            postal_code: string;
            city: string;
            state: string;
            country: string;
        };
    };
    componentWillLoad(): void;
    componentDidLoad(): void;
    private getData;
    private sendData;
    inputHandler: (name: string, value: string) => void;
    render(): any;
}
