export declare const businessFormSchema: import("yup").ObjectSchema<{
    legal_address: {
        state?: string;
        line1?: string;
        line2?: string;
        city?: string;
        postal_code?: string;
        country?: string;
    };
    additional_questions: {
        business_recurring_payments?: string;
        business_revenue?: string;
        business_payment_volume?: string;
        business_when_service_received?: string;
        business_recurring_payments_percentage?: string;
        business_seasonal?: string;
        business_other_payment_details?: string;
    };
    representative: {
        address?: {
            state?: string;
            line1?: string;
            line2?: string;
            city?: string;
            postal_code?: string;
            country?: string;
        };
        title?: string;
        ssn_last4?: string;
        name?: string;
        email?: string;
        phone?: string;
        dob_full?: string;
        identification_number?: string;
    };
    legal_name: unknown;
    website_url: unknown;
    email: unknown;
    phone: unknown;
    doing_business_as: unknown;
    classification: unknown;
    industry: unknown;
    tax_id: unknown;
    date_of_incorporation: unknown;
}, import("yup").AnyObject, {
    legal_address: {
        line1: undefined;
        line2: undefined;
        city: undefined;
        state: undefined;
        postal_code: undefined;
        country: undefined;
    };
    additional_questions: {
        business_revenue: undefined;
        business_payment_volume: undefined;
        business_when_service_received: undefined;
        business_recurring_payments: undefined;
        business_recurring_payments_percentage: undefined;
        business_seasonal: undefined;
        business_other_payment_details: undefined;
    };
    representative: {
        name: undefined;
        title: undefined;
        email: undefined;
        phone: undefined;
        dob_full: undefined;
        ssn_last4: undefined;
        identification_number: undefined;
        address: {
            line1: undefined;
            line2: undefined;
            city: undefined;
            state: undefined;
            postal_code: undefined;
            country: undefined;
        };
    };
    legal_name: undefined;
    website_url: undefined;
    email: undefined;
    phone: undefined;
    doing_business_as: undefined;
    classification: undefined;
    industry: undefined;
    tax_id: undefined;
    date_of_incorporation: undefined;
}, "">;
