import { EventEmitter } from '../../stencil-public-runtime';
import JustifiAnalytics from '../../api/Analytics';
import { BillingFormFields } from './billing-form/billing-form-schema';
import { ICheckout, ILoadedEventResponse } from '../../api';
import { ComponentErrorEvent, ComponentSubmitEvent } from '../../api/ComponentEvents';
import { PaymentMethodOption } from './payment-method-option-utils';
export declare class Checkout {
    analytics: JustifiAnalytics;
    modularCheckoutRef?: HTMLJustifiModularCheckoutElement;
    selectedPaymentMethodOptionRef?: HTMLJustifiSavedPaymentMethodElement | HTMLJustifiSezzlePaymentMethodElement;
    checkout: ICheckout;
    complete: Function;
    errorMessage: string;
    insuranceToggled: boolean;
    isSubmitting: boolean;
    paymentMethodOptions: PaymentMethodOption[];
    savePaymentMethod: boolean;
    serverError: string;
    authToken: string;
    checkoutId: string;
    disableBankAccount?: boolean;
    disableBnpl?: boolean;
    disableCreditCard?: boolean;
    disablePaymentMethodGroup?: boolean;
    hideBankAccountBillingForm?: boolean;
    hideCardBillingForm?: boolean;
    propChanged(): void;
    errorEvent: EventEmitter<ComponentErrorEvent>;
    loadedEvent: EventEmitter<ILoadedEventResponse>;
    submitEvent: EventEmitter<ComponentSubmitEvent>;
    connectedCallback(): void;
    componentWillLoad(): void;
    disconnectedCallback(): void;
    savePaymentMethodChanged(event: CustomEvent<boolean>): void;
    checkoutComplete(_event: CustomEvent<any>): void;
    checkoutError(event: CustomEvent<any>): void;
    paymentMethodOptionSelected(event: CustomEvent<PaymentMethodOption>): void;
    fillBillingForm(fields: BillingFormFields): Promise<void>;
    validate(): Promise<{
        isValid: boolean;
    }>;
    private updateStore;
    private submit;
    private get canSavePaymentMethod();
    private get showBillingForm();
    private get showBillingFormSection();
    private get showPaymentTypeHeader();
    private get showPostalCodeForm();
    render(): any;
}
