import { EventEmitter } from "../../stencil-public-runtime";
import JustifiAnalytics from "../../api/Analytics";
import { ComponentErrorCodes, ComponentErrorSeverity } from '../../api/ComponentError';
import { TerminalModel, ComponentErrorEvent } from "../../api";
import { Business } from "../../api/Business";
import { TerminalOrder } from "../../api/TerminalOrder";
export declare class OrderTerminals {
    businessId: string;
    authToken: string;
    accountId: string;
    shipping: boolean;
    submitButtonText: string;
    loading: {
        business: boolean;
        terminals: boolean;
    };
    submitting: boolean;
    error: {
        message: string;
        code?: ComponentErrorCodes;
        severity?: ComponentErrorSeverity;
    } | null;
    business: Business;
    terminalModels: TerminalModel[];
    orderLimit: number;
    order: TerminalOrder;
    totalQuantity: number;
    analytics: JustifiAnalytics;
    errorEvent: EventEmitter<ComponentErrorEvent>;
    submitted: EventEmitter<any>;
    componentWillLoad(): void;
    disconnectedCallback(): void;
    private handleError;
    private loadData;
    private initializeGetBusiness;
    private initializeGetTerminalModels;
    private submitOrder;
    private onSelectedQuantityChange;
    private renderLoading;
    private renderBusinessDetails;
    private renderTerminals;
    private renderOrderSection;
    render(): any;
}
