import { EventEmitter } from '../../stencil-public-runtime';
import { PagingInfo, Payout, SubAccount } from '../../api';
import { Table } from '../../utils/table';
import { ComponentClickEvent, ComponentErrorEvent } from '../../api/ComponentEvents';
export declare class PayoutsListCore {
    getPayouts: Function;
    getSubAccounts: Function;
    getPayoutCSV: Function;
    columns: string;
    payouts: Payout[];
    payoutsTable: Table<Payout>;
    subAccounts: SubAccount[];
    loading: boolean;
    errorMessage: string;
    paging: PagingInfo;
    pagingParams: any;
    updateOnPropChange(): void;
    clickEvent: EventEmitter<ComponentClickEvent>;
    errorEvent: EventEmitter<ComponentErrorEvent>;
    componentWillLoad(): void;
    fetchData(): void;
    fetchSubAccounts(): Promise<void>;
    downloadCSV: (payoutId: string) => void;
    handleClickPrevious: (beforeCursor: string) => void;
    handleClickNext: (afterCursor: string) => void;
    rowClickHandler: (e: any) => void;
    get payoutParams(): any;
    get subAccountParams(): {
        sub_account_id: string;
    };
    get entityId(): string[];
    get showEmptyState(): boolean;
    get showErrorState(): boolean;
    get showRowData(): boolean;
    render(): any;
}
