import { EventEmitter } from '../../stencil-public-runtime';
import { ComponentErrorEvent, ComponentSubmitEvent, IRefund, IRefundPayload } from '../../api';
import { FormController } from '../../ui-components/form/form';
import JustifiAnalytics from '../../api/Analytics';
export declare class RefundPayment {
    formController: FormController;
    refundPayload: IRefundPayload;
    displayAmount: string;
    errors: any;
    paymentLoading: boolean;
    refundLoading: boolean;
    submitDisabled: boolean;
    authToken: string;
    accountId: string;
    paymentId: string;
    hideSubmitButton?: boolean;
    errorEvent: EventEmitter<ComponentErrorEvent>;
    submitEvent: EventEmitter<ComponentSubmitEvent>;
    analytics: JustifiAnalytics;
    componentWillLoad(): void;
    private handleError;
    private checkAmount;
    private handleInvalidAmount;
    private initializeFormController;
    inputHandler: (name: string, value: string) => void;
    private initializeApi;
    refundPayment(event?: CustomEvent): Promise<IRefund>;
    render(): any;
}
