import { EventEmitter } from '../../stencil-public-runtime';
import { PagingInfo, SubAccount, Terminal } from '../../api';
import { Table } from '../../utils/table';
import { ComponentClickEvent, ComponentErrorEvent } from '../../api/ComponentEvents';
export declare class TerminalsListCore {
    getTerminals: Function;
    getSubAccounts: Function;
    columns: string;
    terminals: Terminal[];
    terminalsTable: Table<Terminal>;
    subAccounts: SubAccount[];
    loading: boolean;
    errorMessage: string;
    paging: PagingInfo;
    pagingParams: any;
    updateOnPropChange(): void;
    clickEvent: EventEmitter<ComponentClickEvent>;
    errorEvent: EventEmitter<ComponentErrorEvent>;
    componentWillLoad(): void;
    fetchData(): void;
    fetchSubAccounts(): Promise<void>;
    handleClickPrevious: (beforeCursor: string) => void;
    handleClickNext: (afterCursor: string) => void;
    rowClickHandler: (e: any) => void;
    get terminalParams(): any;
    get subAccountParams(): {
        sub_account_id: string;
    };
    get entityId(): string[];
    get showEmptyState(): boolean;
    get showErrorState(): boolean;
    get showRowData(): boolean;
    render(): any;
}
