import { EventEmitter } from '../../stencil-public-runtime';
import JustifiAnalytics from '../../api/Analytics';
import { BillingFormFields } from '../../components';
import { PaymentMethodPayload } from '../checkout/payment-method-payload';
import { ComponentSubmitEvent, ComponentErrorEvent } from '../../api';
interface ValidationResult {
    isValid: boolean;
    errors?: Record<string, any>;
}
export declare class TokenizePaymentMethod {
    analytics: JustifiAnalytics;
    private billingFormRef?;
    private paymentMethodFormRef?;
    isLoading: boolean;
    selectedPaymentMethodId: string;
    saveNewPaymentMethodChecked: boolean;
    accountId?: string;
    authToken?: string;
    disableBankAccount?: boolean;
    disableCreditCard?: boolean;
    hideBankAccountBillingForm?: boolean;
    hideCardBillingForm?: boolean;
    hideSubmitButton?: boolean;
    paymentMethodGroupId: string;
    submitButtonText: string;
    errorEvent: EventEmitter<ComponentErrorEvent>;
    submitEvent: EventEmitter<ComponentSubmitEvent>;
    componentWillLoad(): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    paymentMethodsChanged(): void;
    handleRadioClick(event: CustomEvent<string>): void;
    handleCheckboxChanged(event: CustomEvent<boolean>): void;
    fillBillingForm(fields: BillingFormFields): Promise<void>;
    tokenizePaymentMethod(event?: MouseEvent): Promise<PaymentMethodPayload>;
    validate(): Promise<ValidationResult>;
    private validateRequiredProps;
    private setDefaultSelectedPaymentMethod;
    private get availablePaymentMethods();
    private areFormsReady;
    private emitError;
    private createErrorResponse;
    resolvePaymentMethod(insuranceValidation: any): Promise<PaymentMethodPayload>;
    private performTokenization;
    private tokenize;
    private buildPaymentMethodMetadata;
    private get shouldHideRadioInput();
    private renderPaymentMethodOption;
    private renderSelectedPaymentMethodForm;
    private renderPaymentMethodForm;
    render(): any;
}
export {};
