
<p align="center">
  <a href="https://justifi.tech/" rel="noopener" target="_blank"><img width="150" height="133" src="https://justifi.tech/wp-content/uploads/2022/07/Light-BG-1.svg" alt="JustiFi logo"></a>
</p>

<h1 align="center">JustiFi Web Components</h1>

The JustiFi web component library is an ever-expanding repository of customizable, white-labeled fintech components. From Payment Forms and Tables/Lists to Charts and Onboarding Forms, this diverse collection is designed to empower our clients to seamlessly integrate crucial elements of their financial infrastructure into existing dashboards and software solutions.


## Installation

The best method for including the JustiFi web components in your application is via npm:

`npm install @justifi/webcomponents`


## Documentation

Visit [https://storybook.justifi.ai/?path=/docs/introduction--docs](https://storybook.justifi.ai/?path=/docs/introduction--docs) to view the full documentation.


## Examples

Our documentation features examples of rendered components. 

- [Payment Form](https://storybook.justifi.ai/?path=/story/components-paymentform--basic)
- [Payments List](https://storybook.justifi.ai/?path=/docs/components-paymentslist--docs)
- [Payment Detail](https://storybook.justifi.ai/?path=/docs/components-paymentdetails--docs)

Visit our [documentation home page](https://storybook.justifi.ai/?path=/docs/introduction--docs) to view examples of all available components.


## Questions and Issues

In order to best respond to questions and issues, we ask that users utilize the [Issue Section](https://github.com/justifi-tech/web-component-library/issues/new/choose) in the project's Github repo. 


## Contributing

Read the [contributing guide](https://github.com/justifi-tech/web-component-library/blob/main/CONTRIBUTING.md) to learn about our development process, how to propose bug fixes and improvements, and how to build and test your changes.


## Changelog

The [changelog](https://github.com/justifi-tech/web-component-library/blob/main/packages/webcomponents/CHANGELOG.md) is regularly updated to reflect what's changed in each new release.
